;---------------------------------------------------
;ARROWS
;---------------------------------------------------

firearrow:
  ; CHECK IF WE HAVE ARROWS
  ;ld a,(player_arrows)
  ld b,1
  call checkplayerinvrand
  or a;cp 0
  ret z ; WE HAVE NO ARROWS LEFT
  ;dec a ; DECREASE ARROW COUNT
  ;ld (player_arrows),a

  ; ONLY FIRE ARROW IF WE HAVE BOW
  ld a,(hasbow)
  or a
  ret z

  ld b,1
  call remplayerinvrand ; REMOVE ARROW FROM RANDOM INVENTORY LIST
  ;nop

  ld hl,mcparrowdata
  ld (hl),3               ; ACTIVATE AS ARROW SPRITE
  ld de,mcparrowdata+3
  ld hl,playerspritedata+3
  ; COPY LOCATION DATA FROM ONE SPRITE TO ANOTHER
  ; COPY IN BUILDING
  ; COPY X MAP COORD
  ; COPY Y MAP COORD
  ; COPY X BYTE COORD
  ; COPY Y LINE COORD
  ; COPY CURRENT DIRECTION OF PLAYER
  ld bc,6 
  ldir    
  ld hl,mcparrowdata+10
  ld (hl),anim_arrowleft ; INITIAL IMAGE LEFT
  inc hl
  ld (hl),anim_arrowdown ; INITIAL IMAGE DOWN
  inc hl
  ld (hl),anim_arrowup   ; INITIAL IMAGE UP
  ld hl,mcparrowdata+24
  ld (hl),3              ; MOVE IN STRAIGHT LINE
  inc hl
  inc hl
  ld (hl),1              ; SPRITE ID FOR OBJECT COLLISION DETECTION
  inc hl
  ld (hl),3              ; SPRITE TYPE FOR OBJECT COLLISION DETECTION   

  call updatestatusbarmoney ; UPDATE NUMBER OF ARROWS
  ret

;disablearrow:
;  ld (ix+0),0 ; DEACTIVATE
;  ld (ix+15),0 ; DEACTIVATE SPRITE - DON'T RESTORE BUFF
;ret

;---------------------------------------------------
;OBJECT COLLISION
;---------------------------------------------------

; CHECK IF POINT IS IN HIT BOX
; IN 4 BYTES X
; IN 8 LINES Y
; INPUTS
; D = X BYTE
; E = Y LINE
; A = X BYTE 2
; C = Y LINE 2
; OUTPUT
; A = 0 NO HIT, 1 HIT, 2 GRAZE
checkinhitbox:
  ; CHECK X HIT BOX
  ld hl,hitboxtablex
  sub d
  ld l,a
  ld a,(hl)
  or a;cp 0
  ret z
  ; CHECK Y HIT BOX
  ld hl,hitboxtabley
  ld a,c
  sub e
  ld l,a
  ld a,(hl)
  ret

; INPUTS
; IX = CURRENT SPRITE BLOCK
; D = X POS OF OUR SPRITE
; E = Y POS OF OUR SPRITE
checkcollisionsprite:
  ld iy,mcps
  checkcollisionspriteloop:
    ld a,(iy+0)                   
    cp 255                        ; END OF LIST
    jp z,returnfalse
    or a;cp 0                          ; INACTIVE SKIP
    jr z,nextcheckcollisionsprite

    ld a,(iy+27)                  ; SKIP IF WE ARE CHECKING OURSELVES
    cp (ix+27)
    jr z,nextcheckcollisionsprite
    ld a,(iy+4)                   ; SKIP IF NOT IN SAME X SCREEN
    cp (ix+4)
    jr nz,nextcheckcollisionsprite
    ld a,(iy+5)                   ; SKIP IF NOT IN SAME Y SCREEN
    cp (ix+5)
    jr nz,nextcheckcollisionsprite
    ld a,(iy+3)                   ; SKIP IF NOT IN BUILDING
    cp (ix+3)
    jr nz,nextcheckcollisionsprite

    ; GET X POS OF SPRITE TO CHECK
    ld a,(iy+7)   ; GET Y POS FROM OTHER SPRITE
    add 8         ; MOVE COL DETECTION TO MIDDLE OF SPRITE
    ld c,a
    ld a,(iy+6)   ; GET X POS FROM OTHER SPRITE
    add 2         ; MOVE COL DETECTION TO MIDDLE OF SPRITE

    call checkinhitbox
    or a;cp 0            
    jr z,nextcheckcollisionsprite   ; NO COLLISION, JUST RETURN
    cp 1                            ; COLLISION - CHECK IF ONE OBJECT IS ARROW
    jr z,checkkill                  ; COLLISION - CHECK IF ONE OBJECT IS ARROW
    cp 2                            ; GRAZE - FORCE OTHER SPRITE TO REDRAW
    jr z,checkgraze

;arrowsound:
;  call doorknock
;  jp returnfalse

nextcheckcollisionsprite:
  ld bc,28
  add iy,bc
  jr checkcollisionspriteloop

; PREVENT SPRITE FROM COMING TO CLOSE TO ANOTHER SPRITE TO
; STOP SCREEN CORRUPTION, UNLESS IT IS AN OBJECT TO PICK UP
; OR AN ARROW SPRITE THAT NEEDS TO MAKE CONTACT WITH THE SPRITE
checkgraze:
  ld a,(ix+27)
  cp 3                        ; IF ARROW ALLOW ARROW TO GRAZE ANYTHING
  jp z,returnfalse
  or a;cp 0                        ; IF PLAYER
  jr z,checkgrazeplayerandobj
  cp 2                        ; IF ANIMAL
  jr z,checkgrazeanimalandobj
  jp returntrue               ; DO NOT ALLOW PASS THROUGH

checkgrazeplayerandobj:
    ld a,(iy+27)  
    cp 3                  
    jp z,returnfalse       ; OWN ARROW COLLIDED WITH PLAYER 
    cp 4                  
    jp z,pickupobj         ; PLAYER COLLIDED WITH PICKABLE OBJECT
    cp 2                   ; PICKUP OBJECT ON GRAZE PREVENTS GRAPHICS CORRUPTION
    jp z,chaserabbit       ; MAKE RABBIT RUN FROM PLAYER
    jp returntrue          ; DO NOT ALLOW TO PASS THROUGH

checkgrazeanimalandobj:
    ld a,(iy+27)  
    cp 3                  
    jp z,returnfalse       ; ANIMAL COLLIDED WITH ARROW 
    jp returntrue          ; DO NOT ALLOW TO PASS THROUGH

; CHECK IF WE NEED TO KILL ANIMAL AFTER COLLISION
; INPUTS 
; IX = MOVING SPRITE
; IY = COLLISION SPRITE
; RESULTS
; A = 0 NO COLLISION, 1 = COLLISION

; OBJECT TYPES
; 0 = PLAYER
; 1 = GAME CHARACTER
; 2 = ANIMAL THAT CAN BE KILLED
; 3 = ARROW PLAYER
; 4 = PICKABLE OBJECT - MEAT
; 5 = OBSCTRUCTION THAT CAN'T BE KILLED

checkkill:
  ld a,(ix+27)
  cp 3 ; IF HIT ARROW
  jr z,checkarrowandobj
  or a;cp 0 ; IF HIT PLAYER
  jr z,checkplayerandobj
  cp 1 ; IF HIT PERSON
  jr z,checkpersonandobj
  cp 2 ; IF HIT ANIMAL
  jr z,checkrabbitandobj
  ; IF HIT ANY OTHER SPRITE
  jp returnfalse

  checkarrowandobj:
    ld a,(iy+27)  
    cp 1  
    jp z,killboth          ; ARROW COLLIDED WITH PERSON
    cp 2
    jr z,turnrabbittofood  ; ARROW COLLIDED WITH RABBIT    
    jp returnfalse         ; ALLOW TO PASS THROUGH
 
  checkplayerandobj:
    ld a,(iy+27)
    cp 3
    jp z,returnfalse       ; PLAYER COLLIDED WITH OWN ARROW, ALLOW PASS THROUGH
    cp 4
    jr z,pickupobj         ; WE FOUND AN OBJECT TO PICK UP
    jp returntrue          ; COLLIDED WITH OBSTACLE      

  checkpersonandobj:
    ld a,(iy+27)
    cp 3
    jp z,killboth          ; PERSON COLLIDED WITH ARROW
    jp returntrue          ; COLLIDED WITH OBSTACLE        

  checkrabbitandobj:
    ld a,(iy+27)
    cp 3
    jr z,killboth          ; RABBIT COLLIDED WITH ARROW
    jp returntrue          ; COLLIDED WITH OBSTACLE      

killboth:
  call deactivatesprite    ; KILL RABBIT
  call deactivatespriteiy  ; DISABLE ARROW
  jp returnfalse

turnrabbittofood:
  ld (iy+8),0                   ; SET RABBIT DIRECTION TO STATIONARY
  ld (iy+24),3                  ; SET MOVEMENT TO STRAIGHT
  ld (iy+18),rabbitmeat          ; SET OBJECT ID TO MEAT 
  ld (iy+27),4                  ; SET OBJECT TYPE TO PICKUPABLE OBJECT
  ld (iy+20),1                  ; SET TO REDRAW NEW IMAGE

  call deactivatesprite         ; DISABLE ARROW
  jp returnfalse

chaserabbit:
  ld a,(ix+8)                   ; SET DIRECTION TO SAME AS PLAYER TO RUN AWAY
  ld (iy+8),a
  ld (iy+20),1                  ; MARK THAT WE HAVE MOVED
  jp returntrue                 ; DO NOT ALLOW TO PASS
  
;pickupobj:
;  ;ld a,(iy+1)                  ; GET OBJECT TYPE FROM IMAGE ID
;  ld a,(iy+18)                  ; GET OBJECT TYPE 
;  cp 37                         ; WE GOT FOOD
;  jr z,pickupfood
;  jp returnfalse
  
pickupobj:
  ld b,(iy+18);                 ; GET TILE GRAPHIC ID
  call pickupspriteobject
  or a;cp 0                          ; WE HAVENT ROOM FOR ANY MORE OBJECTS
  jp z,returnfalse
  call restoremybufferiy        ; CLEAR SPRITE FROM SCREEN
  call deactivatespriteiy       ; DISABLE MEAT
  jp returnfalse