

; DEFAULT VALUES FOR INITIAL POSITION
initialposx     equ 10
initialposy     equ 80
initialmapx     equ 49;1;16;46;7;1;49;46;49;53;8;1;53;97;1;53;1;08;50;7;1;22;46;23;1;1;8;1 ;46
initialmapy     equ 27;1;56;35; 83;1;27;35;27;38;46;1;38;1;47;88;83; 1;22;35;49;1;1;47;1 ;35
initialposbuild equ 0 ; IN BUILDING TYPE = 0 = NO, 1 = YES
initialworldmap equ 1 ; HAS MAP
;initialarrows   equ 99

; MAKE TABLES AT START OF MEMORY, BLOCKS OF 256 BYTES EACH
; THIS MAKES MORE SPACE FOR GAME AND SAVES LOADING TIME
; AS THEY DO NOT HAVE TO BE SAVED TO DISC
; VARIABLES ARE ORGANIZED SO THAT THEY LINK TOGETHER IN A CHAIN
; THIS MEANS THEY CAN BE MOVED AROUND EASILY AS NEEDED
letters_ptr_table  equ &0040 ; SIZE 59*2
; DATA AREAS WITH 256 BOUNDARIES
tilemap0           equ &0100             ; SIZE 256
tilemap1           equ tilemap0+256      ; SIZE 256
tilemap2           equ tilemap1+256      ; SIZE 256
endoftilemaps      equ tilemap2+255      ; SIZE 0
mask_table         equ tilemap2+256      ; SIZE 256

hitboxtablex       equ mask_table+256    ; SIZE 256 BYTES 
hitboxtabley       equ hitboxtablex+256  ; SIZE 256 BYTES
tilecalchoriz      equ hitboxtabley+256  ; SIZE 80 BYTES - WIDTH OF SCREEN - START ON BYTE BOUNDARY
tilecalcvert       equ tilecalchoriz+256 ; SIZE 200 BYTES - HEIGHT OF SCREEN - START ON BYTE BOUNDARY
tiletablex         equ tilecalcvert+256  ; SIZE 20 BYTES - WIDTH OF SCREEN - START ON BYTE BOUNDARY
tiletabley         equ tiletablex+256    ; SIZE 10 BYTES - HEIGHT OF SCREEN - START ON BYTE BOUNDARY
;tile_ptr_table     equ tiletabley+256    ; SIZE NUM OF TILES (MAX 256) * 2

; GAME MAP IS BASED ON THE FULL MAP IN 10s RESOLUTION
; THIS ENABLES US TO CREATE A NATURAL LOOKING MAP WITH SEAS
; A BYTE REPRESENTS A BLOCK OF TEN SCREENS
; 0 = LAND
; 1 = SEA
; 2 = LAND/SEA ETC
gamemap3           equ tiletabley+256    ; 10x10 = 100 BYTES
gamemap2           equ gamemap3+256          ; 10x10 = 100 BYTES
endofgamemap       equ gamemap2+255          ; POINTER TO END OF GAME MAP DATA
scr_addr_table     equ gamemap2+256          ; SIZE 200 * 2
  ; THIS GAP BETWEEN 400 SCREEN ADDRESS TABLE AND 512 RABBIT BUFF FILLED WITH USER VARIABLES
 
  ;; indicates screen id has changed and screen needs redraw
  tilemap_changed    equ scr_addr_table+400  ; SIZE 1 BYTE 
  viewmap            equ tilemap_changed+1   ; SIZE 1 BYTE
  ; PLAYER INVENTORY DATA
  player_cash2        equ viewmap+1 ; SIZE 2 BYTES
  ;; current screen id
  ;; X,Y
  tilemap_cur        equ player_cash2+2        ; SIZE 1 BYTE 
  tilemap_cury       equ tilemap_cur+1        ; SIZE 1 BYTE
  currscreendata     equ tilemap_cury+1       ; SIZE 1 BYTE - LANDSCAPE TYPE - 0 = PLAINS, 1 = FOREST, 2 = INDIAN, 3, WESTERN
  currzonedata       equ currscreendata+1     ; SIZE 1 BYTE - LANDSCAPE TYPE - 0 = PLAINS, 1 = FOREST, 2 = INDIAN, 3, WESTERN
  currscreendata2    equ currzonedata+1       ; SIZE 1 BYTE - LANDSCAPE TYPE - 0 = EMPTY, 1 = SEA, 2 = BLAH
  currblockid        equ currscreendata2+1    ; SIZE 1 BYTE - CURRENT WORLD MAP LOCATION BLOCK NUM
  lastblockid        equ currblockid+1        ; SIZE 1 BYTE - LAST WORLD MAP LOCATION
  currscreenid       equ lastblockid+1        ; SIZE 1 BYTE - CURRENT LOCAL MAP LOCATION BLOCK NUM
  localscreenx       equ currscreenid+1       ; SIZE 1 BYTE - CURRENT LOCAL MAP LOCATION X
  localscreeny       equ localscreenx+1       ; SIZE 1 BYTE - CURRENT LOCAL MAP LOCATION Y
  inbuilding         equ localscreeny+1       ; SIZE 1 BYTE - IN BUILDING - 0 = NO, 1 = LOG CABIN
  tilemap_name       equ inbuilding+1         ; SIZE 7 BYTES 000_000 - ENDS IN 255
  tilemap_name3      equ tilemap_name+8       ; SIZE 7 BYTES $000000 - ENDS IN 255
  ;player_arrows      equ tilemap_name2+8      ; SIZE 1 BYTE
  key_pressed        equ tilemap_name3+8      ; SIZE 8 BITS - USED BY KEYBOARD ROUTINE TO CHECK IF KEY IS HELD DOWN
  doublebufferfree   equ key_pressed+1        ; SIZE 8 BITS - KEEP A NOTE OF WHAT DOUBLE BUFFERS ARE FREE
  haslocalmap        equ doublebufferfree+1   ; SIZE 8 BITS - DO WE HAVE MAP IN POSSESSION?
  hasworldmap        equ haslocalmap+1        ; SIZE 8 BITS - DO WE HAVE MAP IN POSSESSION?
  hasbow             equ hasworldmap + 1      ; SIZE 8 BITS - DO WE HAVE BOW IN POSSESSION?
  str_temp           equ hasbow + 1           ; SIZE 28 + EOL (END IN 255)
  screentext4        equ str_temp + 29        ; SIZE 28 + EOL (END IN 255)
  byte_temp          equ screentext4 + 29     ; SIZE 1 BYTE - TEMPORARY REUSABLE VARIABLE
  ; NEED OVERRUN BUFFER FOR WORDWRAP HERE
  ; 108 BYTES SO FAR


; ALIGN ON 256 BYTE BOUNDARY
rabbitbuff         equ scr_addr_table+512 ; SIZE 64 BYTES
rabbitbuff2        equ rabbitbuff+64      ; SIZE 64 BYTES
rabbitbuff3        equ rabbitbuff2+64     ; SIZE 64 BYTES
rabbitbuff4        equ rabbitbuff3+64     ; SIZE 64 BYTES
rabbitbuff5        equ rabbitbuff4+64     ; SIZE 64 BYTES
rabbitbuff6        equ rabbitbuff5+64     ; SIZE 64 BYTES
rabbitbuff7        equ rabbitbuff6+64     ; SIZE 64 BYTES
spriteidlist       equ rabbitbuff7+64     ; SIZE 7 BYTES

quest_data_random  equ spriteidlist+7 ; SIZE 11 BYTES * 5 QUESTS = 56 BYTES (END IN 255)
;  ; RANDOM QUEST BLOCK
;  ; DESTINATION SPRITE DATA
;  defb 0                 ; 0 ACTIVE
;  defb 0                 ; 1 X MAP SCREEN DEST
;  defb 0                 ; 2 Y MAP SCREEN DEST
;  defb 0                 ; 3 IN BUILDING DEST
;  defb 0                 ; 4 X TILE LOCATION DEST
;  defw 0                 ; 56 PTR TO SPRITE DATA DEST
;  defb 0                 ; 7 ITEM REWARD
;  defb 0                 ; 8 ITEM SOUGHT
;  defb 0                 ; 9 QUEST STATUS 0 = LOCKED, 1 = ACCEPTED, 2 = COMPLETE
;  defb 0                 ; 10 ROOM ID
animtiles equ quest_data_random+56 ; SIZE 5 BYTES * 3 TILES = 15 BYTES (END IN 255)
;  defb 0    ; ACTIVE - 0 = NO, 1 = YES
;  defb 0    ; CURRENT SPRITE ANIM OFFSET
;  defb 0    ; LOWER SPRITE ID FROM ANIM TABLE
;  defb 0    ; IS FLIPPED?
;  defb 0    ; TILE NUMBER

player_inventory        equ animtiles+16              ; SIZE 10 BYTES ENDS IN 255 - ITEM ID, QTY, ITEM ID, QTY  
player_inventory_rand   equ player_inventory+11       ; SIZE 10 BYTES ENDS IN 255 - ITEM ID, QTY, ITEM ID, QTY  
currinventoryitem       equ player_inventory_rand+11  ; SIZE 1 BYTE
totinventoryitems       equ currinventoryitem+1       ; SIZE 1 BYTE

currlineptr             equ totinventoryitems + 1     ; SIZE 2 BYTES LOOKUP FOR MAZE ROUTINE
lastlineptr             equ currlineptr + 2           ; SIZE 2 BYTES LOOKUP FOR MAZE ROUTINE
 
mcparrowdata            equ lastlineptr+2             ; SIZE 28 - ENDS IN 255
mcps                    equ mcparrowdata+29           ; LIST OF SPRITE DEFINITIONS - SIZE 28 BYTES * 6 + 255
playerspritedata        equ mcps                      ; FIRST SPRITE DEFINITION IN LIST

; SET STRUCTURE OF INITIAL VARIABLES
initiatevars:
  ; ERASE LOADER MEMORY
  ld hl,&1100
  xor a
  ld b,255
  call fillloop5
  
  ;ld hl,playerspritedata+170
  ;ld (hl),"Z"
  ; INSERT END OF STRING MARKER AT END OF BLOCKS OF ALLOCATED STRINGS
  ld hl,screentext4
  ld a," "
  ld b,28
  call fillloop5

  ld a,"$"
  ld (tilemap_name3),a
  ld a,255                          ; END OF BLOCK MARKER
  ld (player_cash2),a


  ld (str_temp+28),a
  ld (screentext4+28),a
  ld (quest_data_random+55),a
  ld (animtiles+15),a
  ld (player_inventory+10),a
  ld (player_inventory_rand+10),a
  ld (mcparrowdata+28),a
  ld (tilemap_name+7),a
  ld (tilemap_name3+7),a 
  ld (mcps+28+28+28+28+28+28),a     ; FIVE SPRITES AND ONE PLAYER AND ARROW
  ld (mcps+28+28+28+28+28+28+1),a   ; FIVE SPRITES AND ONE PLAYER AND ARROW
  ;ld (spriteidlist+6),a            ; SET END OF SPRITE ID LIST
  
  ;ld a,1
  ld a,1
  ld (spriteidlist),a   ; SET FIRST SPRITE BUFFER USED BY PLAYER
  ld (spriteidlist+1),a ; SET SECOND SPRITE BUFFER USED BY ARROW

  ; SET INITIAL PLAYER SPRITE POSITIONS
  ld ix,playerspritedata
  ld (ix+0),2   ; PLAYER

  ld a,initialworldmap
  ld (hasworldmap),a
  ld a,initialposbuild
  ld (ix+3),a          ; IN BUILDING
  ld (inbuilding),a
  ld a,initialmapx
  ld (tilemap_cur),a
  ld (ix+4),a          ; X MAP START POS
  ld a,initialmapy
  ld (tilemap_cury),a
  ld (ix+5),a          ; Y MAP START POS

  ld a,initialposx
  ld (ix+6),a;36  ; X BYTE POS
  ld a,initialposy
  ld (ix+7),a;32  ; Y LINE POS
  ld (ix+10),0  ; SPRITE LEFT IMAGE
  ld (ix+11),4  ; SPRITE DOWN IMAGE
  ld (ix+12),6  ; SPRITE UP IMAGE
  ; LOAD INVENTORY
  ;ld a,initialarrows
  ;ld (player_arrows),a

  ; GENERATE TILE CALC TABLES - ON BYTE BOUNDARY
  ; CONVERTS BYTE POSITION TO TILE COLUMN
  ld hl,tilecalchoriz
  ld de,tilecalchoriz+1
  ld b,20
  ld a,0
  tilecalcloop:
    push bc
    ld (hl),a
    ld bc,4
    ldir
    pop bc
    inc a
  djnz tilecalcloop

  ; CONVERTS LINE POSITION PIXEL TO TILE ROW
  ld hl,tilecalcvert
  ld de,tilecalcvert+1
  ld b,10
  ld a,0
  tilecalcloop2:
    push bc
    ld (hl),a
    ld bc,16
    ldir
    inc a
    pop bc
  djnz tilecalcloop2

  ; CONVERTS TILE NUMBER POSITION TO HORIZONTAL BYTE
  ld hl,tiletablex
  ld b,20
  ld a,0
  tilecalcloop2x:
    ld (hl),a
    inc hl
    add 4
  djnz tilecalcloop2x

  ; CONVERTS TILE NUMBER POSITION TO VERTICAL PIXEL
  ld hl,tiletabley
  ld b,10
  ld a,0
  tilecalcloop2y:
    ld (hl),a
    inc hl
    add 16
  djnz tilecalcloop2y

  ; HIT BOX TABLES
  ; SPECIFIES NUMBER OF BYTES/LINES BETWEEN TWO POINTS IN WHICH A HIT IS RECORDED
  ; 0 IS CENTRE OF TWO SPRITES
  ; EITHER SIDE OF THAT WITHIN A CERTAIN RANGE IS CONSIDERED A HIT
  ld a,1
  ld (hitboxtablex+0),a
  ld (hitboxtablex+1),a
  ld (hitboxtablex+2),a
  ld (hitboxtablex+255),a

  ld hl,hitboxtabley+0
  ld b,7
  call fillloop5

  ld hl,hitboxtabley+250
  ld b,6
  call fillloop5

  ; SET UP GRAZE AREA OF SPRITE
  ; FILL hitboxtabley-20 TO hitboxtabley+10 WITH 2
  ld a,2
  ld (hitboxtablex+3),a
  ld (hitboxtablex+254),a

  ld hl,hitboxtabley+235
  ld b,15
  call fillloop5
  ld hl,hitboxtabley+7
  ld b,4
  call fillloop5
  ;ld (hitboxtabley+7),a
  ;ld (hitboxtabley+8),a
  ;ld (hitboxtabley+9),a
  ;ld (hitboxtabley+10),a

  ; BUILD MAIN GAME MAP
  call genscreenname   ; NEED SCREEN COORDS FOR GENERATING PSEUDO RANDOM DATA
  call getcurrworldmap
  call getcurrlocalmap
  call genlocalgamemap ; PSEUDO RANDOM GENERATE LOCAL MAP
ret

; INPUTS
; B = NUMBER OF BYTES TO FILL
; A = VALUE TO FILL
; HL = MEMORY ADDRESS TO START AT
fillloop5:
  ld (hl),a
  inc hl
  djnz fillloop5
ret

  ; MCP DATA STRUCTURE
  ; RABBIT
  ;defb 0  ; 0 - STATUS 0 - INACTIVE, 1 - ACTIVE, 2 - PLAYER
  ;defb 0  ; 1 - CURRENT SPRITE IMAGE NUMBER TO DISPLAY
  ;defb 0  ; 2 - ZONE SPRITE IS ACTIVE IN - NOT USED
  ;defb 0  ; 3 - IN BUILDING
  ;defb 0  ; 4 - MAP X POS
  ;defb 0  ; 5 - MAP Y POS
  ;defb 0  ; 6 - CURR X BYTE POS
  ;defb 0  ; 7 - CURR Y LINE POS - INCREMENTS OF 4
  ;defb 0  ; 8 - CURR DIRECTION 0 - NOTHING, 1 - NORTH, 2 - NE, 3 - EAST
  ;defb 0  ; 9 - MOVE COUNTER BETWEEN TILES, 0-3, 0 MEANS WE HAVE ARRIVED
  
  ; SPRITE IMAGES ARE INCREMENTED EACH TIME IT IS DRAWN TO THE SCREEN
  ; THESE NUMBERS ARE THE FIRST IMAGE IN THE CYCLE

  ;defb 0  ; 10 - SPRITE LEFT IMAGE 1
  ;defb 0  ; 11 - SPRITE UP IMAGE 1
  ;defb 0  ; 12 - SPRITE DOWN IMAGE 1
  ;defb 0  ; 13 - SPRITE FLIPPED ? 0 = NO, 1 = HORIZ, 2 = VERT

  ;defb 0  ; 14 - CURRENT TILE UPDATED 0 - NO, 1 - YES
  ;defb 0  ; 15 - HAS DOUBLE BUFFER - 0 = NO, 1 = YES, 2 = MOVED SCREEN
  ;defb 0  ; 16 - PREV X BYTE POS
  ;defb 0  ; 17 - PREV Y LINE POS

  ;defb 0  ; 18 - OBJECT ID IF IT IS AN OBJECT THAT CAN BE PICKED UP - THIS IMAGE OVERRIDES ANIMATION
  ;defb 0  ; 19 - CURRENT SPRITE OFFSET FOR ANIMATION

  ;defb 0  ; 20 - HAS MOVED - ONLY REDRAW IF WE HAVE ACTUALLY MOVED
 
  ;defb 0  ; 21 - DESTINATION MAP X
  ;defb 0  ; 22 - DESTINATION MAP Y
  ;defb 0  ; 23 - DESTINATION TILE
  ;defb 0  ; 24 - 0 = MOVE RANDOMLY, 1 = MOVE DEST, 2 = MOVE TO PLAYER, 3 = MOVE STRAIGHT, 4 = STATIONARY

  ;defb 0  ; 25 - SUBMERGED - ONLY DRAW HALF OF SPRITE

  ;defb 0  ; 26 - SPRITE ID, ALSO OFFSET FOR TILE LOCATION DATA
  ;defb 0  ; 27 - SPRITE TYPE, 0 = PLAYER, 1 = PERSON, 2 = ANIMAL, 3 = PLAYER ARROW, 4 = PICKUP OBJECT

; LOOKUP TABLE FOR ANIMATION FRAMES
spriteanimtable:
  defw weemanl1      ; 0
  defw weemanl2      ; 1
  defw torchright    ; 2
  defw torchright2   ; 3
  defw weemand1      ; 4 
  defw weemand2      ; 5
  defw weemanu1      ; 6
  defw weemanu2      ; 7
  defw rabbitleft    ; 8
  defw rabbitleft2   ; 9
  defw tumbleweed1   ; 10
  defw tumbleweed2   ; 11
  defw fire1         ; 12
  defw fire2         ; 13
  defw watershimmer1 ; 14
  defw watershimmer2 ; 15
  defw watershimmer1 ; 16
  defw arrowleft     ; 17
  defw arrowleft     ; 18
  defw arrowup       ; 19
  defw arrowup       ; 20
  defw arrowdown     ; 21
  defw arrowdown     ; 22

  anim_weemanl1      equ 0
  anim_weemanl2      equ 1
  anim_torchright    equ 2
  anim_torchright2   equ 3
  anim_weemand1      equ 4 
  anim_weemand2      equ 5
  anim_weemanu1      equ 6
  anim_weemanu2      equ 7
  anim_rabbitleft    equ 8
  anim_rabbitleft2   equ 9
  anim_tumbleweed1   equ 10
  anim_tumbleweed2   equ 11
  anim_fire1         equ 12
  anim_fire2         equ 13
  anim_watershimmer1 equ 14
  anim_watershimmer2 equ 15
  anim_arrowleft     equ 17
  anim_arrowleft2    equ 18
  anim_arrowup       equ 19
  anim_arrowup2      equ 20
  anim_arrowdown     equ 21
  anim_arrowdown2    equ 22

doublebuffertable:
  defw rabbitbuff    ; USE EMPTY 0 TILE TO SAVE MEMORY
  defw rabbitbuff2
  defw rabbitbuff3
  defw rabbitbuff4
  defw rabbitbuff5
  defw rabbitbuff6
  defw rabbitbuff7

tilenum_cur:
  defb 92 ; TILE NUMBER PLAYER IS CURRENTLY OCCUPYING (NEEDED TO SET RANDOMIZATION OF START HOUSE)

;; the inks for the pens
pens_night:
  defb 0  ;0 TRANSPARENT/BACKGROUND
  defb 25 ;1 WHITE
  defb 0  ;2 BLACK
  defb 0  ;3 BROWN
  defb 3  ;4 RED
  defb 5  ;5 BLUE
  defb 15 ;6 YELLOW
  defb 6  ;7 ORANGE
  defb 0  ;8 PURPLE
  defb 14 ;9 LIGHT BLUE
  defb 4  ;10 MEDIUM BLUE
  defb 12 ;11 LIGHT GREEN
  defb 10 ;12 SEA GREEN
  defb 9  ;13 TEAL
  defb 2  ;14 MAUVE
  defb 0  ;15 DARK GREEN
pens:
  defb 9  ;0 TRANSPARENT/BACKGROUND
  defb 26 ;1 WHITE
  defb 0  ;2 BLACK
  defb 3  ;3 BROWN
  defb 6  ;4 RED
  defb 2  ;5 BLUE
  defb 24 ;6 YELLOW
  defb 15 ;7 ORANGE
  defb 5  ;8 PURPLE
  defb 20 ;9 LIGHT BLUE
  defb 14 ;10 MEDIUM BLUE
  defb 21 ;11 LIGHT GREEN
  defb 12 ;12 SEA GREEN
  defb 10 ;13 TEAL
  defb 4  ;14 MAUVE
  defb 9  ;15 DARK GREEN