screenadr           equ &c000
topstatusbarline    equ &FE54
secondstatusbarline equ &EEA4
screensize          equ &4000
linewidth           equ 2048

; DE = PTR TO TEXT
; HL = SCREEN ADDRESS
; A PRESERVED
gra_wr_string2:
  push af
  ld a,(de)
  cp " " ; SKIP LEADING SPACE
  jr nz,printtextloop
  inc de
  printtextloop:
    ld a,(de)
    cp 255 ; COMPARE TO 255 AS 0 WILL BE A SPRITE NUMBER
    jr z,popaf
    
    push hl ; BACK UP CURRENT GFX POS
    push de ; BACK UP DE TO READ PTR TABLE
    ld de,letters_ptr_table
    sub " " ; CONVERT LETTER TO TILE INDEX NUMBER
    call get_tile_ptr_text
    call font_draw
    pop de
    pop hl ; RESTORE UP CURRENT GFX POS
    inc hl ; ADVANCE ONE CHAR SIZE
    inc hl
    inc de
  jr printtextloop

popaf:
  pop af
ret

dopens:
  ;; set 16 colour mode 1
  
  ;ld a,1
  ;call scr_set_mode

  ;; set border to black
  ;ld bc,0
  ;call scr_set_border

  ;; set pens
  ld hl,pens
  ;ld b,4    ;; 4 pens for mode 1
  xor a      ;; initial pen index
  set_pensa:
  push bc
  push af
  ld c,(hl)  ;; B,C = inks for pen. If they are the same then no flashing
  ld b,c
  inc hl
  push hl
  call scr_set_ink
  pop hl
  pop af
  pop bc
  inc a     ;; increment pen index
  djnz set_pensa
ret

; INPUTS A = COLOUR
ClearScreen:
  ld hl,screenadr
  ld b,20;160
  loopyloo:
    push bc
    call DrawHorizLine
    call DrawHorizLine
    call DrawHorizLine
    call DrawHorizLine
    call DrawHorizLine
    call DrawHorizLine
    call DrawHorizLine
    call DrawHorizLine
    pop bc
  djnz loopyloo
ret

scr_next_line_hl:
  ld a,h
  add &08
  ld h,a
  bit 7,h
  ret nz
  ld bc,&c050
  add hl,bc
ret

;scr_prev_line_hl:
;  ld a,h
;  sub &08
;  ld h,a
;  bit 7,h
;  ret nz
;  ld bc,&c050
;  sbc hl,bc
;ret

; INPUTS
; HL = SCREEN ADR
; A = COLOUR
ClearTile:
  push bc
  ld b,16
  ; SAVES US HAVING TO PUSH POP AF
  ld (selfmodpencol-1),a
  loopyloo3:
    ; COPY HL TO DE
    push bc
    push hl
    push hl
    pop de 
    ld (hl),1:selfmodpencol
    inc de
    ldi
    ldi
    ldi
    pop hl
    call scr_next_line_hl
    pop bc
  djnz loopyloo3
  pop bc
ret