; INPUTS
; HL = DATA DEFINITION TO READ
; DE = SPRITE DATA TO USE AS MAZE OBJECT

buildstaticroomdefmazenew:
  ; BUILD ROOM
  ; GET LOCATION OF SPRITE
  ld a,(hl)
  cp 255 ; HAVE WE REACHED END OF LIST?
  ret z
  cp 254 ; HAVE WE REACHED END OF LINE? GET NEW Y VARIABLE
  jr z,getnewyvar
  cp 253 ; REPEAT LAST LINE
  jr z,repeatlastline

  ld c,a ; X POS
  inc hl

  push hl
  push bc
  call insertspritetilesxynocheck
  pop bc
  pop hl
  jr buildstaticroomdefmazenew

  getnewyvar:
    inc hl
    ld b,(hl) ; Y POS
    inc hl
    ld a,(hl)
    cp 253
    jr z,skiplastlinestore ; DON'T RECORD OUR OWN LINE PTR IF WE ARE REPEATING PREV LINE
    ; STORE LAST LINE PTR
    ld (lastlineptr),hl
    skiplastlinestore:
    jr buildstaticroomdefmazenew

  repeatlastline:
    inc hl
    ; STORE CURR LINE PTR
    ld (currlineptr),hl
    ; POINT HL TO LAST LINE
    ld hl,(lastlineptr)

    lastlinecopy:
      ld a,(hl)
      cp 254 ; END OF LAST LINE
      jr z,finlastlinecopy
      ; PROCESS LAST LINE INTEGER
      ld c,a ; X POS
      inc hl
      push hl
      push bc
      call insertspritetilesxynocheck
      pop bc
      pop hl
      jr lastlinecopy
    finlastlinecopy:
    ; RESTORE CURRENT LINE PTR
    ld hl,(currlineptr)
    jr buildstaticroomdefmazenew

buildmazebottommid:
  ld hl,buildmazebottommiddatanew
  makestaticmazenew:
  ld de,s_pinetree
  call buildstaticroomdefmazenew
  jp jumpbackscreenfoliagey

buildmazemidleft:
  ld hl,buildmazemidleftdata
  jr makestaticmazenew

buildmazetopmid:
  ld hl,buildmazetopmiddata
  jr makestaticmazenew

buildmazetopright:
  ld hl,buildmazetoprightdata
  jr makestaticmazenew

buildmazemidright:
  ld hl,buildmazemidrightdata
  jr makestaticmazenew

buildmazebottomright:
  ld hl,buildmazebottomrightdata
  jr makestaticmazenew

buildmazebottomleft:
  ld hl,buildmazebottomleftdata
  jr makestaticmazenew

buildmazetopleft:
  ld hl,buildmazetopleftdata
  jr makestaticmazenew

buildmazemiddata2:
  defb 7+80 ; X
  defw s_roundhouse
  defb 7+102
  defw s_girlnarnia
  defb 255

buildmazemid:
  ld hl,buildmazemiddata2
  call buildstaticroomdef
  ld hl,buildmazemiddata
  jr makestaticmazenew

; 253 - NEXT BYTE IS Y POSITION ONE TIME ONLY TO SAVE SPACE
; OPTIMIZED
buildmazebottommiddatanew:
  defb 254,9,0,2,4,6,8,10,14,16,18    ; Y, X, X...
  defb 254,5,253                      ; Y, X, X...
  defb 254,3,253                      ; Y, X, X...
  defb 254,7,253                      ; Y, X, X...
  defb 254,9,12                       ; Y, X, X...
  defb 254,5,12                       ; Y, X, X...
  defb 254,3,12                       ; Y, X, X...
  defb 254,8,10                       ; Y, X, X...
  defb 255                            ; END OF LIST

buildmazemiddata:
  defb 254,2,0,2,4,6,8,10,12,14,16,18 ; X, Y
  defb 255                            ; END OF LIST

; OPTIMIZED
buildmazetopmiddata:
  defb 254,9,8,10
  defb 254,9,0,2,4,6,12,14,16,18  ; X, Y
  defb 254,3,253                  ; X, Y
  defb 254,7,253                  ; X, Y
  defb 254,4,6,12                 ; X, Y
  defb 254,5,253                  ; X, Y
  defb 254,6,253                  ; X, Y
  defb 254,5,0,2,16,18            ; X, Y
  defb 255                        ; END OF LIST

; OPTIMIZED
buildmazetoprightdata:
  defb 254,3,16,12,8,4       ; X, Y
  defb 254,6,253             ; X, Y
  defb 254,8,253             ; X, Y
  defb 254,10,253            ; X, Y
  defb 254,11,253            ; X, Y
  defb 254,5,253             ; X, Y
  defb 254,9,253             ; X, Y
  defb 254,7,253             ; X, Y
  defb 254,3,0,2,6,10,14     ; X, Y
  defb 254,5,0,2             ; X, Y
  defb 254,9,0,2             ; X, Y
  defb 254,7,0               ; X, Y
  defb 254,4,16,8            ; X, Y
  defb 255                   ; END OF LIST

; OPTIMIZED
buildmazemidrightdata:
  defb 254,6,16,12,8,4,0     ; X, Y
  defb 254,7,253             ; X, Y
  defb 254,8,253             ; X, Y
  defb 254,9,253             ; X, Y
  defb 254,10,253            ; X, Y
  defb 254,11,253            ; X, Y
  defb 254,2,253             ; X, Y
  defb 254,3,16,12,4,0       ; X, Y
  defb 254,5,253             ; X, Y
  defb 254,1,16,12,8,4       ; X, Y
  defb 254,4,253             ; X, Y
  defb 254,4,6,10,0          ; X, Y
  defb 255                   ; END OF LIST

; OPTIMIZED
buildmazebottomrightdata:
  defb 254,5,16,0,4,8,10,12  ; X, Y
  defb 254,9,253             ; X, Y
  defb 254,7,253             ; X, Y
  defb 254,9,2,6,14          ; X, Y
  defb 254,7,2,6             ; X, Y
  defb 254,5,14              ; X, Y
  defb 254,1,16,4,12,8       ; X, Y
  defb 254,2,253             ; X, Y
  defb 254,3,253             ; X, Y
  defb 254,3,0,2             ; X, Y
  defb 254,4,16,4,8          ; X, Y
  defb 254,6,16,4            ; X, Y
  defb 254,8,16              ; X, Y
  defb 255                   ; END OF LIST

; OPTIMIZED
buildmazemidleftdata:
  defb 254,2,2,6,10,14,18    ; X, Y
  defb 254,3,253             ; X, Y
  defb 254,4,253             ; X, Y
  defb 254,8,253             ; X, Y
  defb 254,9,253             ; X, Y
  defb 254,10,253            ; X, Y
  defb 254,11,253            ; X, Y
  defb 254,5,253             ; X, Y
  defb 254,7,253             ; X, Y
  defb 254,5,8               ; X, Y
  defb 254,7,12              ; X, Y
  defb 254,1,2,6,10,14       ; X, Y
  defb 254,6,2,6,14,18       ; X, Y
  defb 255                   ; END OF LIST

; OPTIMIZED
buildmazebottomleftdata:
  defb 254,1,2,6,10,14,18    ; X, Y
  defb 254,2,253             ; X, Y
  defb 254,3,253             ; X, Y
  defb 254,9,253             ; X, Y
  defb 254,5,253             ; X, Y
  defb 254,7,253             ; X, Y
  defb 254,9,4,8,12,16       ; X, Y
  defb 254,5,16              ; X, Y
  defb 254,7,8               ; X, Y
  defb 254,6,2,6,14          ; X, Y
  defb 254,4,253             ; X, Y
  defb 254,4,10              ; X, Y
  defb 254,8,2,14            ; X, Y
  defb 255                   ; END OF LIST

; OPTIMIZED
buildmazetopleftdata:
  defb 254,10,6,2,10,14      ; X, Y
  defb 254,11,253            ; X, Y
  defb 254,8,253             ; X, Y
  defb 254,3,253             ; X, Y
  defb 254,5,253             ; X, Y
  defb 254,9,253             ; X, Y
  defb 254,7,253             ; X, Y
  defb 254,5,8,12,16,18      ; X, Y
  defb 254,3,253             ; X, Y
  defb 254,3,4               ; X, Y
  defb 254,9,16,18           ; X, Y
  defb 254,7,18              ; X, Y
  defb 254,6,6,2,14          ; X, Y
  defb 254,4,2               ; X, Y
  defb 255                   ; END OF LIST