buildroomlogcabindata:
  defb 1+180;,10
  defw s_cabinwallhbottom
  defb 0+180;,10
  defw s_cabinwallleft
  defb 19+180;,10
  defw s_cabinwallright
  defb 11+100;,6
  defw s_cabinwalldiv
  defb 6+200;,11 ; START OUTSIDE OF SCREEN SO WE CAN PASTE OVER TOP OF WALL
  defw s_doorforest
  defb 13+200;,11 ; START OUTSIDE OF SCREEN SO WE CAN PASTE OVER TOP OF WALL
  defw s_windowforest
  defb 0;,1 ; X, Y
  defw s_cabinwallh ; SPRITE
  defb 255 ; END OF LIST

buildroomlogcabin:
  ld hl,buildroomlogcabindata
  call buildstaticroomdef
  ld de,s_table
  call insspriterandpos
  ret

buildroomstoredata:
  defb 1+180;,10
  defw s_storewallhbottom
  defb 0+180;,10
  defw s_cabinwallleft
  defb 19+180;,10
  defw s_cabinwallright
  defb 11+200;,11 ; START OUTSIDE OF SCREEN SO WE CAN PASTE OVER TOP OF WALL
  defw s_doorforest
  defb 3+200;,11 ; START OUTSIDE OF SCREEN SO WE CAN PASTE OVER TOP OF WALL
  defw s_windowwestern
  defb 7+200;,11 ; START OUTSIDE OF SCREEN SO WE CAN PASTE OVER TOP OF WALL
  defw s_windowwestern
  defb 16+200;,11 ; START OUTSIDE OF SCREEN SO WE CAN PASTE OVER TOP OF WALL
  defw s_windowwestern
  defb 0;,1 ; X, Y
  defw s_cabinwallh ; SPRITE
  defb 255 ; END OF LIST

buildroomstore:
  ld hl,buildroomstoredata
  call buildstaticroomdef
  ld de,s_table
  call insspriterandpos
  ld de,s_shopkeeper
  jp insspriterandpos

buildroomstonebuildingdata:
  defb 4;,1 ; X, Y
  defw s_stonebuildingwallh ; SPRITE
  defb 4+180;,10
  defw s_stonebuildingwallhbottom
  defb 4+160;,9
  defw s_stonebuildingwallleft
  defb 14+160;,9
  defw s_stonebuildingwallright
  defb 8+200;,11 ; START OUTSIDE OF SCREEN SO WE CAN PASTE OVER TOP OF WALL
  defw s_doorforest
  defb 255 ; END OF LIST

buildroomstonebuilding:
  ; FILL BLANK AREAS OF ROOM TO STOP TABLES APPEARING IN THEM
  ld a,0   ; TILENUM
  ld b,10  ; HEIGHT
  ld c,5   ; WIDTH
  ld d,1   ; MAKE OBJECT
  call fillobjectmap
  ld a,15  ; TILENUM
  ld b,10  ; HEIGHT
  ld c,5   ; WIDTH
  ld d,1   ; MAKE OBJECT
  call fillobjectmap

  ld hl,buildroomstonebuildingdata
  call buildstaticroomdef
  ld b,anim_torchright   ; LOWER SPRITE ID IN ANIM TABLE
  ld c,94                ; TILE NUMBER
  ld d,0                 ; FLIPPED
  call activatetileanim 
  ld b,anim_torchright   ; LOWER SPRITE ID IN ANIM TABLE
  ld c,84                ; TILE NUMBER
  ld d,1                 ; FLIPPED
  call activatetileanim 
  ld de,s_table
  jp insspriterandpos

buildroomlogcabinwesterndata:
  defb 0;,1 ; X, Y
  defw s_cabinwallh ; SPRITE
  defb 1+180;,10
  defw s_cabinwallhbottom
  defb 0+180;,10
  defw s_cabinwallleft
  defb 19+180;,10
  defw s_cabinwallright
  defb 11+100;,6
  defw s_cabinwalldiv
  defb 6+200;,11 ; START OUTSIDE OF SCREEN SO WE CAN PASTE OVER TOP OF WALL
  defw s_doorforest
  defb 13+200;,11 ; START OUTSIDE OF SCREEN SO WE CAN PASTE OVER TOP OF WALL
  defw s_windowwestern
  defb 255 ; END OF LIST
  defb 255 ; END OF LIST

buildroomlogcabinwestern:
  ld hl,buildroomlogcabinwesterndata
  call buildstaticroomdef
  ld de,s_table
  jp insspriterandpos

;buildroomlogcabinwesternshop:
;  call buildroomlogcabinwestern
;  ld de,s_shopkeeper
;  jp insspriterandpos

buildroomwigwamdata:
  defb 0+20;,2 ; X, Y
  defw s_wigwaminsidetoprow ; SPRITE
  defb 0+160;,9 ; X, Y
  defw s_wigwaminside ; SPRITE
  defb 0+180;,2 ; X, Y
  defw s_wigwaminsidebottomrow ; SPRITE
  defb 255 ; END OF LIST

buildroomwigwam:
  ; MAKE WALLS AND BACKGROUND OF WIGWAM SOLID
  ; SO RANDOM SPRITES DON'T GET STUCK IN IT
  ld a,0   ; TILENUM
  ld b,12  ; HEIGHT
  ld c,20  ; WIDTH
  ld d,1   ; MAKE OBJECT

  call fillobjectmap
  ld hl,dograssdata

  call loadgrasstable
  ld hl,buildroomwigwamdata
  ; MAKE GROUND PASSABLE
  call buildstaticroomdef
  ld a,46 ; TILENUM
  ld b,6  ; HEIGHT
  ld c,8  ; WIDTH
  call clearobjectmap

  ld b,anim_fire1 ; LOWER SPRITE ID IN ANIM TABLE
  ld c,90         ; TILE NUMBER
  jp activatetileanim 

buildminedata:
  defb 9+80               ; X, Y
  defw s_minetunneltop    ; SPRITE
  defb 9+180
  defw s_minetunnelbottom
  defb 255                ; END OF LIST

buildroommine:
  call createmydirt
  ld hl,buildminedata
  call buildstaticroomdef
  ld a,30
  ld b,8
  ld c,1
  jp clearobjectmapbridge

buildroommine2:
  call buildroommine
  ld hl,tilemap2
  ld l,10
  ld a,242             ; EXIT MINE TO STONE BUILDING IN NARNIA
  makeexitdoor:
  ld (hl),a
  ld hl,tilemap2
  ld l,190
  ld a,239             ; EXIT TO SAME STONE BUILDING
  ld (hl),a 
ret
buildroommine2reverse:
  call buildroommine
  ld hl,tilemap2
  ld l,10
  ld a,240            ; EXIT MINE TO STONE BUILDING IN MAZE
  jr makeexitdoor

;backupinbuilding IN BUILDING - 0 = NO, 1 = LOG CABIN ETC
; BACK UP PLAYER POSITION
backupplayerpos:
  ld a,(ix+3)      ; SAVE IN BUILDING
  ld (backupinbuildingmin1-1),a
  ld a,(ix+6)      ; SAVE X COORD
  ld (backupcoordxmin1-1),a
  ld a,(ix+7)      ; SAVE Y COORD
  ld (backupcoordymin-1),a
ret
;backupcoordx BACKUP PLAYER COORD X
; RESTORE PLAYER POSITION
restoreplayerpos:
  ld a,1:backupinbuildingmin1 ; SAVE IN BUILDING
  ld (ix+3),a
  ld (inbuilding),a
  ld a,32:backupcoordxmin1
  ld (ix+6),a             ; SAVE X COORD
  ld a,94:backupcoordymin
  ld (ix+7),a             ; SAVE Y COORD
ret