

; TILE ANIMATION
updatetileanims:
  ld ix,animtiles
  animloop:
    ;push ix
    ld a,(ix+0)
    cp 255 ; END OF LIST
    ret z
  
    or a;cp 0   ; ANIM NOT ACTIVE
    jr z,movenextanim

    ; SKIP IF PICKUPABLE OBJECT
    ld a,(ix+18)
    cp 0 
    jr nz,movenextanim

    ; BUMP OFFSET
    ld a,(ix+1)
    inc a
    cp 2
    jr nz,skipdecoffset
    xor a;ld a,0
    skipdecoffset:
    ld (ix+1),a

    ; GET SPRITE DATA TO DE
    add (ix+2)
    call vectorspritelookup
    push de               ; BACK UP TILE GRAPHICS
  
    ; FLIPPED
    ld a,(ix+3)
    or a;cp 0
    ld l,(ix+4)
    jr z,drawnotflipped

    ; GET TILE POS
    call gettilepixelpos
    call get_scr_addr
    pop de
    call tile_restore_flip    ;; now draw tile
    jr movenextanim

    drawnotflipped:
    ; GET TILE POS
    call gettilepixelpos
    call get_scr_addr
    pop de
    call tile_restore    ;; now draw tile
    
    movenextanim: 
      ld bc,5
      add ix,bc
    jr animloop 

building_transp_col:
  ; BUILDING ID, DAY, NIGHT PEN
  defb 9,  0   ; 0 - GRASS - GREEN, BLACK
  defb 3,  0   ; 1 - CABIN - BROWN, BLACK
  defb 15, 3   ; 2 - MINE - ORANGE, BROWN
  defb 15, 3   ; 3 - WIGWAM - ORANGE, BROWN
  defb 0,  0   ; 4 - STONE BUILDING - BLACK, BLACK
  defb 15, 3   ; 5 - MINE - ORANGE, BROWN
  defb 15, 3   ; 6 - MINE2 - ORANGE, BROWN
  defb 3,  0   ; 7 - WESTERN SHOP

set_transp_col_zone:
  ld hl,zone_transp_col
  ld a,(currzonedata)
  jr set_transp_col_zone2

set_transp_col:
  ld hl,building_transp_col
  ld a,(inbuilding)
  set_transp_col_zone2:
  rlca ; DOUBLE BYTE FOR LOOKUP
  ld b,0
  ld c,a
  add hl,bc

  ; GET INKS INTO B AND C - DAY AND NIGHT
  ld b,(hl)
  inc hl
  ld c,(hl)

  ; UPDATE PENS DAY / NIGHT TABLE SO WE REMEMBER TO CHANGE TO RIGHT COLOUR
  ld hl,pens
  ld (hl),b
  ld hl,pens_night
  ld (hl),c

  ; SET INK
  ld a,(nighttime)
  or a ; IF IT IS DAY
  jr z,setdayink
  
  ; SET NIGHT INK
  xor a
  ld b,c
  call scr_set_ink
  jr doclearscreen

  setdayink:
  ld c,b
  call scr_set_ink

  doclearscreen:
  ; CLEAR SCREEN BY BACKGROUND COLOUR
  ld a,(currscreendata2)
  cp 5 ; DONT CLEAR SCREEN IF IT IS JUST SEA
  ret z

  xor a
  call ClearScreen
  ret
    
gentilemapa:
  ; RESET PSEUDO RANDOM NUMBER SEQUENCE
  call resetpseudorandom
  call genscreenname

  call getcurrworldmap
  call getcurrworldmapvalue
  call checkscreenzoneclimate
  call getcurrlocalmap
  call getcurrlocalmapvalue
  call resetpseudorandom

  ; SET TRANSP COL BY BUILDING
  ld a,(inbuilding)
  or a;cp 0
  jr z,skipsetbuildcol
  call set_transp_col
  jr clsfin
  skipsetbuildcol:
  ; SET BY ZONE
  call set_transp_col_zone
  
  clsfin:
  call populatetilemap

  ;call bankswitchsprites

  ld de,tilemap0     
  call tilemap_draw       ; DRAW GROUND LEVEL TILE MAP
  ld de,tilemap1
  call tilemap_draw       ; DRAW UPPER LEVEL TILE MAP

  ld a,(lastinsertpos)   ; GET LOCATION OF SHOP
  cp 255
  jr z,skipshoptitle
  ld de,str_shoptitle
  call drawshoptitles     ; DRAW TITLES ON SHOPS IF WE HAVE ANY
  ld a,255
  ld (lastinsertpos),a   ; CLEAR LOCATION OF SHOP
  skipshoptitle:

  ld a,(lastinsertpossaloon)   ; GET LOCATION OF SHOP
  cp 255
  jr z,skipsaloontitle
  ld de,str_saloontitle
  call drawshoptitles     ; DRAW TITLES ON SHOPS IF WE HAVE ANY
  ld a,255
  ld (lastinsertpossaloon),a   ; CLEAR LOCATION OF SHOP
  skipsaloontitle:

  ld a,(viewmap)
  or a;cp 0
  jr z,skipdrawmap
  call drawmap
  skipdrawmap: 

  ;mcall bankswitchcode

  skiptilemapdraw:
  call updateplayersprite ; REDRAW PLAYER SPRITE
ret

str_shoptitle:
  defb "STORE",255
hasshop:
  defb 0
str_saloontitle:
  defb "SALOON",255
hassaloon:
  defb 0

; CHECK TO SEE IF A SPRITE INSERTION POINT WAS RECORDED.
; IF SO, CONVERT THE TILE NUMBER TO A PIXEL LOCATION AND PRINT 
; THE SIGN
; INPUTS
; A  = LAST INSERT POS
; DE = STR TO INSERT
drawshoptitles:
  push de
  sub 21                  ; MOVE UP ONE ROW FOR SHOP ROOF AND BACK ONE FOR CENTRING
  ld l,a
  call gettilepixelpos
  call get_scr_addr
  ld bc,&0050             ; CENTRE ON ROOF
  add hl,bc
  pop de
  call gra_wr_string2
ret

; PARSES GRASS TABLE ITEMS AND INSERTS THEM INTO TILEMAP
; INPUTS
; HL = TABLE DATA
loadgrasstable:
  ld a,(hl)
  cp 255           ; END OF LIST
  ret z
  ld b,a           ; GET MAX RAND IN B
  inc hl
  ld d,(hl)        ; GET SPRITE ID NUMBER IN D 
  inc hl
  push hl
  call dograsstile ; INSERT INTO MAP
  pop hl
jr loadgrasstable

dograssdata:
  defb 30,grass      ; MAX RAND INSERT, TILE ID
  defb 30,longgrass
  defb 255           ; END OF LIST
dograss:
  ld hl,dograssdata
  call loadgrasstable
  jp buildgrassjumpback
dograssflowersdata:
  defb 10,flowers   ; MAX RAND INSERT, TILE ID
  defb 255          ; END OF LIST
dograssflowerstreesdata:
  defb 5,smalltree  ; MAX RAND INSERT, TILE ID
  defb 255          ; END OF LIST
dograssflowers:
  ld hl,dograssflowersdata
  call loadgrasstable
  dosmalltrees:
  ld hl,dograssflowerstreesdata
  call loadgrasstable
  jp dograss
dograsswesternnoflowersdata:
  defb 30,longgrass   ; MAX RAND INSERT, TILE ID
  defb 5,smallcactus
  defb 255            ; END OF LIST
dograsswesternnoflowers:
  ld hl,dograsswesternnoflowersdata
  call loadgrasstable
  jp buildgrassjumpback
dograsswesterndata:
  defb 5,smallcactus  ; MAX RAND INSERT, TILE ID
  defb 2,skull
  defb 30,longgrass
  defb 255            ; END OF LIST
dograsswestern:
  ld hl,dograsswesterndata
  call loadgrasstable
  jp buildgrassjumpback

; INSERT A RANDOM NUMBER OF GRASS TILES INTO TILE MAP
; INPUTS
; B = MAX RAND NUMBER OF TIMES TO INSERT TILE
; D = TILE NUMBER TO INSERT
dograsstile:
  call rand32
  or a; cp 0 ; RETURN IF WE AREN'T TO INSERT ANYTHING
  ret z
  ld b,a
  ld hl,tilemap0
  sgloop:
    call rand
    ld l,a
    ld (hl),d
  djnz sgloop
ret

; FILL MAP
; FILL GRAPHIC AND OBJECT MAP WITH SPECIFIC VALUES
; INPUTS
; A = START TILE NUM
; B = HEIGHT
; C = WIDTH
; D = VALUE
; E = VALUE FOR OBJECT MAP
fillmap:
  call filltilemap
  ld d,e
  fillobjectmap:
  ld hl,tilemap2
  jr filltilemap2

; INPUTS
; A = START TILE NUM
; B = HEIGHT
; C = WIDTH
; D = VALUE

; FILL MAP WITH SPECIFIC TILE
filltilemap:
  ld hl,tilemap0
  filltilemap2:
  push af
  push bc
  call clearloopy
  pop bc
  pop af
  ret

; INPUTS
; A = START TILE NUM
; B = HEIGHT
; C = WIDTH
; D = VALUE

; FILL OBJECT MAP WITH VALUE
clearobjectmapbridge:
  ld hl,tilemap2
  ld d,254
  clearloopy:
     ld l,a ; FIND START TILE
     push bc
     ld b,c
     clearloopx:
       ld (hl),d  ; CLEAR OBJECT TILE - 254 MAKES OBJECT PASSABLE, E.G BRIDGE
       inc l
     djnz clearloopx
     pop bc
     add tilemap_width_tiles
  djnz clearloopy
ret

clearobjectmap:
  ld d,0
  jr fillobjectmap

b_nothing                   equ 0
b_laketopleft               equ 1
b_laketop                   equ 2
b_laketopright              equ 3
b_lakeleft                  equ 4
b_lakemid                   equ 5
b_lakeright                 equ 6
b_lakebottomleft            equ 7
b_lakebottom                equ 8
b_lakebottomright           equ 9
b_rivertopleft              equ 10
b_riververtleft             equ 11
b_rivertopright             equ 12
b_riverhoriz                equ 13
b_riverhoriz2               equ 14
b_riverbottomleft           equ 15
b_riverbottomright          equ 16
b_islandtopleft             equ 17
b_islandtopright            equ 18
b_islandbottomleft          equ 19
b_islandbottomright         equ 20
b_home                      equ 21
b_randomtownwestern         equ 22
b_randomtownplains          equ 23
b_randomtownforest          equ 24
b_randomtownindian          equ 25
b_randomtownknights         equ 26
b_archeryrange              equ 27
b_mazetopleft               equ 28
b_mazetopmid                equ 29
b_mazetopright              equ 30
b_mazemidleft               equ 31
b_mazemid                   equ 32
b_mazemidright              equ 33
b_mazebottomleft            equ 34
b_mazebottommid             equ 35
b_mazebottomright           equ 36
b_castle                    equ 37
b_buildmountainrangetop     equ 38
b_buildmountainrangebottom  equ 39
b_mine                      equ 40
b_mine2                     equ 41
b_riverseatop               equ 42
b_riverseabottom            equ 43
b_buildforest               equ 44
b_narniahouse               equ 45
b_mountainblockbottom       equ 46
b_landfence                 equ 47
b_sealandfenceleft          equ 48
b_sealandfenceright         equ 49
b_buildmountainrange        equ 50
b_buildmountainrangeleft    equ 51
b_buildmountainrangeright   equ 52
b_buildcrossroad            equ 53
b_buildvertroad             equ 54
b_buildhorizroad            equ 55
b_stonewalltopleft          equ 56
b_stonewallhoriz            equ 57
b_stonewalltopright         equ 58
b_stonewallvert             equ 59
b_stonewallbottomleft       equ 60
b_stonewallbottomright      equ 61
b_stonewallarchway          equ 62

; INSERT STATICALLY BUILT SCREENS INTO LOCAL MAP ON LOCAL MAP GENERATION
; NUMBERS ARE TILE IDS, NOT COORDINATES
static_map_table:
  ; HOME SWEET HOME
  ; WORLD MAP TILENUM, LOCAL MAP TILENUM, ROOM ID
  defb 0,13,      b_lakeleft
  defb 0,10,      b_lakeright
  defb 0,21,      b_laketop
  defb 0,01,      b_lakebottom
  defb 0,22,      b_laketop
  defb 0,02,      b_lakebottom
  defb 0,23,      b_islandbottomright
  defb 0,20,      b_islandbottomleft
  defb 0,03,      b_islandtopright
  defb 0,0,       b_islandtopleft
  defb 0,11,      b_home  

  ;defb 0,01,      b_stonewalltopleft   
  ;defb 0,02,      b_stonewallhoriz
  ;defb 0,03,      b_stonewalltopright
  ;defb 0,11,      b_stonewallvert   
  ;defb 0,13,      b_stonewallvert   
  ;defb 0,21,      b_stonewallbottomleft   
  ;defb 0,23,      b_stonewallbottomright
  ;defb 0,22,      b_stonewallarchway
 
  ;defb 0,01,      b_buildcrossroad        
  ;defb 0,02,      b_buildhorizroad          
  defb 0,12,      b_mine
  defb 1+10,55,   b_mine2 
  defb 1+50,5+51, b_archeryrange
  ; MAZE
  defb 2+20,11,   b_mazetopleft    
  defb 2+20,12,   b_mazetopmid      
  defb 2+20,13,   b_mazetopright    
  defb 2+20,21,   b_mazemidleft     
  defb 2+20,22,   b_mazemid         
  defb 2+20,23,   b_mazemidright    
  defb 2+20,31,   b_mazebottomleft  
  defb 2+20,32,   b_mazebottommid   
  defb 2+20,33,   b_mazebottomright
  defb 2+40,3+90, b_narniahouse 

  defb 0+40,6+50, b_stonewalltopleft   
  defb 0+40,7+50, b_stonewallhoriz
  defb 0+40,8+50, b_stonewalltopright
  defb 0+40,6+60, b_stonewallvert   
  defb 0+40,8+60, b_stonewallvert   
  defb 0+40,6+70, b_stonewallbottomleft   
  defb 0+40,7+70, b_stonewallarchway
  defb 0+40,8+70, b_stonewallbottomright

  defb 0+40,7+60, b_castle
  ;defb 0,13,      b_castle
  defb 255                    ; END OF LIST

; TO CONVERT WORLD MAP, LOCAL MAP TO COORDINATE
; ADDING WORLD MAP NUMBERS GIVES YOU TENS DIGITS TILE ID
; ADDING LOCAL MAP NUMBERS GIVES YOU SINGLE DIGITS TILE ID

; STORING THE TILE LOCATION IN GLOBAL AND LOCAL MAP IDS MAKES IT FASTER
; YOU ONLY HAVE TO CHECK ONE NUMBER TO SEE IF THE SCREEN IS IN YOUR WORLD MAP
; RATHER THAN CHECKING X AND Y DIGITS

; WORLD MAP  X  +  Y  = 0 + 40 TENS
; LOCAL MAP  X  +  Y  = 8 + 70 UNITS
; COORD     00. - 04.    WORLD
; COORD     ..8 - ..7    LOCAL
; COORD     008 - 047   

; INSERT ESSENTIAL SPRITES INTO MAP
; THESE ARE REFERENCED BY STATIC MAP TABLE
landscapetable2:
  defw buildwaterjumpback        ; 0 BUILD NOTHING
  defw buildlaketopleft          ; 1
  defw buildlaketop              ; 2
  defw buildlaketopright         ; 3
  defw buildlakeleft             ; 4
  defw buildlakemid              ; 5
  defw buildlakeright            ; 6
  defw buildlakebottomleft       ; 7
  defw buildlakebottom           ; 8
  defw buildlakebottomright      ; 9
  defw buildrivertopleft         ; 10
  defw buildriververtleft        ; 11
  defw buildrivertopright        ; 12
  defw buildriverhoriz           ; 13
  defw buildriverhoriz2          ; 14
  defw buildriverbottomleft      ; 15
  defw buildriverbottomright     ; 16
  defw buildislandtopleft        ; 17
  defw buildislandtopright       ; 18
  defw buildislandbottomleft     ; 19
  defw buildislandbottomright    ; 20
  defw buildhome                 ; 21
  defw buildrandomtownwestern    ; 22
  defw buildrandomtownplains     ; 23
  defw buildrandomtownforest     ; 24
  defw buildrandomtownindian     ; 25
  defw buildrandomtownknights    ; 26
  defw buildarcheryrange         ; 27
  defw buildmazetopleft          ; 28
  defw buildmazetopmid           ; 29
  defw buildmazetopright         ; 30
  defw buildmazemidleft          ; 31
  defw buildmazemid              ; 32
  defw buildmazemidright         ; 33
  defw buildmazebottomleft       ; 34
  defw buildmazebottommid        ; 35
  defw buildmazebottomright      ; 36
  defw buildcastle               ; 37
  defw buildmountainrangetop     ; 38
  defw buildmountainrangebottom  ; 39
  defw buildminemountain         ; 40
  defw buildminemountain2        ; 41
  defw buildriverseatop          ; 42
  defw buildriverseabottom       ; 43
  defw buildforest               ; 44
  defw buildnarniahouse          ; 45
  defw buildmountainblockbottom  ; 46
  defw buildlandfence            ; 47
  defw buildsealandfenceleft     ; 48
  defw buildsealandfenceright    ; 49
  defw buildmountainrange        ; 50
  defw buildmountainrangeleft    ; 51
  defw buildmountainrangeright   ; 52
  defw buildcrossroad            ; 53
  defw buildvertroad             ; 54
  defw buildhorizroad            ; 55
  defw buildstonewalltopleft     ; 56
  defw buildstonewallhoriz       ; 57
  defw buildstonewalltopright    ; 58
  defw buildstonewallvert        ; 59
  defw buildstonewallbottomleft  ; 60
  defw buildstonewallbottomright ; 61
  defw buildstonewallarchway     ; 62

; BUILDING CODES LISTED BY BUILDING ID
buildinglist:
  defw skipbuildingcheck     ; 0
  defw inlogcabin            ; 1
  defw inmine                ; 2
  defw inwigwam              ; 3
  defw instonebuilding       ; 4
  defw inmine2               ; 5
  defw inmine2reverse        ; 6
  defw inlogcabinwesternshop ; 7

populatetilemap:
  ; CLEAR ALL THREE TILE MAPS USING THE STACK POINTER
  ; TILEMAPS NEED TO ADD TO 3x256 BYTES AND MUST BE TOGETHER IN MEMORY
  call clearsp

  ; CHECK IF WE ARE CURRENTLY IN A BUILDING
  ld a,(inbuilding)
  or a;cp 0
  jr z,skipbuildingcheck
  ld hl,buildinglist
  jp vectortablelaunchcode

  skipbuildingcheck:

  ; BUILD GRASS
  ; INDEXED BY ZONE MAP ID VALUE
  ld a,(currzonedata)
  ld hl,landscapetable3
  jp vectortablelaunchcode

  buildgrassjumpback:   

  ; BUILD MAIN FEATURES - WATER / STATIC MAPS
  ; INDEXED BY LOCAL MAP ID VALUE
  ld a,(currscreendata2)
  ld hl,landscapetable2
  jp vectortablelaunchcode

  buildwaterjumpback:   

  ; BUILD EXTRA NON ESSENTIAL SPRITES  - TREES ETC
  ; INDEXED BY ZONE MAP ID VALUE
  ld a,(currzonedata)
  ld hl,landscapetable
  jp vectortablelaunchcode

  ; GEN RANDOM QUEST ONLY SOMETIMES
  tilefinisheddorandomquest:
  call genrandomquest

  jumpbackscreenfoliagey:

  ; DRAW STATUS BAR
  tilefinished:
  ; QUEST SPRITES HAVE TO BE INSERTED LAST
  ; CAN'T HAVE RANDOM QUEST SPRITES CHANGING MAP SCENERY
  xor a
  ld (doroomidcheckminusone-1),a ; SKIP ROOM IDS FOR STATIC QUEST OBJECTS
  call checkinsertquestsprites
  ld a,1
  ld (doroomidcheckminusone-1),a ; DO ROOM ID CHECK FOR RANDOM QUEST OBJECTS

  call checkinsertquestspritesstatic ; INSERT STATIC QUEST SPRITES
  call checkinsertquestspritesrandom ; INSERT RANDOMLY GENERATED QUEST SPRITES
  call updatestatusbar
ret

; BUILD NON ESSENTIAL LANDSCAPE FEATURES

  ; HORIZONTAL
  domyplains:
    jp jumpbackscreenfoliagey

; INSERT FOLIAGE BY TABLES
; INPUTS 
; HL = FOLIAGE LIST
dofoliage:
  ld a,(hl)
  cp 255    ; END OF LIST
  ret z
  ld b,a    ; LOAD MAX RAND NUMBER INTO B
  inc hl
  ld e,(hl) ; LOAD SPRITE DEFINITION INTO DE
  inc hl
  ld d,(hl)
  inc hl
  push hl
  call insertspriterandtimes
  pop hl
jr dofoliage

domyprairiedata:
  defb 3              ; MAX RAND OF TREES TO INSERT
  defw s_bush         ; SPRITE DEFINITION
  defb 2              ; MAX RAND OF TREES TO INSERT
  defw s_bushclump    ; SPRITE DEFINITION
  defb 6              ; MAX RAND OF TREES TO INSERT
  defw s_bigtree      ; SPRITE DEFINITION
  defb 2              ; MAX RAND OF TREES TO INSERT
  defw s_bigtreebare  ; SPRITE DEFINITION
  defb 255

  domyprairie:
    ld hl,domyprairiedata
    domyfoliage:
    call dofoliage
    jp jumpbackscreenfoliagey

domyforestdata:
  defb 30          ; MAX RAND OF TREES TO INSERT
  defw s_pinetree  ; SPRITE DEFINITION
  defb 10          ; MAX RAND OF TREES TO INSERT
  defw s_bigtree   ; SPRITE DEFINITION
  defw 255

  domyforest:
    ld hl,domyforestdata
    jr domyfoliage

domymountaindata:
  defb 3                 ; MAX RAND OF TREES TO INSERT
  defw s_smallmountain   ; SPRITE DEFINTION
  defb 2                 ; MAX RAND OF TREES TO INSERT
  defw s_bignewmountain  ; SPRITE DEFINITION
  defb 4                 ; MAX RAND OF TREES TO INSERT
  defw s_newmountain     ; SPRITE DEFINITION
  defb 255

  domymountain:
    ld hl,domymountaindata
    jr domyfoliage
  domyforestmountain:
    ld hl,domyforestdata
    call dofoliage
    ld hl,domymountaindata
    jr domyfoliage
  domywesternmountain:
    ld hl,domywesterndata
    call dofoliage
    ld hl,domymountaindata
    jr domyfoliage

domylakedata:
  defb 2        ; MAX RAND TO INSERT
  defw s_water  ; SPRITE DEFINITION
  defb 255

  domylake:
    call rand32 ; ONLY HAVE LAKES SOMETIMES
    sub 16
    jp nc,jumpbackscreenfoliagey
    ld hl,domylakedata
    jr domyfoliage

domytropicaldata:
  defb 10       ; MAX RAND OF TREES TO INSERT
  defw s_palm   ; SPRITE DEFINITION
  ;defb 2        ; MAX RAND TO INSERT
  ;defw s_water  ; SPRITE DEFINITION
  defb 255

  domytropical:
    ld hl,domytropicaldata
    jr domyfoliage
  domytropicalmountain:
    ld hl,domytropicaldata
    call dofoliage
    ld hl,domymountaindata
    jr domyfoliage

domywesterndata:
  defb 6           ; MAX RAND OF TREES TO INSERT
  defw s_bigcactus ; SPRITE DEFINITION
  defb 2           ; MAX RAND OF TREES TO INSERT
  defw s_deadbush  ; SPRITE DEFINITION
  defb 255

  domywestern:
    ld hl,domywesterndata
    jr domyfoliage
  inlogcabin:
    ld a,(currzonedata)
    cp zone_western
    jr z,inlogcabinwestern
    call buildroomlogcabin
    jp tilefinisheddorandomquest
  inlogcabinwestern:
    call buildroomlogcabinwestern
    jp tilefinisheddorandomquest
  inlogcabinwesternshop:
    call buildroomstore;buildroomlogcabinwesternshop
    jp tilefinisheddorandomquest
  inwigwam:
    call buildroomwigwam
    call createmydirt
    jp tilefinisheddorandomquest
  instonebuilding:
    call buildroomstonebuilding
    jp tilefinisheddorandomquest
  inmine:
    call buildroommine
    jp tilefinished
  inmine2:
    call buildroommine2
    jp tilefinished
  inmine2reverse:
    call buildroommine2reverse
    jp tilefinished

; BUILD A FOREST OUT OF WHATEVER TREES OUR ZONE HAS
buildforest:
  ld a,(currzonedata)
  ld hl,tabletrees
  call vectorlookup ; GET SPRITE DATA INTO DE
  ld b,30
  call insertspriterandtimes
  jp buildwaterjumpback

buildnarniahousedata:
  defb 7+80 ; X
  defw s_roundhouse
  defb 255
buildnarniahouse:
  ld hl,buildnarniahousedata
  call buildstaticroomdef
  jp buildwaterjumpback

; INPUT
; HL = SPRITE DEFINITION
; B  = TOP RAND TIMES TO INSERT
insertspriterandtimes:
  push bc
  call rand
  sub 100
  jr c,skipinsert
  call insspriterandpos
  skipinsert:
  pop bc
  djnz insertspriterandtimes
ret

; RANDOMLY INSERT A SPRITE ONCE
; USED FOR SHOP, AS WE NEED TO KNOW IF WE HAVE INSERTED ONE OR NOT
; INPUT
; HL = SPRITE DEFINITION
insertspriterandonce:
  push bc
  call randbool
  or a
  jr nz,skipinsert2
  ld a,1
  ld (hasshop),a    
  call insspriterandpos
  skipinsert2:
  pop bc
ret
insertspriterandoncesaloon:
  push bc
  call randbool
  or a
  jr nz,skipinsert3
  ld a,1
  ld (hassaloon),a    
  call insspriterandpos
  skipinsert3:
  pop bc
ret

buildcampfirewestern:
  ld b,anim_fire1 ; LOWER SPRITE ID IN ANIM TABLE
  ld c,90         ; TILE NUMBER
  call activatetileanim 
  call genrandomquest
  jp buildwaterjumpback
buildrandomtownwestern:
  call rand  ; SOMETIMES BUILD CAMPFIRES IN WESTERN, BUT NOT ALWAYS
  sub 50
  jr c,buildcampfirewestern

  ld de,s_livery
  call insertspriterandonce
  ld de,s_saloon
  call insertspriterandoncesaloon

  ld b,4
  ld de,s_loghouse
  buildrandtown:
  call insertspriterandtimes
  call genrandomscreenname
  jp buildwaterjumpback
buildrandomtownplains:
  ld b,5 ; MAX RAND OF WIGWAMS TO INSERT
  ld de,s_thatchhousefront
  call insertspriterandtimes

  ld b,2 ; MAX RAND OF WIGWAMS TO INSERT
  ld de,s_thatchhouse
  ;call insertspriterandtimes

  ;ld b,3 ; MAX RAND OF WIGWAMS TO INSERT
  ;ld de,s_thatchhouseback
  jp buildrandtown
buildrandomtownforest:
  ld b,3 ; MAX RAND OF WIGWAMS TO INSERT
  ld de,s_loghouse
  jp buildrandtown
buildrandomtownknights:
  ld b,3 ; MAX RAND OF WIGWAMS TO INSERT
  ld de,s_roundhouse
  jp buildrandtown
buildrandomtownindian:
  call rand  ; SOMETIMES BUILD CAMPFIRES IN WESTERN, BUT NOT ALWAYS
  sub 50
  jr c,buildcampfirewestern
  ld b,6 ; MAX RAND OF WIGWAMS TO INSERT
  ld de,s_wigwam
  jp buildrandtown

buildhomedata:
  defb 4+160 ; X 16,9
  defw s_rainbow
  defb 6+160 ; X 16,9
  defw s_rainbow2
  defb 7+100 ; X 7,6
  defw s_thatchhousefront
  ;defb 12+100 ; X 7,6
  ;defw s_stonewallback;s_church;brickhouse
  ;defb 13+100 ; X 7,6
  ;defw s_stonewallfront;s_church;brickhouse
  defb 255 ; END OF LIST

buildhome:
  ld hl,buildhomedata
  call buildstaticroomdef
  ld hl,str_welcometo
  ld de,str_homesweethome
  ld a,0 ; DON'T SCROLL UP
  call statusbarprintparagraph
  jp buildwaterjumpback

; BUILD CROSS ROAD FROM HEDGE ROWS
buildcrossroaddata:
  defb 12+60       ; X 7,6
  defw s_hedgehoriz 
  defb 12+120       ; X 7,6
  defw s_hedgehoriz 
  defb 0+60         ; X 7,6
  defw s_hedgehoriz 
  defb 0+120         ; X 7,6
  defw s_hedgehoriz 
  defb 6+40         ; X 7,6
  defw s_hedgevert 
  defb 12+40         ; X 7,6
  defw s_hedgevert 
  defb 6+180         ; X 7,6
  defw s_hedgevert 
  defb 12+180         ; X 7,6
  defw s_hedgevert 
  defb 255          ; END OF LIST

buildcrossroad:
  ld hl,buildcrossroaddata
  domystaticroomwater:
  call buildstaticroomdef
  jp buildwaterjumpback

buildhorizroaddata:
  defb 12+60       ; X 7,6
  defw s_hedgehoriz 
  defb 12+120       ; X 7,6
  defw s_hedgehoriz 
  defb 0+60         ; X 7,6
  defw s_hedgehoriz 
  defb 0+120         ; X 7,6
  defw s_hedgehoriz 
  defb 8+60         ; X 7,6
  defw s_hedgehoriz 
  defb 8+120         ; X 7,6
  defw s_hedgehoriz 
  defb 255          ; END OF LIST

buildhorizroad:
  ld hl,buildhorizroaddata
  jr domystaticroomwater

buildvertroaddata:
  defb 6+0         ; X 7,6
  defw s_bush 
  defb 12+0         ; X 7,6
  defw s_bush 
  defb 6+60         ; X 7,6
  defw s_hedgevert 
  defb 12+60         ; X 7,6
  defw s_hedgevert 
  defb 6+120         ; X 7,6
  defw s_hedgevert 
  defb 12+120         ; X 7,6
  defw s_hedgevert 
  defb 6+180         ; X 7,6
  defw s_hedgevert 
  defb 12+180         ; X 7,6
  defw s_hedgevert 
  defb 255          ; END OF LIST

buildvertroad:
  ld hl,buildvertroaddata
  jr domystaticroomwater

; ------------ STONE WALL ---------------

buildstonewalltopleftdata:
  defb 13+100         ; X 7,6
  defw s_stonewalltopleft 
  defb 15+100         ; X 7,6
  defw s_stonewallhoriz
  defb 13+180         ; X 7,6
  defw s_stonewallvert
  defb 255          ; END OF LIST

buildstonewalltopleft:
  ld hl,buildstonewalltopleftdata
  jr domystaticroomwater

buildstonewalltoprightdata:
  defb 0+100         ; X 7,6
  defw s_stonewallhoriz
  defb 5+100         ; X 7,6
  defw s_stonewallhoriz
  defb 8+100         ; X 7,6
  defw s_stonewallhoriz
  defb 12+100         ; X 7,6
  defw s_stonewalltopright
  defb 13+180         ; X 7,6
  defw s_stonewallvert
  defb 255          ; END OF LIST

buildstonewalltopright:
  ld hl,buildstonewalltoprightdata
  jr domystaticroomwater

buildstonewallbottomleftdata:
  defb 13+80         ; X 7,6
  defw s_stonewallvert
  defb 13+100         ; X 7,6
  defw s_stonewallbottomleft 
  defb 15+100         ; X 7,6
  defw s_stonewallhoriz
  defb 13+40         ; X 7,6
  defw s_stonewallvert
  defb 255          ; END OF LIST

buildstonewallbottomleft:
  ld hl,buildstonewallbottomleftdata
  jr domystaticroomwater

buildstonewallbottomrightdata:
  defb 13+80         ; X 7,6
  defw s_stonewallvert
  defb 12+100         ; X 7,6
  defw s_stonewallbottomright
  defb 0+100         ; X 7,6
  defw s_stonewallhoriz
  defb 5+100         ; X 7,6
  defw s_stonewallhoriz
  defb 8+100         ; X 7,6
  defw s_stonewallhoriz
  defb 13+40         ; X 7,6
  defw s_stonewallvert
  defb 255          ; END OF LIST

buildstonewallbottomright:
  ld hl,buildstonewallbottomrightdata
  jp domystaticroomwater

buildstonewallvertdata:
  defb 13+180         ; X 7,6
  defw s_stonewallvert
  defb 13+100          ; X 7,6
  defw s_stonewallvert
  defb 13+40          ; X 7,6
  defw s_stonewallvert
  defb 255          ; END OF LIST

buildstonewallvert:
  ld hl,buildstonewallvertdata
  jp domystaticroomwater

buildstonewallhorizdata:
  defb 0+100         ; X 7,6
  defw s_stonewallhoriz
  defb 5+100         ; X 7,6
  defw s_stonewallhoriz
  defb 10+100         ; X 7,6
  defw s_stonewallhoriz
  defb 15+100         ; X 7,6
  defw s_stonewallhoriz
  defb 255          ; END OF LIST

buildstonewallhoriz:
  ld hl,buildstonewallhorizdata
  jp domystaticroomwater

buildstonewallarchwaydata:
  defb 0+100         ; X 7,6
  defw s_stonewallhoriz
  defb 4+100         ; X 7,6
  defw s_stonewallhoriz
  defb 11+100         ; X 7,6
  defw s_stonewallhoriz
  defb 15+100         ; X 7,6
  defw s_stonewallhoriz
  defb 9+100
  defw s_stonewallarchway
  defb 255          ; END OF LIST

buildstonewallarchway:
  ld hl,buildstonewallarchwaydata
  jp domystaticroomwater

; ------------ MOUNTAIN RANGE ----------------

buildmountainrangetopdata:
  defb 2+180 ; X
  defw s_bignewmountaintophalf
  defb 255 ; END OF LIST

buildmountainrangetop:
  ld hl, buildmountainrangetopdata
  call buildstaticroomdef
  buildmountainrange:
  ld b,3 ; MAX RAND OF WIGWAMS TO INSERT
  ld de,s_newmountain
  call insertspriterandtimes
  ld b,2 ; MAX RAND OF WIGWAMS TO INSERT
  ld de,s_bignewmountain
  call insertspriterandtimes
  jp buildwaterjumpback

buildmountainrangebottomdata:
  defb 2+40 ; X
  defw s_bignewmountain
  defb 255 ; END OF LIST

buildmountainrangebottom:
  ld hl,buildmountainrangebottomdata
  domystaticroommountain:
  call buildstaticroomdef
  jr buildmountainrange

buildmountainrangeleftdata:
  defb 16+140 ; X
  defw s_bignewmountainleft
  defb 255 ; END OF LIST

buildmountainrangeleft:
  ld hl,buildmountainrangeleftdata
  jr domystaticroommountain

buildmountainrangerightdata:
  defb 0+140 ; X
  defw s_bignewmountainright
  defb 255 ; END OF LIST

buildmountainrangeright:
  ld hl,buildmountainrangerightdata
  jr domystaticroommountain

buildborderfencehorizfilldata:
  defb 0+20,1,20,83,1
  defb 255

buildborderfencehoriz:
  ld hl,buildborderfencehorizfilldata
  call buildfill
ret

; FENCE DEFINITIONS
buildmountainblockbottom:
  call buildborderfencehoriz
  jr buildmountainrangebottom
buildlandfence:
  call buildborderfencehoriz
  jp buildwaterjumpback
buildsealandfenceleft:
  call buildborderfencehoriz
  jp buildlakeright
buildsealandfenceright:
  call buildborderfencehoriz
  jp buildlakeleft

; CHECK FOR STATIC MAP DEFINITIONS
checkstaticmapdef:
  ld hl,static_map_table
  staticmaploop:
    ld a,(hl)
    cp 255
    ret z  ; END OF LIST

    ; CHECK IF CURRENT MAP IS IN LIST
    ld a,(currblockid)
    cp (hl)
    jr z,insertstaticmapid
    inc hl
    inc hl
    inc hl
    jr staticmaploop
    
    insertstaticmapid:
    inc hl
    ld b,(hl)               ; GET POSITION OF ROOM IN BLOCK
    inc hl
    ld a,(hl)               ; GET ROOM ID TO INSERT

    ; INSERT BYTE INTO CURRENT LOCAL MAP TABLE
    push hl
    ld hl,gamemap2
    ld l,b
    ld (hl),a
    pop hl
    ; CHECK NEXT DEFINITION
    inc hl
jr staticmaploop

;jumpbackstaticmap:
;    ret

; INPUTS
; DE = TILE SPRITE ADDRESS
insertspritetilesrandompos:
  call rand32
  sub 4
  ret c
  call insspriterandpos
ret

lastinsertpos:
  defb 255   ; 255 MARKS AS NOT USED
lastinsertpossaloon:
  defb 255   ; 255 MARKS AS NOT USED

; INPUTS
; DE = TILE SPRITE ADDRESS
insspriterandpos:
  push bc

  push de  ; MOVE DE TO UX
  pop ix

  ld a,tilemap_width_tiles-1   ; GET WIDTH OF SCREEN
  sub (ix+0)                   ; SUB WIDTH OF SPRITE
  ld b,a                       ; STORE IN B
  call rand32                  ; GET RANDOM NUMBER
  ld c,a                       ; BACKUP A TO C

  ld b,tilemap_height_tiles+1  ; GET HEIGHT OF SCREEN (ALLOW SLIGHTLY OFF SCREEN)
  call rand32
  sub (ix+1)                   ; CHECK WE AREN'T OFF TOP OF SCREEN
  jr c, setminypos
  add (ix+1)
  ld b,a                       ; BACKUP A TO B
  jr convxy

  setminypos:
  ld b,(ix+1)

  convxy:
  call insertspritetilesxy
  pop bc
ret

; RECORD LAST INSERTION POINT FOR SHOP
recordtilepos:
  ld a,l
  ld (lastinsertpos),a         ; RECORD INSERT POS OF SPRITE FOR FUTURE USE (SHOP TITLE)
  xor a
  ld (hasshop),a               ; CLEAR HAS SHOP VARIABLE SO WE DON'T RECORD SUBSEQUENT TILE POSITIONS
  jp resumetileinsert
; RECORD LAST INSERTION POINT FOR SALOON
recordtilepossaloon:
  ld a,l
  ld (lastinsertpossaloon),a        ; RECORD INSERT POS OF SPRITE FOR FUTURE USE (TITLE)
  xor a
  ld (hassaloon),a                  ; CLEAR HAS SALOON VARIABLE SO WE DON'T RECORD SUBSEQUENT TILE POSITIONS
  jp resumetileinsertsaloon

; INSERT A LARGER SPRITE INTO THE TILEMAP ARRAY AUTOMATICALLY
; INPUTS 
; C = X COORD TILE
; B = Y COORD TILE
insertspritetilesxy:
  call convxytotilenum
  ld b,a

; INSERT A LARGER SPRITE INTO THE TILEMAP ARRAY AUTOMATICALLY
; DE = POINTER TO ARRAY OF SPRITE TILE IDS
; B = TILE NUMBER TO START DISPLAYING AT
; C = OBJECT TYPE, 1 = LAND, 2 = SEA
insertspritetiles:
  push bc ; STORE START POSITION FOR LOOPS
  push de ; BACK UP SPRITE ADDRESS IF WE HAVE TO CALL MULTIPLE TIMES
  ld c,b  ; BACK UP B

  ; CHECK OBJECT TILEMAP TO MAKE SURE WE DON'T OVERWRITE EXISTING SPRITE
  ld hl,tilemap2
  ld l,b
 
  push de ; MOVE DE TO IX
  pop ix

  ld b,(ix+0) ; GET SPRITE WIDTH IN TILES
  inc de
  ; SKIP HEIGHT DEF
  inc de      
  ; SKIP DEFAULT OBJECT TYPE
  inc de
  ; CHECK TILEMAP FOR OBSTACLES TO INSERTING SPRITE
  checkloop:
    ld a,(hl)
    or a;cp 0
    jp nz,popoff ; DO NOT INSERT IF WE FIND SPACE OCCUPIED
    inc l
    inc de
  djnz checkloop
  ; CHECK TO SEE IF WE HAVE REACHED END OF SPRITE DEFINITION
  ld a,(de)
  cp 254
  jr z,donecheck ; FINISHED CHECKING LOWER LEVEL
  cp 255
  jr z,donecheck ; FINISHED CHECKING LOWER LEVEL

  moveuprow:
    ld b,(ix+0)              ; RESTORE WIDTH COUNT 
    ld a,l                   ; MOVE UP A ROW
    sub tilemap_width_tiles
    sub b
    jp c,popoff ; WE HAVE MOVED OFF SCREEN - DON'T INSERT SPRITE
    ld l,a
    inc de
    jr checkloop

  donecheck:
  ; ENTER TILES ON TO ACTUAL SPRITE TILE MAP
  ; FIND LEFT TOP POSITION TO PRINT SPRITE AT ON TILEMAP
  ld hl,tilemap0
  ld l,c
  pop de
  push de ; BACK UP SPRITE ADDRESS IF WE HAVE TO CALL MULTIPLE TIMES 
  inc de ; MOVE FROM WIDTH PARAMETER TO TILE DATA
  inc de ; SKIP HEIGHT PARAMETER

  ; SELF MODIFY CODE TO INSERT DEFAULT OBJECT TYPE
  ; 1 = STANDARD OBJECT
  ; 2 = WATER
  ; 3 = MOUNTAIN
  ; 4 = VERTICALLY FLIPPED STANDARD OBJECT 
  ld a,(de)
  ld (selfmodify_objtype-1),a 
  inc de           ; SKIP DEFAULT OBJECT TYPE PARAMETER
  ld b, 0          ; STORE X POS
  ld c, 0          ; SET LEVEL CHECK
  myloop:
    ld a,(de)
    or a;cp 0             
    jr z,skipmarkoccupied: ; EMPTY TILE INSIDE SPRITE
    cp 253
    jr z,newrow            ; WE MOVED TO ANOTHER HORIZONTAL ROW ON SPRITE
    cp 254
    jr z,levelup           ; WE MOVED TO THE UPPER LEVEL TILE MAP
    cp 1                   ; REPEAT LAST CHAR FOUR TIMES
    jr z,repeatlastcharfourtimes
    cp 255
    jr z,endofsprite       ; WE REACHED THE END OF THE SPRITE DATA
    ld (hl),a
    
    ; CHECK IF WE HAVE MOVED ON TO TOP LEVEL
    ; IF SO DO NOT MARK TILEMAP AS OCCUPIED
    ld a,c
    cp 1
    jr z,skipmarkoccupied

    ; CHECK IF OBJECT IS MOUNTAIN
    ld a,(de)
    cp mountaintile
    jr z,checkmountainobjectid
    cp mountaintile2
    jr z,checkmountainobjectid
    cp mountaintile3
    jr z,checkmountainobjectid

    ; MARK OCCUPIED IN TILEMAP 2
    push hl
    ld a,l
    ld hl,tilemap2
    ld l,a
    ld (hl),1:selfmodify_objtype ; SELF MODIFYING CODE FOR OBJECT TYPE
    pop hl
    skipmarkoccupied:

    inc l
    inc de
    inc b ; REMEMBER WIDTH OF SPRITE
  jr myloop
 
  repeatlastcharfourtimes:
    push hl
    ; REPEAT LAST BYTE FOUR TIMES WE HAVE COPIED OBJECT TILEMAP
    ld a,l
    ld hl,tilemap2
    ld l,a

    dec hl
    ld a,(hl)
    inc hl
    ld (hl),a  
    inc hl
    ld (hl),a  
    inc hl
    ld (hl),a  
    inc hl
    ld (hl),a  
    inc hl
    pop hl

    ; REPEAT LAST BYTE FOUR TIMES WE HAVE COPIED GRAPHIC TILEMAP
    dec hl
    ld a,(hl)
    inc hl
    ld (hl),a  
    inc hl
    inc b ; REMEMBER WIDTH OF SPRITE
    ld (hl),a  
    inc hl
    inc b ; REMEMBER WIDTH OF SPRITE
    ld (hl),a  
    inc hl
    inc b ; REMEMBER WIDTH OF SPRITE
    ld (hl),a  
    inc hl
    inc b ; REMEMBER WIDTH OF SPRITE

    inc de ; MOVE PAST REPEAT CHAR
  jr myloop

  levelup:
    ld a,l
    ld hl,tilemap1     
    ld l,a
    ld c,1 ; SET CURRENT LEVEL CHECK

    newrow: ; MOVE UP A TILE ROW ON SCREEN BUT NOT IN HEIGHT - EG WATER/FIELD
    ld a,l
    sub tilemap_width_tiles ; FIND NEXT ROW POSITION (MINUS AS WE ARE GOING UP IN HEIGHT)
    sub b                   ; FIND LEFT POSITION OF SPRITE AGAIN
    jr c, endofsprite       ; DO NOT PRINT IF OUT OF SCREEN
    ld b,0                  ; RESET ROW COUNT
    ld l,a 
    inc de
  jr myloop
 
  endofsprite:
  
  ; CHECK IF WE NEED TO MODIFY OBJECT TILE MAP TO INSERT DOOR, ETC
  inc de
  ld a,(de)
  or a;cp 0
  jr z, popoff
  ; KEEP COPY OF END OF SPRITE DATA LOCATION
  push de
  pop ix
  ; FIND START OF SPRITE IN TILE MAP AGAIN
  pop de
  pop bc
  ld hl,tilemap2
  ; ADD X / Y LOCATION TO FIND DOOR, ETC
  ld a,b
  add (ix+1)
  ld b,(ix+2)
  loopyloop: 
    sub tilemap_width_tiles
  djnz loopyloop
  ld l,a
  ; ENTER CUSTOM OBJECT TILEMAP NUMBER
  ld a,(ix+0)
  ld (hl),a
  ;call recordrandomchartile

  ld a,(hasshop)
  cp 1
  jp z,recordtilepos
  resumetileinsert:
  ld a,(hassaloon)
  cp 1
  jp z,recordtilepossaloon
  resumetileinsertsaloon:

  ret
  
  popoff:
  pop de
  pop bc  
ret

checkmountainobjectid:
  push hl
  ld a,l
  ld hl,tilemap2
  ld l,a
  ld (hl),3
  pop hl
  jr skipmarkoccupied

; INSERT A LARGER SPRITE INTO THE TILEMAP ARRAY AUTOMATICALLY
; THIS ROUTINE DOES NOT CHECK FOR EXISTING SPRITE DATA
; USE THIS TO BUILD LARGE SPRITES, EG. RIVERS, OUT OF SMALLER OBJECTS
; INPUTS 
; C = X COORD TILE
; B = Y COORD TILE
insertspritetilesxynocheck:
  call convxytotilenum
  ld b,a

; INSERT A LARGER SPRITE INTO THE TILEMAP ARRAY AUTOMATICALLY
; DE = POINTER TO ARRAY OF SPRITE TILE IDS
; B = TILE NUMBER TO START DISPLAYING AT
insertspritetilesnocheck:
  push bc ; STORE START POSITION FOR LOOPS
  push de
  ld c,b  ; BACK UP B
  jp donecheck ; JUMP STRAIGHT TO SPRITE INSERTION

minemountaindata:
  defb 12+80;,5         ; X, Y
  defw s_minemountain ; SPRITE
  defb 255          ; END OF LIST

buildminemountain:
  ld hl,minemountaindata
  call buildstaticroomdef
  ld hl,str_welcometo
  ld de,str_abandonedmine
  ld a,0 ; DON'T SCROLL UP
  call statusbarprintparagraph
  jp buildwaterjumpback

minemountain2data:
  defb 12+80;,5         ; X, Y
  defw s_minemountain2 ; SPRITE
  defb 255          ; END OF LIST

buildminemountain2:
  ld hl,minemountain2data
  jp domystaticroomwater

archeryrangedata:
  defb 4+100;,6         ; X, Y
  defw s_target      ; SPRITE
  defb 7+80;,5         ; X, Y
  defw s_target      ; SPRITE
  defb 10+60;,4        ; X, Y
  defw s_target      ; SPRITE
  defb 13+40;,3        ; X, Y
  defw s_target      ; SPRITE
  defb 16+20;,2        ; X, Y
  defw s_target      ; SPRITE
  ;defb 4,8         ; X, Y
  ;defw fencehoriz  ; SPRITE
  ;defb 5,8         ; X, Y
  ;defw fencehoriz  ; SPRITE
  ;defb 6,8         ; X, Y
  ;defw fencehoriz  ; SPRITE
  ;defb 7,8         ; X, Y
  ;defw fencehoriz  ; SPRITE
  ;defb 8,8         ; X, Y
  ;defw fencehoriz  ; SPRITE
  ;defb 9,8         ; X, Y
  ;defw fencehoriz  ; SPRITE
  ;defb 10,8         ; X, Y
  ;defw fencehoriz  ; SPRITE
  ;defb 11,8         ; X, Y
  ;defw fencehoriz  ; SPRITE
  ;defb 12,8         ; X, Y
  ;defw fencehoriz  ; SPRITE
  ;defb 13,8         ; X, Y
  ;defw fencehoriz  ; SPRITE
  ;defb 14,8         ; X, Y
  ;defw fencehoriz  ; SPRITE
  ;defb 15,8         ; X, Y
  ;defw fencehoriz  ; SPRITE
  ;defb 16,8         ; X, Y
  ;defw fencehoriz  ; SPRITE
  ;defb 18+160;,9        ; X, Y
  ;defw s_oldmanarchery ; SPRITE
  defb 255         ; END OF LIST

buildarcheryrange:
  ;call cleartrees
  ld hl,archeryrangedata
  call buildstaticroomdef
  ; DON'T BUILD TREES
  jp jumpbackscreenfoliagey;buildwaterjumpback
  ;ret
  ;jp jumpbackstaticmap


; INPUTS
; HL = PTR TO DATA BLOCK FOR FILL
; DATA BLOCK
; A = START TILE
; B = FILL HEIGHT IN TILES
; C = FILL WIDTH IN TILES
; D = TILE ID GRAPHIC
; E = OBJECT TILE ID
buildfill:
  ld a,(hl)     ; START TILE
  cp 255        ; IF END OF LIST
  ret z

  ; LOAD FILL DATA BLOCK INTO REGISTERS AND CALL FILL ROUTINE
  inc hl
  ld b,(hl)     ; FILL HEIGHT    
  inc hl
  ld c,(hl)     ; FILL WIDTH   
  inc hl
  ld d,(hl)     ; TILE ID    
  inc hl
  ld e,(hl)     ; OBJ TILE ID    
  inc hl
  
  push hl
  call fillmap ; FILL ROUTINE
  pop hl

  jr buildfill

topleftfilldata:
  defb 109,5,11,water,2
  defb 255 ; END OF LIST

buildlaketopleft:
  ld hl,buildrivertopleftdata
  call buildstaticroomdef
  ld hl,topleftfilldata
  jr dobuildfill
;------------------------------------
; ISLAND
;------------------------------------

islandtopleftfilldata:
  defb 0,5,20,water,2
  defb 100,5,6,water,2
  defb 255

buildislandtopleft:
  ld hl,buildrivertopleftdata
  call buildstaticroomdef
  ld hl,islandtopleftfilldata
  jr dobuildfill

islandtoprightfilldata:
  defb 0,5,20,water,2
  defb 109,5,11,water,2
  defb 255

buildislandtopright:
  ld hl,buildrivertoprightdata
  call buildstaticroomdef
  ld hl,islandtoprightfilldata
  jr dobuildfill

islandbottomrightfilldata:
  defb 100,5,20,water,2
  defb 8,5,12,water,2
  defb 255

buildislandbottomright:
  ld hl,buildriverbottomrightdata
  call buildstaticroomdef
  ld hl,islandbottomrightfilldata
  jr dobuildfill

islandbottomleftfilldata:
  defb 100,5,20,water,2
  defb 0,5,7,water,2
  defb 255

buildislandbottomleft:
  ld hl,buildriverbottomleftdata
  call buildstaticroomdef
  ld hl,islandbottomleftfilldata
  jr dobuildfill

;-----------------------------------
; LAKE
;-----------------------------------

lakebottomfilldata:
  defb 0,5,20,water,2
  defb 255

buildlakebottom:
  ld hl,buildriverhorizdata
  call buildstaticroomdef
  ld hl,lakebottomfilldata
  jr dobuildfill

laketopfilldata:
  defb 100,5,20,water,2
  defb 255

buildlaketop:
  ld hl,buildriverhorizdata
  call buildstaticroomdef
  ld hl,laketopfilldata
  dobuildfill:
  call buildfill
  jp buildwaterjumpback

lakemidfilldata:
  defb 0,10,20,water,2
  defb 255

buildlakemid:
  ld hl,lakemidfilldata
  call buildfill
  ; CLEAR WITH BLUE - FASTER THAN REDRAWING EVERY TILE
  ld a,15
  call ClearScreen
  jp buildwaterjumpback

laketoprightfilldata:
  defb 100,5,6,water,2
  defb 255

buildlaketopright:
  ld hl, buildrivertoprightdata
  call buildstaticroomdef
  ld hl,laketoprightfilldata
  jr dobuildfill

lakeleftfilldata2:
  defb 9,10,11,water,2
  defb 255

buildlakeleft:
  ld hl,buildriververtleftdata
  call buildstaticroomdef
  ld hl,lakeleftfilldata2
  jr dobuildfill

lakerightfilldata:
  defb 0,10,7,water,2
  defb 255

buildlakeright:
  ld hl,buildriververtleftdata
  call buildstaticroomdef
  ld hl,lakerightfilldata
  jr dobuildfill

lakebottomleftfilldata:
  defb 9,5,11,water,2
  defb 255

buildlakebottomleft:
  ld hl, buildriverbottomleftdata
  call buildstaticroomdef
  ld hl,lakebottomleftfilldata
  jr dobuildfill

lakebottomrightfilldata:
  defb 0,5,6,water,2
  defb 255

buildlakebottomright:
  ld hl, buildriverbottomrightdata
  call buildstaticroomdef
  ld hl,lakebottomrightfilldata
  jr dobuildfill

;--------------------------------------------
; RIVER ISLAND
;--------------------------------------------

buildrivertopleftdata:
  defb 5+140;,8 ; X, Y
  defw s_water ; SPRITE
  defb 10+140;,8
  defw s_waterhoriz
  defb 5+220;,12
  defw s_watervertical
  defb 15+140;,8
  defw s_waterhoriz
  defb 255 ; END OF LIST

buildrivertopleft:
  ld hl,buildrivertopleftdata
  call buildstaticroomdef
  ld b,anim_watershimmer1 ; LOWER SPRITE ID IN ANIM TABLE
  ld c,107                ; TILE NUMBER
  call activatetileanim 
  ld b,anim_watershimmer2 ; LOWER SPRITE ID IN ANIM TABLE
  ld c,128                ; TILE NUMBER
  domyactivetileanimwater:
  call activatetileanim 
  jp buildwaterjumpback

buildrivertoprightdata:
  defb 4+140;,8
  defw s_water
  defb 0+140;,8
  defw s_waterhoriz
  defb 5+220;,12
  defw s_watervertical2
  defb 255 ; END OF LIST

buildrivertopright:
  ld hl,buildrivertoprightdata
  call buildstaticroomdef
  ld b,anim_watershimmer1 ; LOWER SPRITE ID IN ANIM TABLE
  ld c,106                ; TILE NUMBER
  call activatetileanim 
  ld b,anim_watershimmer2 ; LOWER SPRITE ID IN ANIM TABLE
  ld c,127                ; TILE NUMBER
  jr domyactivetileanimwater

buildriverhorizdata:
  defb 10+120;,7 ; X, Y
  defw s_waterhorizthin ; SPRITE
  defb 15+140;,8
  defw s_waterhoriz
  defb 5+140;,8
  defw s_waterhoriz
  defb 0+140;,8
  defw s_waterhoriz
  defb 255 ; END OF LIST

buildriverhoriz:
  ld hl,buildriverhorizdata
  call buildstaticroomdef
  ld b,anim_watershimmer1 ; LOWER SPRITE ID IN  TABLE
  ld c,87                 ; TILE NUMBER
  call activatetileanim 
  ld b,anim_watershimmer2 ; LOWER SPRITE ID IN ANIM TABLE
  ld c,108                ; TILE NUMBER
  jr domyactivetileanimwater

buildriverhoriz2data:
  defb 15+140;,8 ; X, Y
  defw s_waterhoriz ; SPRITE
  defb 10+140;,8
  defw s_waterhoriz
  defb 5+120;,7
  defw s_waterhorizthin
  defb 0+140;,8
  defw s_waterhoriz
  defb 6+140;,8
  defw s_bridge
  defb 255 ; END OF LIST

buildriverhoriz2:
  ld hl, buildriverhoriz2data
  call buildstaticroomdef
  ld b,5 ; HEIGHT
  ld c,2 ; WIDTH
  ld a,67 ; START TILE
  call clearobjectmapbridge  
  ld b,anim_watershimmer1 ; LOWER SPRITE ID IN ANIM TABLE
  ld c,92                 ; TILE NUMBER
  call activatetileanim 
  ld b,anim_watershimmer2 ; LOWER SPRITE ID IN ANIM TABLE
  ld c,113                ; TILE NUMBER
  jr domyactivetileanimwater

buildriververtleftdata:
  defb 5+20;,2           ; X, Y
  defw s_watervertical ; SPRITE
  defb 6+120;,7
  defw s_watervertical2
  defb 5+220;,12
  defw s_watervertical
  defb 255

buildriververtleft:
  ld hl,buildriververtleftdata
  call buildstaticroomdef
  ld b,anim_watershimmer1 ; LOWER SPRITE ID IN ANIM TABLE
  ld c,87                 ; TILE NUMBER
  call activatetileanim 
  ld b,anim_watershimmer2 ; LOWER SPRITE ID IN ANIM TABLE
  ld c,108                ; TILE NUMBER
  jp domyactivetileanimwater

buildriverbottomrightdata:
  defb 4+140;,8
  defw s_water
  defb 5+60;,4
  defw s_watervertical2
  defb 0+140;,8
  defw s_waterhoriz
  defb 255

buildriverbottomright:
  ld hl, buildriverbottomrightdata
  call buildstaticroomdef
  ld b,anim_watershimmer1 ; LOWER SPRITE ID IN ANIM TABLE
  ld c,106                ; TILE NUMBER
  call activatetileanim 
  ld b,anim_watershimmer2 ; LOWER SPRITE ID IN ANIM TABLE
  ld c,127                ; TILE NUMBER
  jp domyactivetileanimwater

buildriverseatopdata:
  defb 5+140;,7
  defw s_waterhoriz
  defb 10+140;,8
  defw s_waterhoriz
  defb 5+60;,12
  defw s_watervertical2
  defb 0+140;,8
  defw s_waterhoriz
  defb 15+140;,8
  defw s_waterhoriz
  defb 5+220;,12
  defw s_watervertical3
  defb 255

riverseatopfilldata:
  defb 0,6,20,water,2
  defb 126,1,5,water,2
  defb 255

buildriverseatop:
  ld hl,buildriverseatopdata
  call buildstaticroomdef
  ld hl,riverseatopfilldata
  jp dobuildfill

riverseabottomfilldata:
  defb 100,5,20,water,2
  defb 85,1,1,water,2
  defb 68,1,1,water,2
  defb 255

buildriverseabottom:
  ld hl,buildriverseatopdata
  call buildstaticroomdef
  ld hl,riverseabottomfilldata
  jp dobuildfill

buildriverbottomleftdata:
  defb 5+140;,8   ; X, Y
  defw s_water ; SPRITE
  defb 5+60;,4
  defw s_watervertical
  defb 15+140;,8
  defw s_waterhoriz
  defb 10+140;,8
  defw s_waterhoriz
  defb 255

buildriverbottomleft:
  ld hl, buildriverbottomleftdata
  call buildstaticroomdef
  ld b,anim_watershimmer1 ; LOWER SPRITE ID IN ANIM TABLE
  ld c,106                ; TILE NUMBER
  call activatetileanim 
  ld b,anim_watershimmer2 ; LOWER SPRITE ID IN ANIM TABLE
  ld c,127                ; TILE NUMBER
  jp domyactivetileanimwater

;buildtownindian:
;  ld b,7 ; Y TILE POS
;  ld c,10 ; X TILE POS
;  ld de,s_water
;  call insertspritetilesxynocheck
;  ld b,16 ; LOWER SPRITE ID IN ANIM TABLE
;  ld c,94  ; TILE NUMBER
;  call activatetileanim 
;  ld b,17 ; LOWER SPRITE ID IN ANIM TABLE
;  ld c,73  ; TILE NUMBER
;  call activatetileanim 

;  ld b,14 ; LOWER SPRITE ID IN ANIM TABLE
;  ld c,86  ; TILE NUMBER
;  call activatetileanim 

;  ld b,12 ; MAX RAND OF WIGWAMS TO INSERT
;  ld de,s_wigwam
;  call insertspriterandtimes

;  jp jumpbackstaticmap

;cleartrees:
;  ; DON'T LET TREES GROW IN CASTLE
;  ld b,10   ; HEIGHT
;  ld c,20   ; WIDTH
;  ld a,0    ; START TILE
;  ld d,0    ; TILE ID
;  ld e,254  ; OBJECT ID
;  call fillmap 
;  ; MAKE LAWN
;  ld b,30 
;  ld d,2  
;  jp dograsstile

buildcastle:
  ld hl, buildcastledata
  call buildstaticroomdef
  ; DON'T BUILD TREES
  jp jumpbackscreenfoliagey

buildcastledata:
  defb 7+100;,6
  defw s_woodenroof
  defb 4+100;,6
  defw s_castle
  defb 11+100;,6
  defw s_castle
  defb 7+140;,8
  defw s_castlegate
  defb 4+160;,9
  defw s_castle
  defb 11+160;,9
  defw s_castle
  defb 255              ; END OF LIST

buildstaticroomdef:
  ld a,(hl)
  cp 255 ; HAVE WE REACHED END OF LIST?
  ret z

  ; BUILD ROOM
  ld b,a ; GET TILE POSITION IN B
  inc hl

  ; LOAD SPRITE DATA
  ld e,(hl)  
  inc hl
  ld d,(hl)
  inc hl
  push hl
  call insertspritetilesnocheck
  pop hl
  jr buildstaticroomdef

; INSERT STATIC SPRITES ON TILEMAP FOR QUESTS
checkinsertquestspritesstatic:
  ld iy,quest_data
  ld bc,11
  push bc
  jr checkinsertquestspritesloop
; INSERT RANDOM SPRITES ON TILEMAP FOR QUESTS
checkinsertquestspritesrandom:
  ld iy,quest_data_random
  ld bc,11
  push bc
  jr checkinsertquestspritesloop
; INSERT STATIC SPRITES ON TILEMAP FOR QUESTS
checkinsertquestsprites:
  ld iy,quests_fixed_sprites
  ld bc,7
  push bc
  checkinsertquestspritesloop:
  ; REURN IF WE REACH END OF LIST
  ld a,(iy+0)
  cp 255
  jr z,fininsquestspri        
  ; CHECK IF STILL ACTIVE
  or a;cp 0
  jr z,checknextsprite

  ; CHECK IF QUEST SPRITE IS IN CURRENT TILEMAP
  ld a,(tilemap_cur)       
  cp (iy+1)
  jr nz,checknextsprite
  ld a,(tilemap_cury)
  cp (iy+2)
  jr nz,checknextsprite
  ; IF THE OBJECT IS IN A BUILDING AND WE ARE NOT, SKIP 
  ld a,(inbuilding)
  cp (iy+3)
  jr nz,checknextsprite 
  ; IF OBJECT IS NOT IN BUILDING THEN SKIP BUILDING ID CHECK
  ld a,(iy+3)
  or a;cp 0
  jr z,insquestspr
  ; IF WE ARE CHECKING RANDOM SPRITE DATA, WE HAVE TO CHECK EXTRA ROOM ID NUMBER
  ; IF WE ARE CHECKING FIXED SPRITES WE MUST SKIP THIS PART
  ; AS THE FIXED SPRITE STRUCTURE DOESN'T HAVE THIS INFORMATION
  ld a,1:doroomidcheckminusone
  or a
  jr z,insquestspr
  ; CHECK BUILDING ID
  ld a,(tilenum_cur)
  cp (iy+10)
  jr nz,checknextsprite  

  insquestspr:
    ; INSERT QUEST SPRITE
    ld b,(iy+4) ; LOAD TILE POSITION

  ; IF SELECTED TILE IS OCCUPIED
  ; CHECK / FIND EMPTY SPACE TO MAKE SURE IT DEFINITELY GETS INSERTED
  ld hl,tilemap2
  checkanotheremptyspace:
    ld l,b
    ld a,(hl)
    or a; cp 0
    jr z,foundemptyspace
    inc b
    jr checkanotheremptyspace

  foundemptyspace:
    ld (iy+4),b ; RECORD NEW TILE LOCATION IN QUEST DATA IF WE MOVED TO EMPTY SPACE
    ld e,(iy+5) ; LOAD TILE SPRITE DATA INTO DE
    ld d,(iy+6) ; LOAD TILE SPRITE DATA INTO DE
    call insertspritetiles

  checknextsprite:
    pop bc
    add iy,bc
    push bc
  jr checkinsertquestspritesloop
   
  fininsquestspri:
  pop bc
ret

; INPUTS
; HL = TEXT TO PRINT
; B = NUMBER OF CHARACTERS TO GET
;getstringinput:
;  call statusbarprintparagraph
;  ld hl,screentext4
;  call statusbarscrollnewline

;  ; CLEAR BUFFER BEFORE GETTING NEW CHAR
;  cleartextbuffloop:
;    call km_read_char
;    jr nc, gettextloop
;  jr cleartextbuffloop

;  gettextloop:
;    call km_wait_char

;    displaychar:
;    cp &7F ; BACKSPACE
;    jr z,dobackspace
;    cp &0D ; RETURN
;    ret z

;    ld (hl),a
;    inc hl
;    jr printcharonscreen

;    dobackspace:
;    ld a,b            ;  DO NOT GO PAST START OF STRING
;    cp 16
;    jr z, gettextloop
;    dec hl
;    ld (hl)," "
;    inc b
;    inc b

;    printcharonscreen:
;    push hl
;    push bc
;    call updatestatusbartext
;    pop bc
;    pop hl
;  djnz gettextloop
;ret

; INPUTS
genrandomscreenname:
  ld de,str_temp
  ; COPY FIRST RANDOM NAME
  ; GET FIRST NAME INTO DE
  ld a,numrandnames
  ld b,a
  call rand32
  ld hl,firstrandnameslist
  call vectorlookup
  ex de,hl
  call copystr
  push de ; SAVE CURRENT POSITION IN TEMP STR

  ; COPY SECOND RANDOM NAME
  ; GET SECOND NAME INTO DE
  ld a,numrandnames
  ld b,a
  call rand32
  ld hl,lastrandnameslist
  call vectorlookup
  pop hl
  ex de,hl
  call copystr
  ldi ; COPY 255 MARKER
  ld hl,str_welcometo
  ld de,str_temp
  ld a,0 ; DON'T SCROLL UP
  jp statusbarprintparagraph