; A LOCKED QUEST SIGNIFIES THAT IT IS NOT POSSIBLE TO COMPLETE
; WITHOUT ANOTHER QUEST BEING COMPLETED.
; E.G. INDIANS NEED WATER FOR PRISONER EXCHANGE
; BUT IF PRISONER EXCHANGE QUEST HASN'T BEEN ACCEPTED INDIANS
; WILL NOT ASK FOR WATER.

num_quests equ 3
; FIXED SPRITES TO INSERT FOR QUESTS
quests_fixed_sprites:
  defb 1               ; ACTIVE 
  defb 1               ; X MAP SCREEN
  defb 1               ; Y MAP SCREEN
  defb 1               ; IN BUILDING
  defb 55              ; X TILE LOCATION
  defw s_mimomum       ; PTR TO SPRITE DATA

  ; MONEY BAG
  defb 1               ; ACTIVE 
  defb 1               ; X MAP SCREEN
  defb 1               ; Y MAP SCREEN
  defb 1               ; IN BUILDING
  defb 65              ; X TILE LOCATION
  defw s_moneybag      ; PTR TO SPRITE DATA

  ; PARCEL
  defb 1               ; ACTIVE 
  defb 1               ; X MAP SCREEN
  defb 1               ; Y MAP SCREEN
  defb 0               ; IN BUILDING
  defb 154             ; X TILE LOCATION
  defw s_parcel        ; PTR TO SPRITE DATA

  ; KEY
  defb 1               ; ACTIVE 
  defb 1               ; X MAP SCREEN
  defb 1               ; Y MAP SCREEN
  defb 0               ; IN BUILDING
  defb 156             ; X TILE LOCATION
  defw s_key           ; PTR TO SPRITE DATA

  ; CLIMBING ROPE IN WESTERN ZONE
  defb 1               ; ACTIVE 
  defb 84              ; X MAP SCREEN
  defb 37              ; Y MAP SCREEN
  defb 0               ; IN BUILDING
  defb 155             ; X TILE LOCATION
  defw s_rope          ; PTR TO SPRITE DATA

  ; MAP FOUND IN MAZE
  defb 1               ; ACTIVE 
  defb 22              ; X MAP SCREEN
  defb 22              ; Y MAP SCREEN
  defb 0               ; IN BUILDING
  defb 165             ; X TILE LOCATION
  defw s_map           ; PTR TO SPRITE DATA

  ; NARNIA DOOR IN HOUSE IN MAZE
  defb 1               ; ACTIVE 
  defb 22              ; X MAP SCREEN
  defb 22              ; Y MAP SCREEN
  defb 4               ; IN BUILDING
  defb 29              ; X TILE LOCATION
  defw s_narniadoor    ; PTR TO SPRITE DATA

  ; NARNIA DOOR IN HOUSE IN NARNIA
  defb 1                  ; ACTIVE 
  defb 23                 ; X MAP SCREEN
  defb 49                 ; Y MAP SCREEN
  defb 4                  ; IN BUILDING
  defb 29                 ; X TILE LOCATION
  defw s_narniadoorback   ; PTR TO SPRITE DATA
  defb 255                ; END OF OBJECT DATA LIST

; THIS IS A TABLE OF ALL QUESTS
; QUESTS START AT 10
quest_data:
  ; KIDNAPPED SON
  ; QUEST OBJECT STARTS AT 10 BECAUSE EMPTY SPACE IS 0 AND TREES, ETC ARE 1
  defb 1             ; QUEST NUMBER - OVERRIDES OBJECT QUEST LOOKUP
  defb 46            ; 1 X MAP SCREEN
  defb 35            ; 2 Y MAP SCREEN
  defb 0             ; 3 IN BUILDING
  defb 50            ; 4 TILE LOCATION
  defw s_settlerman  ; SPRITE DATA
  defb moneybag      ; 7 ITEM REWARD
  defb 1             ; 8 ITEM SOUGHT
  defb 1             ; 9 0 = LOCKED, 1 AVAILABLE, 2 = ACCEPTED, 3 = COMPLETED
  defb 0             ; 10 ROOM ID IF IN BUILDING (TILE ID OF DOOR)
  ; INDIAN PEACE PIPE
  defb 11            ; QUEST NUMBER - OVERRIDES OBJECT QUEST LOOKUP
  defb 1             ; 1 X MAP SCREEN
  defb 1             ; 2 Y MAP SCREEN
  defb 0             ; 3 IN BUILDING
  defb 51            ; 4 TILE LOCATION
  defw s_indianman   ; SPRITE DATA
  defb 11            ; 7 ITEM REWARD
  defb 14            ; 8 ITEM SOUGHT
  defb 1             ; 9 0 = LOCKED, 1 AVAILABLE, 2 = ACCEPTED, 3 = COMPLETED
  defb 0             ; 10 ROOM ID IF IN BUILDING (TILE ID OF DOOR)
  ; LOVE LETTER
  defb 12            ; QUEST NUMBER - OVERRIDES OBJECT QUEST LOOKUP
  defb 1             ; 1 X MAP SCREEN
  defb 1             ; 2 Y MAP SCREEN
  defb 0             ; 3 IN BUILDING
  defb 52            ; 4 TILE LOCATION
  defw s_indianwoman ; SPRITE DATA
  defb moneybag      ; 7 ITEM REWARD
  defb 13            ; 8 ITEM SOUGHT
  defb 1             ; 9 0 = LOCKED, 1 AVAILABLE, 2 = ACCEPTED, 3 = COMPLETED
  defb 0             ; 10 ROOM ID IF IN BUILDING (TILE ID OF DOOR)
  ; LOVE LETTER - ONE WAY QUEST. ONLY REQUIRES RECEIPT OF OBJECT
  defb 13            ; QUEST NUMBER - OVERRIDES OBJECT QUEST LOOKUP
  defb 1             ; 1 X MAP SCREEN
  defb 1             ; 2 Y MAP SCREEN
  defb 0             ; 3 IN BUILDING
  defb 53            ; 4 TILE LOCATION
  defw s_indianman   ; SPRITE DATA
  defb 13            ; 7 ITEM REWARD
  defb 1             ; 8 ITEM SOUGHT
  defb 1             ; 9 0 = LOCKED, 1 AVAILABLE, 2 = ACCEPTED, 3 = COMPLETED
  defb 0             ; 10 ROOM ID IF IN BUILDING (TILE ID OF DOOR)
  ; ARCHERY RANGE
  defb 5            ; QUEST NUMBER - OVERRIDES OBJECT QUEST LOOKUP
  defb 16             ; 1 X MAP SCREEN
  defb 55             ; 2 Y MAP SCREEN
  defb 0             ; 3 IN BUILDING
  defb 54            ; 4 TILE LOCATION
  defw s_oldmanarchery ; SPRITE DATA
  defb 1             ; 7 ITEM REWARD
  defb 0             ; 8 ITEM SOUGHT
  defb 1             ; 9 0 = LOCKED, 1 AVAILABLE, 2 = ACCEPTED, 3 = COMPLETED
  defb 0             ; 10 ROOM ID IF IN BUILDING (TILE ID OF DOOR)
  ; OLD MAN FAMINE - 7x83
  defb 5             ; QUEST NUMBER - OVERRIDES OBJECT QUEST LOOKUP
  defb 7             ; 1 X MAP SCREEN
  defb 83            ; 2 Y MAP SCREEN
  defb 0             ; 3 IN BUILDING
  defb 55            ; 4 TILE LOCATION
  defw s_oldmanfamine ; SPRITE DATA
  defb 13            ; 7 ITEM REWARD
  defb 12            ; 8 ITEM SOUGHT
  defb 1             ; 9 0 = LOCKED, 1 AVAILABLE, 2 = ACCEPTED, 3 = COMPLETED
  defb 0             ; 10 ROOM ID IF IN BUILDING (TILE ID OF DOOR)
  ; END OF QUEST LIST
  defb 255 

; QUEST CHARACTERS THAT CAN BE PLACED ON MAP
num_random_chars_knights equ 1
random_chars_knights:
  defw s_oldmanrandom ; SPRITE

; STATIC QUEST CONVERSATIONS
; 11      = ITEM
; 13,<ID> = DICTIONARY WORD
; 10      = LINE FEED

quest_generic_complete:      defb 13,thankyou," ",13,for,13,helpingme,"!",255
quest_generic_empty:         defb 255
quest_generic_reject:        defb "OH DEAR, WHAT WILL I DO?",255

quest_kidnap:                defb 13,please," ",13,helpme,", ",13,my,11," ",13,hasbeen,13,captured,"!",255
quest_kidnap_accept:         defb "I HEARD ",13,my,11," ",13,hasbeen,13,captured," BY ",13,indian,"S. ",13,please," ",13,helpme,".",255
quest_kidnap_ongoing:        defb 13,have,13,you,"FOUND ",13,my,11," YET?",255
quest_kidnap_reject:         defb "OH I DO MISS HIM SO!",255
quest_kidnap_reward:         defb 13,thankyou,"! ",13,hereis,"A",11," ",13,for,13,helpingme,"!",255
quest_kidnap_complete:       defb 13,thankyou," ",13,for,"FINDING",13,my,11,"!",255
 
quest_indian:                defb 13,you,13,help,13,indian," ",13,chief,"?",255
quest_indian_accept:         defb "BOY STOLE ",11,".","FIND ",11,".","WE ",13,give,"BIG REWARD.",255
quest_indian_ongoing:        defb 13,bring,11,".","MAKE ",13,chief," ",13,happy,"!",255
quest_indian_reject:         defb "NO ",11,", NO ",13,happy," ",13,chief,"!",255
quest_indian_reward:         defb 13,you,"GOOD ",13,help,"TO ",13,chief,"!",13,you,13,bring,"PEACE TO VILLAGE",255
quest_indian_complete:       defb "HOW!",255

quest_loveletter:            defb 13,please," SIR! ",13,help,"A LONELY ",13,indian," WOMAN.",255
quest_loveletter_accept:     defb 13,give,13,this,11," TO ",13,my,13,love,". HE LIVES IN CEDAR FALLS. ",13,please,"!",255
quest_loveletter_ongoing:    defb 13,have,13,you,13,heard,13,from,13,my,13,love,"?",255
quest_loveletter_reward:     defb "HE ",13,returns," ",13,my,13,love,"! HOW CAN I EVER ",13,thankyou,"!",255

; ONE WAY QUEST. ONLY REQUIRES RECEIPT OF OBJECT
quest_loveletterman:         defb 13,have,13,you,13,heard,13,from,13,my,13,love,"? SHE LIVES IN BUFFALO CREEK",255
quest_loveletterman_reward:  defb "SHE ",13,returns," ",13,my,13,love,"!",13,please," ",13,give,"HER ",13,this,"TOKEN OF ",13,my,"UNDYING ",13,love,"!",255

; ARCHERY RANGE 016-056
quest_archery:               defb 13,have,"A GO SIR?",255
quest_archery_reward:        defb 13,here," IS ",13,your,13,arrow,"!",255

; OLD MAN FAMINE 007-083
quest_oldmanfamine:            defb "OH SIR,",13,have,"PITY ON AN OLD MAN",13,andd,"HIS FAMILY",255
quest_oldmanfamine_accept:     defb "OUR CROPS ",13,have,"FAILED",13,andd,"THOSE PESKY RABBITS ",13,have,"EATEN EVERY LAST MORSEL!",255
quest_oldmanfamine_ongoing:    defb 13,have,13,you,"GOT ANY FOOD?",255
quest_oldmanfamine_reward:     defb 13,thankyou,13,for," ",13,helpingme,"! ",13,hereis,"A GIFT ",13,for,13,your,"TROUBLE",255

; TRADING
quest_trade:                   defb "MAKE ",13,trade," WITH ",13,indian,"? BIG BARGAIN!",255
quest_trade_accept:            defb 13,bring,11,", WE DO DEAL.",255
quest_trade_ongoing:           defb 13,bring,11,", BIG TALK!",255
quest_trade_reward:            defb 13,you,"DRIVE HARD BARGAIN! I GIVE ",11,"!",255
quest_trade_complete:          defb 13,comeback,"SOON!",255

; TRADING COWBOY
quest_trade_cowboy:            defb "HOWDY PARDNER. WANT TO MAKE A ",13,trade,"?",255
quest_trade_cowboy_accept:     defb "I'M LOOKIN' FER SOME ",11,". KNOW ",13,where,"TO GET IT?",255
quest_trade_cowboy_reject:     defb "WHAT DOES A FELLA ",13,have,"TO DO TO GET SOME ",11,"?",255
quest_trade_cowboy_ongoing:    defb "ANY NEWS ON THE ",11,"?",255
quest_trade_cowboy_reward:     defb "FAIR DEAL, PARDNER! ",13,here," ARE SOME ",11," FOR ",13,your,"TROUBLE!",255
quest_trade_cowboy_complete:   defb "BEST ",11," IN TOWN!",255

; STATIC QUEST CONVERSATIONS LOOKUPS

; CHARACTER RESPONSES HELD IN VECTOR LOOKUP TABLES
; EACH STATEMENT SHOULD LINK TO SEVERAL POSSIBLE RESPONSES
; WHICH WILL BE SELECTED BY THE USER

quest_vector_help:
  defw 0                            ; EMPTY            - 0
  defw quest_kidnap                 ; KIDNAP           - 1
  defw quest_indian                 ; PEACE PIPE       - 2
  defw quest_loveletter             ; LOVE LETTER      - 3
  defw quest_loveletterman          ; LOVE LETTER MAN  - 4
  defw quest_archery                ; ARCHERY          - 5
  defw quest_oldmanfamine           ; OLD MAN FAMINE   - 6
  defw quest_trade                  ; TRADE            - 7
  defw quest_trade_cowboy           ; TRADE            - 8

quest_vector_accept:
  defw 0
  defw quest_kidnap_accept          ; KIDNAP
  defw quest_indian_accept          ; PEACE PIPE
  defw quest_loveletter_accept      ; LOVE LETTER
  defw quest_generic_empty          ; LOVE LETTER MAN
  defw quest_generic_empty           ; ARCHERY
  defw quest_oldmanfamine_accept    ; OLD MAN FAMINE
  defw quest_trade_accept           ; TRADE            - 7
  defw quest_trade_cowboy_accept    ; TRADE            - 8

quest_vector_ongoing:
  defw 0
  defw quest_kidnap_ongoing         ; KIDNAP
  defw quest_indian_ongoing         ; PEACE PIPE
  defw quest_loveletter_ongoing     ; LOVE LETTER
  defw quest_generic_empty          ; LOVE LETTER MAN
  defw quest_generic_empty          ; ARCHERY
  defw quest_oldmanfamine_ongoing   ; OLD MAN FAMINE
  defw quest_trade_ongoing          ; TRADE            - 7
  defw quest_trade_cowboy_ongoing   ; TRADE            - 8

quest_vector_reject:
  defw 0
  defw quest_kidnap_reject          ; KIDNAP
  defw quest_indian_reject          ; PEACE PIPE
  defw quest_generic_reject         ; LOVE LETTER
  defw quest_generic_reject         ; LOVE LETTER MAN
  defw quest_generic_empty          ; ARCHERY
  defw quest_generic_reject         ; OLD MAN FAMINE
  defw quest_indian_reject          ; TRADE            - 7
  defw quest_trade_cowboy_reject    ; TRADE            - 8

quest_vector_reward:
  defw 0
  defw quest_kidnap_reward          ; KIDNAP
  defw quest_indian_reward          ; PEACE PIPE
  defw quest_loveletter_reward      ; LOVE LETTER
  defw quest_loveletterman_reward   ; LOVE LETTER MAN
  defw quest_archery_reward         ; ARCHERY
  defw quest_oldmanfamine_reward    ; OLD MAN FAMINE
  defw quest_trade_reward           ; TRADE            - 7
  defw quest_trade_cowboy_reward    ; TRADE            - 8

quest_vector_complete:
  defw 0
  defw quest_kidnap_complete         ; KIDNAP
  defw quest_indian_complete         ; PEACE PIPE
  defw quest_generic_complete        ; LOVE LETTER
  defw quest_generic_complete        ; LOVE LETTER MAN
  defw quest_generic_empty           ; ARCHERY
  defw quest_generic_complete        ; OLD MAN FAMINE
  defw quest_trade_complete          ; TRADE            - 7
  defw quest_trade_cowboy_complete   ; TRADE            - 8

; INPUT
; C = TILE NUM

; A = 0 NOT BUMPED SPRITE
; A = 1 HAS BUMPED SPRITE
checkplayerbumpedquestsprite:
  ; CHECK TILE NUM
  ld a,c
  cp (iy+4)
  jr nz,returnfalse
  ; CHECK QUEST LOCATION
  ;jr matchquestdata

matchquestdata:
  ; CHECK X MAP POS
  ld a,(tilemap_cur)
  cp (iy+1)
  jr nz,returnfalse
  ; CHECK Y MAP POS
  ld a,(tilemap_cury)
  cp (iy+2)
  jr nz,returnfalse
  ; DONT CHECK ROOM ID IF NOT IN BUILDING
  ld a,(inbuilding)
  or a;cp 0
  jr z,returntrue
  ; CHECK ROOM ID
  ld a,(tilenum_cur)
  cp (iy+10)
  jr nz,returnfalse
  ; HAS BUMPED SPRITE

  returntrue:
  ld a,1
  ret
  returnfalse:
  xor a;ld a,0
  ret

movenextstaticquestblock:
  push bc
  ld bc,6
  addblock:
  add iy,bc
  pop bc
ret

movenextfixedspriteblock:
  push bc
  ld bc,7
  jr addblock

firstquestid equ 234
questlistdata:
  defw checkstaticquestcomplete ; 234 - 0 ; STATIC QUEST
  defw speaktoshopkeeper        ; 235 - 1 ; SHOP KEEPER
  defw enterwesternshop         ; 236 - 2 ; ENTER SHOP
  defw mimomum                  ; 237 - 3 ; MIMO'S MUM
  defw checkrandomconversation  ; 238 - 4 ; RANDOM CONVERSATION CHARACTER
  defw exitminestonebuilding    ; 239 - 5 ; EXIT MINE TO SAME STONE BUILDING
  defw exitmine3                ; 240 - 6 ; EXIT TO STONE BUILDING IN MAZE
  defw entermine3               ; 241 - 7 ; IN NARNIA ZONE
  defw exitmine2                ; 242 - 8 ; EXIT TO STONE BUILDING IN NARNIA
  defw entermine2               ; 243 - 9 ; IN MAZE ZONE
  defw narnia                   ; 244 - 10
  defw mineblocked              ; 245 - 11
  defw 0                        ; 246 - 12 ; VERTICALLY FLIPPED SPRITE
  defw enterstonebuilding       ; 247 - 13
  defw enterwigwam              ; 248 - 14
  defw checkrandomquestcomplete ; 249 - 15
  defw pickupobject             ; 250 - 16
  defw enterwesternzone         ; 251 - 17
  defw exitbuilding             ; 252 - 18
  defw entermine                ; 253 - 19 ; IN HOME ISLAND TO OUTSIDE
  defw 0                        ; 254 - 20 ; OBJECT IS TRAVERSIBLE
  defw checkdoor                ; 255 - 21

; CHOSE WHAT HAPPENS WHEN PLAYER ENCOUNTERS SPECIAL OBJECT TILE
; INPUTS 
; A = TILE TYPE ACTIVATED
; (B = TILE OBJECT GRAPHIC)
; (C = TILE NUMBER WE ARE ON)
questchooser:
  push af
  ld a,(ix+0)       ; CHECK IF MCP OR PLAYER
  cp 2 
  jr z,isplayerchoosequest
  pop af
  ret

  isplayerchoosequest:
    pop af

    ; CHECK IF WE HAVE QUEST NUMBER IN A
    ; SUBTRACT FIRST NON QUEST ID TO SEE IF IT CARRIES
    ; IF SO WE HAVE A NON QUEST ID
    sub firstquestid
    jp c,checkstaticquestcomplete
 
    ld hl,questlistdata
    jp vectortablelaunchcode
    ret

    ;gotquestid:
    ;add firstquestid

    ; ANY OTHER NUMBER MUST BE QUEST
    ;ld b,a
    ;ld iy,quest_data
    ; FIND FIRST ACTIVE QUEST BLOCK
    ;jp checkstaticquestcomplete    


    ;jp printqueststr

  checkdoor: 
    ; LOCK ALL DOORS AT NIGHT
    ld a,(nighttime)
    or a
    jr nz,doorlocked
    ; WE NEED TO RESET THE PSEUDO RANDOM NUMBER TO MAKE SURE
    ; WE ALWAYS GET THE SAME RANDOM NUMBER EACH TIME WE TRY TO 
    ; OPEN THE DOOR
    call resetpseudorandomquest
    call rand32
    add 15
    jr c,doorlocked
    jr enterlogcabin
    ;call playsound
  doorlocked:
    call doorknock
    ld hl,str_doorlocked
    xor a ; DON'T SCROLL UP
    jp printstronce
  mineblocked:
    ld hl,str_mineblocked
    xor a ; DON'T SCROLL UP
    jp printstronce
  mimomum:
    ld hl,str_mimomum
    jp printstronce
  narnia:
    ld hl,str_narnia
  printstronce:
    call statusbarprintparagraph
    jp checknokeyspressed

; PICK UP STANDARD QUEST OBJECT
; INPUTS 
; B = OBJECT ID
pickupobject:
  call clearquestsprite ; CLEAR STANDARD OBJECT FROM OBJECT MAP
  ; PICK UP SPRITE OBJECT - EG RABBIT. DOES NOT NEED CLEARED FROM OBJECT MAP
  pickupspriteobject:
    ; ADD OBJECT TO INVENTORY
    call addplayerinv
    or a;cp 0 ; IF WE HAD ROOM FOR THE ITEM, A WILL BE TRUE
    jp z,returnfalse ; WE HAD NO ROOM SO DON'T PICK UP
    call getobjectstr
    ld hl,str_pickupobject
    xor a;ld a,0 ; DO NOT SCROLL UP TO CLEAR STATUS BAR
    call statusbarprintparagraph
    jp returntrue

; STORE PLAYER POS ON ENTERING BUILDING
storeplayerpos:
  ; RECORD TILE NUM
  push af
  ld a,c
  ld (tilenum_cur),a     ; SAVE LOCATION
  pop af
  call backupplayerpos 
ret

enterwesternshop:
  ; LOCK ALL DOORS AT NIGHT
  ld a,(nighttime)
  or a
  jr nz,doorlocked
  call storeplayerpos
  ld (ix+6),48      ; SET NEW X PLAYER COORD BYTE
  ld (ix+7),120      ; SET NEW X PLAYER COORD LINE NUM
  ; SET THAT WE HAVE ENTERED A SHOP
  ld a,7
  jr enterbuildingredrawtilemap
enterlogcabin:
  call storeplayerpos
  ld (ix+6),28      ; SET NEW X PLAYER COORD BYTE
  ld (ix+7),120      ; SET NEW X PLAYER COORD LINE NUM
  ; SET THAT WE HAVE ENTERED A CABIN
  ld a,1
  enterbuildingredrawtilemap:
  ld (inbuilding),a
  ld (ix+3),a
  ; REDRAW TILEMAP
  jp marktilemapchanged
enterstonebuilding:
  call storeplayerpos
  ld (ix+6),36      ; SET NEW X PLAYER COORD BYTE
  ld (ix+7),120      ; SET NEW X PLAYER COORD LINE NUM
  ; SET THAT WE HAVE ENTERED A STONE BUILDING
  ld a,4
  jr enterbuildingredrawtilemap
enterwigwam:
  call storeplayerpos
  ld (ix+6),36      ; SET NEW X PLAYER COORD BYTE
  ld (ix+7),110      ; SET NEW X PLAYER COORD LINE NUM
  call createmydirt
  ; SET THAT WE HAVE ENTERED A WIGWAM
  ld a,3
  jr enterbuildingredrawtilemap
enterwesternzone:
  ; MOVE SCREEN POS
  ld a,15
  ld (tilemap_cur),a
  ld (tilemap_cury),a

  ; MOVE PLAYER COORDS
  ld ix,playerspritedata
  ld (ix+4),a   ; X MAP START POS
  ld (ix+5),a   ; Y MAP START POS
  jr exitbuilding
exitbuilding:
  call restoreplayerpos
  call checkclimate 
  ; SET THAT WE HAVE EXITED A BUILDING
  xor a ;ld a,0
  jr enterbuildingredrawtilemap
entermine:
  call backupplayerpos
  ld (ix+6),40       ; SET NEW X PLAYER COORD BYTE
  ld (ix+7),120      ; SET NEW X PLAYER COORD LINE NUM
  ; SET THAT WE HAVE ENTERED A MINE
  ld a,2
  jr enterbuildingredrawtilemap
entermine2:
  ld (ix+6),40       ; SET NEW X PLAYER COORD BYTE
  ld (ix+7),120      ; SET NEW X PLAYER COORD LINE NUM
  ; SET THAT WE HAVE ENTERED A MINE
  ld a,5
  jp enterbuildingredrawtilemap
entermine3:
  ld (ix+6),40       ; SET NEW X PLAYER COORD BYTE
  ld (ix+7),120      ; SET NEW X PLAYER COORD LINE NUM
  ; SET THAT WE HAVE ENTERED A MINE
  ld a,6
  jp enterbuildingredrawtilemap
exitmine2:
  call enternarniazone
  exitminestonebuilding:
  ld (ix+6),36       ; SET NEW X PLAYER COORD BYTE
  ld (ix+7),32       ; SET NEW X PLAYER COORD LINE NUM
  ; SET THAT WE HAVE ENTERED A STONE BUILDING
  ld a,4
  jp enterbuildingredrawtilemap
exitmine3:
  call entermazezone
  jr exitminestonebuilding
enternarniazone:
  ; MOVE SCREEN POS
  ld a,23
  ld (tilemap_cur),a
  ld (ix+4),a   ; X MAP START POS
  ld a,49
  ld (tilemap_cury),a
  ld (ix+5),a   ; Y MAP START POS
ret
entermazezone:
  ; MOVE SCREEN POS
  ld a,22
  ld (tilemap_cur),a
  ld (ix+4),a   ; X MAP START POS
  ld a,22
  ld (tilemap_cury),a
  ld (ix+5),a   ; Y MAP START POS
ret

; LOOK UP TABLE OF OBJECT NAMES, COPY DESCRIPTION TO DE
; INPUTS
; B = OBJECT ID
; OUTPUT
; DE = PTR TO OBJECT STRING

getobjectstr:
  push hl
  push bc
  ; COPY OBJECT STRING
  ld hl,inventoryiddictlookup
  ld c,0 ; GET CORRESPONDING ID FOR INVENTORY DICTIONARY
  objloop:
    ld a,(hl)
    cp 255
    jr z,popoffagainnotfound          ; DID NOT FIND OBJECT STRING
    cp b
    jr z,foundinvobj
    inc hl
    inc c
  jr objloop

  foundinvobj:
    ; FOUND ID, NOW LOOKUP INVENTORY DICTIONARY
    ld hl,inventorydict
    ld a,c
    inc a
    call vectorlookup
  jr popoffagain
 
  popoffagainnotfound:
    ld de,str_empty ; RETURN EMPTY STRING IN CASE WE MADE A MISTAKE
  popoffagain:
    pop bc
    pop hl
    ret

; COPY STRING FROM HL TO DE
; INPUT
; HL = STRING TO INSERT ENDING IN 255
; DE = DESTINATION STRING
copystr:
    ld a,(hl)
    cp 255
    ret z
    ldi
    jr copystr

; INPUTS
; C = TILE NUMBER WE ARE ON
clearquestsprite:
  ld iy,quests_fixed_sprites

  clearquestspritesloop:
  ; REURN IF WE REACH END OF LIST
  ld a,(iy+0)
  cp 255
  ret z        

  ; CHECK IF WE ARE IN BUILDING
  ld a,(inbuilding)
  or a;cp 0
  jr z,clearspriteoutside          
  ; ONLY CHECK BUILDING IDS AS WE ARE IN BUILDING
  cp (iy+3)
  jr z,clearquestspr
  jr checknextsprite2

  clearspriteoutside:
  ; SKIP IF QUEST SPRITE IS NOT IN CURRENT TILEMAP
  ld a,(tilemap_cur)       
  cp (iy+1)
  jr nz,checknextsprite2
  ld a,(tilemap_cury)
  cp (iy+2)
  jr nz,checknextsprite2

  clearquestspr:
  ; SKIP IF QUEST SPRITE IS NOT IN PLAYER TILE
  ld a,c
  cp (iy+4)
  jr nz,checknextsprite2

  ; CLEAR OBJECT TILEMAP
  ld hl,tilemap2
  ld a,(iy+4)
  ld l,a
  ld (hl),0
  ; CLEAR SPRITE FROM TILEMAP
  ld hl,tilemap0
  ld l,a
  ld (hl),0

  push hl
  push bc
  ; RESTORE MIMO BUFFER FIRST THEN CLEAR SPRITE FROM LANDSCAPE 
  ; SO THERE IS NO GRAPHIC CORRUPTION
  call restoremybuffer
  pop bc
  pop hl
  xor a
  call redrawsingletile_notrans
  
  ; DEACTIVATE SPRITE FROM QUEST LIST
  ld (iy+0),0 
  ret

  checknextsprite2:
    call movenextfixedspriteblock
  jr clearquestspritesloop

; INPUTS
;  A = ID
;  HL = VECTOR TABLE
outputqueststringsrandom:
  call vectorlookuphl          ; GET STRING TO PRINT IN HL
  ld a,(hl)                    ; DON'T PRINT IF STRING IS OF 0 LENGTH
  cp 255
  ret z
  jp statusbarprintparagraph ; PRINT STRING

addflipperpower:
  xor a;ld a,0
  ld (selfmodify_hasnoflippers-1),a
  jr nextinvitem4
addropepower:
  xor a;ld a,0
  ld (selfmodify_hasnorope-1),a
  jr nextinvitem4
addbowpower:
  ld a,1;ld a,0
  ld (hasbow),a
  jr nextinvitem4
addmappower:
  ld a,1
  ld (hasworldmap),a
  jr nextinvitem4

checkpowers:
  ; RESET POWERS
  ld a,1
  ld (selfmodify_hasnoflippers-1),a
  ld (selfmodify_hasnorope-1),a
  xor a
  ld (hasbow),a

  ; CHECK INVENTORY FOR CURRENT POWERS
  ld hl,player_inventory_rand
  invloop5:
    ld a,(hl)
    cp 255                   ; END OF INVENTORY LIST
    jp z,returnfalse
    cp flipper_id            ; FLIPPER ID
    jr z,addflipperpower
    cp rope_id               ; ROPE ID
    jr z,addropepower
    cp map_id
    jr z,addmappower
    cp bow_id
    jr z,addbowpower

    nextinvitem4:
      inc hl
      inc hl
    jr invloop5
  
; INPUTS
; B = QUEST TO UNLOCK
checkunlockquest:
  ld hl,quest_data
  ld b,(iy+5)
  questloop2:
    ; RETURN IF WE HAVE REACHED THE END OF LIST
    ld a,(hl)
    cp 255
    ret z
    ; SEE IF WE MATCH ONE WE ARE LOOKING FOR
    cp b
    jr z, unlockquest

    ; NEXT QUEST
    push bc
    ld bc,6
    add hl,bc
    pop bc
  jp questloop2

unlockquest:
  ; UNLOCK QUEST
  inc hl
  inc hl
  ld (hl),1
ret