; RANDOM CHARACTERS FOR ZONES

num_random_chars_indian equ 2
random_chars_indian:
  defw s_indianmanrandom   ; SPRITE DEFINITION 
  defw s_indianwomanrandom 
  ;defw s_indianmanconv

num_random_chars_forest equ 2
random_chars_forest:
  defw s_settlermanrandom 
  defw s_oldmanrandom

num_random_chars_loghouse equ 3
random_chars_loghouse:
  defw s_settlermanrandom
  defw s_girlrandom 
  defw s_oldmanrandom 

num_random_chars_wigwam equ 2
random_chars_wigwam:
  defw s_indianmanrandom   
  defw s_indianwomanrandom 

; LOOKUP TABLE OF LOOKUP TABLES FOR QUESTS

randomobjectnumsbyzone:
   defb 3 ; zone_empty                   equ 0
   defb 3 ; zone_forest                  equ 1
   defb 3 ; zone_indian                  equ 2
   defb 3 ; zone_knights                 equ 3
   defb 5 ; zone_western                 equ 4
   defb 3 ; zone_tropical                equ 5
   defb 3 ; zone_sea                     equ 6
   defb 3 ; zone_winter                  equ 7
   defb 3 ; zone_autumn                  equ 8
   defb 6 ; zone_westernindian           equ 9
   defb 3 ; zone_forestmountain          equ 10
   defb 6 ; zone_westernmountain         equ 11
   defb 3 ; zone_westerntropical         equ 12
   defb 3 ; zone_westerntropicalmountain equ 13

randomobjectlistsbyzone:
   defw rand_quest_object_ids ; zone_empty                   equ 0
   defw rand_quest_object_ids ; zone_forest                  equ 1
   defw rand_quest_object_ids ; zone_indian                  equ 2
   defw rand_quest_object_ids ; zone_knights                 equ 3
   defw cowboyobjects         ; zone_western                 equ 4
   defw rand_quest_object_ids ; zone_tropical                equ 5
   defw rand_quest_object_ids ; zone_sea                     equ 6
   defw rand_quest_object_ids ; zone_winter                  equ 7
   defw rand_quest_object_ids ; zone_autumn                  equ 8
   defw indianquestobjects    ; zone_westernindian           equ 9
   defw rand_quest_object_ids ; zone_forestmountain          equ 10
   defw indianquestobjects    ; zone_westernmountain         equ 11
   defw rand_quest_object_ids ; zone_westerntropical         equ 12
   defw rand_quest_object_ids ; zone_westerntropicalmountain equ 13

; EACH ZONE HAS A LIST OF RANDOM OBJECT IDS THAT ARE ASSOCIATED WITH IT
; THESE ARE REFERENCED AGAINST A MAIN LIST OF DESCRIPTIONS/PRICES/ETC
; GENERAL OBJECT IDS
rand_quest_object_ids:
   defb 1 ; ARROW
   defb 2 ; SPANNER
   defb 3 ; CAT

; MAIN OBJECT LIST
rand_quest_objects equ 11
rand_quest_object_strs:
  defw str_empty         ; 0 EMPTY - CAN'T USE OBJECT WITH 0 ID, AS OUR INVENTORY IS FULL OF IT
  defw str_arrow         ; 1
  defw str_spanner       ; 2
  defw str_worldmap      ; 3
  defw str_localmap      ; 4
  defw str_bow           ; 5
  defw str_saddle        ; 6
  defw str_tobacco       ; 7
  defw str_bakedbeans    ; 8
  defw str_shootingirons ; 9
  defw str_eatingirons   ; 10
  defw str_peacepipe     ; 11
  defw str_rabbitmeat    ; 12
  defw str_feather       ; 13
  defw str_lostson       ; 14
  defw str_flippers      ; 15

indianquestobjects:
  defb arrow_id ; 1 ARROW
  defb bow_id   ; 2 BOW
  defb 6        ; 3 SADDLE
  defb 7        ; 4 TOBACCO
  defb 11       ; 5 PEACE PIPE
  defb 13       ; 6 FEATHER

cowboyobjects:
  defb 8  ; 1 BAKED BEANS
  defb 9  ; 2 SHOOTING IRONS
  defb 10 ; 3 EATING IRONS
  defb 12 ; 4 RABBIT MEAT
  defb 15 ; 5 FLIPPERS

str_arrow:            defb "ARROW",255           ; 1
str_spanner:          defb "SPANNER",255         ; 2
str_worldmap:         defb "WORLD MAP",255       ; 3
str_localmap:         defb "LOCAL MAP",255       ; 4
str_bow:              defb "BOW",255             ; 5
str_saddle:           defb "SADDLE",255          ; 6
str_tobacco:          defb "TOBACCO",255         ; 7
str_bakedbeans:       defb "BAKED BEANS",255     ; 8
str_shootingirons:    defb "SHOOTIN' IRONS",255  ; 9
str_eatingirons:      defb "EATIN' IRONS",255    ; 10

; STANDARD QUEST STRINGS
;str_peacepipe         defb "PEACE PIPE",255      ; 11
;str_rabbitmeat        defb "TASTY MORSEL",255    ; 12
;str_feather           defb "FEATHER",255         ; 13

; QUEST TYPES BASED ON RANDOM OBJECT ID
; NUMBER IS LOOKUP IN STATIC QUEST CONVERSATION TABLES
rand_quest_types_lookup:
  defb 1 ; KIDNAPPED -  0 EMPTY   
  defb 7 ; LOST ITEM -  1 ARROW
  defb 2 ; LOST ITEM -  2 SPANNER
  defb 6 ; TRADE     -  3 WORLD MAP
  defb 7 ; TRADE     -  4 LOCAL MAP
  defb 7 ; TRADE     -  5 BOW INDIAN
  defb 7 ; TRADE     -  6 SADDLE INDIAN
  defb 7 ; TRADE     -  7 TOBACCO INDIAN
  defb 8 ; TRADE     -  8 BAKED BEANS COWBOY
  defb 8 ; TRADE     -  9 SHOOTING IRONS COWBOY
  defb 8 ; TRADE     - 10 EATING IRONS COWBOY
  defb 7 ; TRADE     - 11 PEACE PIPE
  defb 8 ; TRADE     - 12 RABBIT MEAT
  defb 7 ; TRADE     - 13 FEATHER
  defb 2 ; LOST      - 14 LOST SON
  defb 8 ; TRADE     - 15 FLIPPERS

; CLEAR LIST OF COMPLETED QUESTS WHEN MOVING SCREEN
; ALSO CLEAR LIST OF INACTIVATED ONES WHEN MOVING SCREEN
; THIS MAKES MORE SPACE FOR GENERATING ANOTHER RANDOM QUEST
; IN THE NEXT SCREEN.

;clearunusedquests:
;  ld iy,quest_data_random
;  checkrandomquestblock5:
;    ld a,(iy+0)
;    cp 255 ; END OF LIST
;    ret z
;    ld a,(iy+9)
;    cp 2 ; IF QUEST IS ACCEPTED
;    jr z,movenextrandomquestblock5
;    cp 3 ; IF QUEST IS COMPLETED - KEEP FOR A DAY 
;    jr z,movenextrandomquestblock5

;    ld (iy+0),0 ; MARK BLOCK AS EMPTY AGAIN

;    movenextrandomquestblock5:
;      call movenextrandomquestblock
;    jr checkrandomquestblock5

; USED TO DO THIS WHEN MOVING SCREEN, BUT MAKES MORE SENSE TO DO IT ON NEXT DAY
; AS RANDOM CHARACTERS FORGOT TOO QUICKLY THAT YOU HAD JUST DONE THEIR QUEST
; AND WERE ASKING YOU TO DO IT AGAIN!
clearcompletedquests:
  ld iy,quest_data_random
  checkrandomquestblock4:
    ld a,(iy+0)
    cp 255 ; END OF LIST
    ret z
    ld a,(iy+9)
    cp 2 ; IF QUEST IS ACCEPTED
    jr z,movenextrandomquestblock4

    ld (iy+0),0 ; MARK BLOCK AS EMPTY AGAIN

    movenextrandomquestblock4:
      call movenextrandomquestblock
    jr checkrandomquestblock4

movenextrandomquestblock:
  push bc
  ld bc,11
  add iy,bc
  pop bc
ret

; CHECK MAP LOCATION TO SEE IF ACCEPTED QUEST ALREADY EXISTS HERE
; IF SO, DON'T GENERATE ANOTHER ONE
; INPUT
; IY = QUEST DATA BLOCK
; OUTPUT
; A = 0 NOT FOUND MATCH, 1 FOUND MATCH
checkduplicatequest:
  ld iy,quest_data_random
  checkduplicatequestloop:
    ; IF WE REACH END OF LIST, RETURN
    ld a,(iy+0)
    cp 255 ; CHECK END OF LIST
    jp z,returnfalse 
    or a;cp 0   ; CHECK ACTIVE
    jr z,movenextrandomquestblock3

    call matchquestdata
    cp 1 ; FOUND MATCH
    ret z
    
  movenextrandomquestblock3:
    call movenextrandomquestblock
  jr checkduplicatequestloop

; GENERATE A RANDOM QUEST.
; A RANDOM QUEST IS GENERATED WHEN A PLAYER ENTERS A ROOM IF...
;   1) A QUEST HAS NOT ALREADY BEEN ACCEPTED FOR THIS MAP ID AND ROOM ID
genrandomquest:
  ; ONLY GENERATE RANDOM QUEST SOMETIMES
  call rand32
  sub 16
  ret nc
;****
  createrandomquest:
  ; CHECK IF RANDOM QUEST SPRITE ALREADY OCCUPYING SPACE
  ; CHARACTER MAY HAVE ALREADY ACCEPTED RANDOM QUEST AND INSERTING
  ; ANOTHER SPRITE WOULD CREATE A DUPLICATE
  call checkduplicatequest
  cp 1
  ret z

  ld iy,quest_data_random
  ; FIND FIRST INACTIVE QUEST BLOCK
  checkrandomquestblock:
    ld a,(iy+0)
    cp 255 ; END OF LIST
    ret z
    or a;cp 0 ; SKIP IF ACTIVE
    jr z,createrandquest

    call movenextrandomquestblock
  jr checkrandomquestblock

  createrandquest:
    ; CREATE RANDOM QUEST CHARACTER FOR CURRENT SCREEN
    ld (iy+0),1                 ; MARK ACTIVE 
    ld a,(tilemap_cur)
    ld (iy+1),a                 ; 1 X MAP SCREEN
    ld a,(tilemap_cury)
    ld (iy+2),a                 ; 2 Y MAP SCREEN 
    ld a,(inbuilding)
    ld (iy+3),a                 ; 3 IN BUILDING
    ld b,200
    call rand20
    ld (iy+4),a                 ; 4 X TILE LOCATION
    ; GET RANDOM CHARACTER SPRITE BASED ON ZONE INTO DE
    call getrandomsprite
    ld (iy+5),e                 ; 5-6 PTR TO SPRITE DATA 
    ld (iy+6),d                 ; 5-6 PTR TO SPRITE DATA 
    ; GET RANDOM OBJECT CHARACTER NEEDS
    call getrandomobjectid      ; GET RANDOM OBJECT ID - THESE ARE DIFFERENT FROM NORMAL OBJECT IDS
    ld (iy+8),a                 ; 8 ITEM SOUGHT
    ;cp 8                       ; MAKE IF REWARD IS PARCEL, REQUIRED OBJECT IS NONE
    ;jr z,makesoughtitemnone
    ; SET REWARD ITEM
    call getdesiredrandomobjectid
    ld (iy+7),a                 ; 7 ITEM REWARD
    ; NEED TO GENERATE CHARACTER TO RECEIVE PARCEL
    ;ld (iy+7),0                 ; 7 ITEM REWARD
    ld (iy+9),1                 ; 9 MAKE QUEST ACTIVE
    ; IF WE ARE NOT IN BUILDING, NO ROOM ID PLEASE
    ld a,(inbuilding)
    or a;cp 0
    jr z,clearroomid
    ld a,(tilenum_cur) 
    clearroomid:         
    ld (iy+10),a                ; 10 ROOM ID
  ret

; INPUTS
; B = OBJECT ID
; OUTPUT
; DE = PTR TO OBJECT STR
getrandobjectstr:
  ld a,b
  ld hl,rand_quest_object_strs
  call vectorlookup
ret

; INPUTS 
; B = OBJECT ID
; OUTPUT
; A = QUEST LOOKUP ID
getrandobjectquesttype:
  ld a,(selfmod_israndomquest-1)   ; IF WE ARE A RANDOM QUEST, USE TABLE TO LOOK UP QUEST STRINGS
  or a                             ; IF NOT, GO BY STATIC QUEST ID
  jr z,getstaticobjectquesttype
  push bc
  ld hl,rand_quest_types_lookup
  ld c,b
  ld b,0
  add hl,bc
  ld a,(hl)
  pop bc
ret

getstaticobjectquesttype:
  ld a,(iy+0)
ret

; CHECK IF A RANDOM QUEST HAS BEEN COMPLETED
; A QUEST BLOCK IS CREATED WHEN A SCREEN IS DRAWN
; IT IS UP TO THE PLAYER TO ACCEPT THE QUEST OR NOT
; THIS ROUTINE JUST CHECKS TO SEE IF WE BUMPED INTO A QUEST CHARACTER
; AND IF SO CHECKS WHAT STATUS THE RELATED QUEST IS AT
; INPUTS
; C = TILENUMBER OF QUEST SPRITE

israndomquest:
  defb 0

checkstaticquestcomplete:
  xor a ; A = WHETHER THIS IS STATIC OR RANDOM QUEST 0 = RANDOM QUEST
  ld (selfmod_israndomquest-1),a
  ld iy,quest_data
  jr checkrandomquestblock2
checkrandomquestcomplete:
  ld a,1 ; A = WHETHER THIS IS STATIC OR RANDOM QUEST 0 = RANDOM QUEST
  ld (selfmod_israndomquest-1),a
  ld iy,quest_data_random
  ; FIND FIRST ACTIVE QUEST BLOCK
  checkrandomquestblock2:
    ld a,(iy+0)
    cp 255 ; END OF LIST
    ret z 
    ; QUEST IS LOCKED
    or a;cp 0
    jr z,movenextrandomquestblock2

    foundrandomquestblock2:
      ; CHECK TILE NUMBER OF CHARACTER SPRITE AGAINST TILE NUMBER OF QUEST
      ; IN CASE WE HAVE BUMPED INTO A DIFFERENT QUEST CHARACTER ON THE SAME SCREEN
      call checkplayerbumpedquestsprite
      or a;cp 0
      jr z,movenextrandomquestblock2

      ; CHECK TIME OF DAY
      ld a,(nighttime)
      or a
      jr nz,printnighttime

      ; PLAYER HAS BUMPED INTO SPRITE THAT RELATES TO QUEST
      ; CHECK STATUS OF QUEST
      ld a,(iy+9)
      
      cp 1 ; QUEST NOT YET ACCEPTED
      jr z,checkacceptrandomquest
      cp 2 ; QUEST IS ACCEPTED - CHECK IF PLAYER HAS DESIRED OBJECT
      jp z,checkifrandomquestcomplete
      cp 3 ; QUEST HAS BEEN COMPLETED - PRINT THANKS... AGAIN!
      jp z,randomquestiscomplete
      ret

      movenextrandomquestblock2:
        call movenextrandomquestblock
      jr checkrandomquestblock2

      printnighttime:
        ld hl,str_sleeping
        call statusbarprintparagraph ; PRINT STRING
        jp checknokeyspressed

      checkacceptrandomquest:
        call resetpseudorandomquest

        ld a,1:selfmod_israndomquest
        or a
        jr z,askacceptquest

        ; JUST SPEAK TO PLAYER INSTEAD OF GIVING THEM QUEST - SOMETIMES
        call rand32
        sub 16
        jp c,checkrandomconversation         

      ; SEE IF PLAYER WANTS TO ACCEPT QUEST
      askacceptquest:
        ld b,(iy+8)
        ld a,(selfmod_israndomquest-1)
        or a
        jr z,skipemptyquestitemcheck
        ; CHECK IF OBJECT ID IS 0, IF SO WE DON'T HAVE A PROPER QUEST GENERATED! AS THERE IS NO QUEST LIST FOR THIS ZONE.
        ; IF B IS 0, JUST MAKE CONVERSATION
        ; BUT IF WE ARE A STATIC QUEST AND DESIRED OBJECT IS 0, THEN GIVE PLAYER REWARD OBJECT IMMEDIATELY
        ld a,b
        or a
        jp z,checkrandomconversation
        skipemptyquestitemcheck:
        ; OR IF EVERYTHING IS OK AND WE HAVE A PROPER QUEST OBJECT ID....
        call getrandobjectstr          ; GET OBJECT STR INTO DE
        call getrandobjectquesttype    ; FIND WHICH QUEST TO USE BASED ON OBJECT ID
        ld hl,quest_vector_help        ; SET VECTOR TABLE
        call outputqueststringsrandom  ; OUTPUT STRING
        call waityesno
        cp "n" 
        jr z,questrejected2

        ; QUEST ACCEPTED
        ld (iy+9),2                    ; MARK QUEST ACCEPTED
        ld b,(iy+8)
        ld a,b
        or a; cp 0                     ; IF WE DO NOT REQUIRE OBJECT, GIVE PLAYER REWARD OBJECT IMMEDIATELY (EG PARCEL TO DELIVER)
        jr z,giverewardonacceptance
        call getrandobjectstr          ; GET DESCRIPTION OF OBJECT FROM TABLE
        call getrandobjectquesttype
        ld hl,quest_vector_accept
        jp outputqueststringsrandom

      ; QUEST REJECTED
      questrejected2:
        ld b,(iy+8)
        call getrandobjectstr         ; GET DESCRIPTION OF OBJECT FROM TABLE
        call getrandobjectquesttype
        ld hl,quest_vector_reject
        jp outputqueststringsrandom

      ; CHECK IF PLAYER HAS DESIRED OBJECT
      checkifrandomquestcomplete:
        ld b,(iy+8)
        call checkplayerinvrand
        cp 1
        jr z,markrandomquestcomplete
        ; QUEST NOT COMPLETE YET, PRINT COMPLAINT
        ld b,(iy+8)
        call getrandobjectstr        ; GET DESCRIPTION OF OBJECT FROM TABLE
        call getrandobjectquesttype
        ld hl,quest_vector_ongoing   ; *** AMEND TO PUT IN ACTUAL QUEST DETAILS
        jp outputqueststringsrandom

      markrandomquestcomplete:
        ; TAKE DESIRED OBJECT FROM PLAYER
        call remplayerinvrand
        giverewardonacceptance:
        ; GIVE REWARD TO PLAYER
        ld b,(iy+7)
        call addplayerinvrand
        ld (iy+9),3                  ; MARK QUEST COMPLETE
        ld b,(iy+7)
        call getrandobjectstr        ; GET DESCRIPTION OF OBJECT FROM TABLE
        call getrandobjectquesttype
        ld hl,quest_vector_reward  ; *** AMEND TO PUT IN ACTUAL QUEST DETAILS
        jp outputqueststringsrandom

      randomquestiscomplete:
        ld b,(iy+8)
        call getrandobjectstr        ; GET DESCRIPTION OF OWN OBJECT FROM TABLE
        call getrandobjectquesttype
        ld hl,quest_vector_complete  ; *** AMEND TO PUT IN ACTUAL QUEST DETAILS
        jp outputqueststringsrandom

getrandomsprite:
  ; INSIDE SPRITES
  ld a,(inbuilding)
  or a;cp 0
  jr z,skipbuildcheck
  cp 1 ; FOREST LOG HOUSE
  jr z,loadrandomloghousesprite
  cp 3 ; INDIAN WIGWAM
  jr z,loadrandomindiansprite
  cp 4 ; KNIGHT HOUSE
  jr z,loadrandomknightsprite

  skipbuildcheck:
  ; OUTSIDE SPRITES
  ; CHECK WHAT ZONE WE ARE IN
  ld a,(currzonedata)
  ld hl,randcharbyzone
  call vectortablelaunchcode
ret

loadrandomforestsprite:
  ld hl,random_chars_forest
  ld a,num_random_chars_forest
  jr getrandvector
loadrandomloghousesprite:
  ld hl,random_chars_loghouse
  ld a,num_random_chars_loghouse
  jr getrandvector
loadrandomknightsprite:
  ld hl,random_chars_knights
  ld a,num_random_chars_knights
  jr getrandvector
loadrandomindiansprite:
  ld hl,random_chars_indian
  ld a,num_random_chars_indian
  getrandvector:
  ld b,a
  call rand32
  jp vectorlookup
 
loadrandgreeting:
  ld hl,quest_vector_hellos
  ld a,num_rand_hellos
  domyrandgreet:
  call getrandvector
  ex de,hl
  ret
loadrandgoodbye:
  ld hl,quest_vector_goodbyes
  ld a,num_rand_goodbyes
  jr domyrandgreet

getrandomobjectid:
  ; GET NUMBER OF RANDOM OBJECT ITEMS FOR THIS ZONE
  ld hl,randomobjectnumsbyzone   
  ld a,(currzonedata)            ; GET CURRENT ZONE
  ld b,0
  ld c,a
  add hl,bc
  ld b,(hl)

  ; RETURN 0 IF WE HAVE NO QUEST ITEMS FOR THIS ZONE  
  ; THIS MAKES CHARACTER MAKE CONVERSATION INSTEAD OF OFFERING QUEST
  ld a,b
  or a
  ret z

  ; GET RANDOM OBJECT NUMBER FOR THIS ZONE
  call rand20
  push af                        ; SAVE OBJECT NUMBER    
      
  ; GET APPROPRIATE OBJECT LIST ZONE TABLE
  ld hl,randomobjectlistsbyzone
  ld a,(currzonedata)            ; GET CURRENT ZONE AGAIN
  call vectorlookuphl
           
  ; FIND CORRESPONDING ITEM IN ZONE LIST
  pop af   ; RESTORE QUEST NUMBER
  ; READ OBJECT ID FROM THIS LIST
  ld b,0
  ld c,a
  add hl,bc
  ld a,(hl)
ret

; GET RANDOM OBJECT ID FOR REWARD
; IF IT IS THE SAME AS THE OBJECT WE ARE LOOKING FOR
; THEN JUST GIVE MONEY
; OUTPUTS
; A = RANDOM OBJECT ID
getdesiredrandomobjectid:
  call getrandomobjectid
  cp (iy+8)
  ret nz
  ld a,250
  ret

showqueststr:
  defb 14
  defb 0:xcoordmin1
  defb ":"
  defb 14
  defb 0:ycoordmin1
  defb " "
  defb 11
  defb 255 ; END OF LINE

showquests:
  ld iy,quest_data_random
  ld c,0 ; KEEP COUNT FOR SCROLLING
  checkrandomquestblock6:
    ld a,(iy+0)
    cp 255 ; END OF LIST
    jp z,finishprinttext ; DO A NICE SCROLL TO CLEAR THE STATUS BAR
    ld a,(iy+9)
    cp 2 ; IF QUEST IS ACCEPTED
    jp nz,movenextrandomquestblock6

    ; POPULATE SHOW QUEST STR
    ld a,(iy+1) ; X MAP POS
    ld (xcoordmin1-1),a
    ld a,(iy+2) ; Y MAP POS
    ld (ycoordmin1-1),a
    ld b,(iy+8)
    call getrandobjectstr          ; GET OBJECT STR INTO DE
    
    ld hl,showqueststr
    xor a                        ; DON'T SCROLL UP
    call statusbarprintparagraph ; PRINT STRING

    movenextrandomquestblock6:
      call movenextrandomquestblock
    jr checkrandomquestblock6