; WHEN PLAYER BUYS ITEM, SHOP QUANTITY MUST STAY SAME UNTIL NEXT DAY
; MAX FIVE OBJECTS PER SHOP
; IF SHOP RUNS OUT OF ITEM, IT WILL BE REPLACED NEXT DAY
; IF SHOP WITH SAME ZONE AND MAP EXISTS IN TABLE, USE THAT
; OTHERWISE GENERATE NEW SHOP INVENTORY OVER EXISTING ITEMS

; ITEM IDS LISTED BY KEYPRESS NUMBER, 1-5
; INV LOOKUP
shopitemdisplaylist:
  defw 0
  defw 0
  defw 0
  defw 0
  defw 0
  defb 255

; GLOBAL INVENTORY LIST
; BLOCK ID, SCREEN ID, ITEM ID, QTY AVAIL
; PRICE IS GENERATED WHEN PLAYER SPEAKS TO SHOP KEEPER
shopinventory:
  defb 0, 0, 0, 0
  defb 0, 0, 0, 0
  defb 0, 0, 0, 0
  defb 0, 0, 0, 0
  defb 0, 0, 0, 0
  defb 0, 0, 0, 0
  defb 0, 0, 0, 0
  defb 0, 0, 0, 0
  defb 0, 0, 0, 0
  defb 0, 0, 0, 0
  defb 0, 0, 0, 0
  defb 0, 0, 0, 0
  defb 0, 0, 0, 0
  defb 0, 0, 0, 0
  defb 0, 0, 0, 0
  defb 255 ; END OF LIST

; BASE PRICES
; PRICE GETS CHEAPER IF SHOP HAVE LOTS OF ITEM IN STOCK
; ITEM, PRICE
basepricesbyitemid:
  defb 4   ;  0 EMPTY
  defb 2   ;  1 ARROWS
  defb 2   ;  2 SPANNER
  defb 30  ;  3 WORLD MAP
  defb 20  ;  4 LOCAL MAP
  defb 10  ;  5 BOW
  defb 15  ;  6 SADDLE
  defb 2   ;  7 TOBACCO
  defb 1   ;  8 BAKED BEANS
  defb 10  ;  9 SHOOTING IRONS
  defb 3   ; 10 EATING IRONS
  defb 2   ; 11 PEACE PIPE
  defb 3   ; 12 RABBIT MEAT
  defb 1   ; 13 FEATHER
  defb 1   ; 14 LOST SON
  defb 10  ; 15 FLIPPERS
  defb 255 ; END OF LIST

; WHETHER TO REGENERATE NEW STOCK OR NOT
; WHEN PLAYER SPEAKS TO SHOPKEEPER
; 0 = GENERATED TODAY
; 1 = GENERATED YESTERDAY
inventorygeneratedtoday:
  defb 0

; FIND IF INVENTORY ALREADY GENERATED
; IF SO COUNT ITEMS
; THEN WE SHOULD ONLY REGENERATE REMAINING ITEMS UP TO 5 MAX
; OUTPUTS
; D = ITEM COUNT FOR THIS SHOP
countshopinv:
  xor a
  ld d,0
  ld hl,shopinventory
  findinvloop:
    ld a,(hl)
    cp 255
    ret z
    
    ld a,(currblockid)
    cp (hl)
    inc hl
    jr nz,movenextshopinv
    ld a,(currscreenid)
    cp (hl)
    jp nz,movenextshopinv

    inc d  ; INCREMENT ITEM COUNT

    movenextshopinv:
    ld bc,3
    add hl,bc
  jr findinvloop

shopinvcount:
  defb 0

; POPULATES GLOBAL SHOP INVENTORY WITH 5 ITEMS FOR OUR LOCATION
generateshopinv:
  ; ONLY REGENERATE INVENTORY ON DAILY BASIS
  ld a,(inventorygeneratedtoday)
  cp 1
  ret z
  ld a,1
  ld (inventorygeneratedtoday),a

  ; FIND IF INVENTORY EXISTS FOR THIS LOCATION
  ; IF NOT, CREATE NEW ONE
  ; IF IT DOES, REPLENISH UNTIL WE HAVE 5 
  call countshopinv
  ld a,d
  ld (shopinvcount),a

  ; CREATE INVENTORY
  ; PREFER EMPTY SPACES FIRST
  ; OVERWRITE IF NO SPACE AVAIL
  ; CREATE MAX FIVE ITEMS

  ; ld b,rand_quest_objects
  makeshopinvloop:
    ; GET A RANDOM OBJECT ID
    ld b,rand_quest_objects
    call brand20
    or a
    jr z,makeshopinvloop
    ld b,a
    ; CHECK IF WE HAVE ALREADY THIS IS STOCK, IF SO GET ANOTHE RANDOM ID
    call findshopqty
    or a
    jr nz,makeshopinvloop

    ; MAKE AN ITEM
    ld a,b
    ld (shopinvitem-1),a
    xor a                  ; MAKE RANDOM QTY
    call makeshopinv

    ; INCREMENT CREATED ITEMS COUNT
    ld a,(shopinvcount)
    inc a
    ld (shopinvcount),a

    ; CHECK IF MAX INVENTORY HAS BEEN REACHED
    cp 5
    ret z
  jr makeshopinvloop

; ADJUST STOCK QUANTITY OF AN ITEM IN A SHOP
; INPUTS
; A = 0 - NEW RANDOM STOCK, 1 = INCREMENT STOCK, 2 = DECREMENT STOCK
makeshopinv:
  push af
  call findnextemptyinvslot 
  ; FILL IN SLOT DETAILS
  ; SHOP LOCATION
  ld a,(currblockid)
  ld (ix+0),a
  ld a,(currscreenid)
  ld (ix+1),a
  ; ITEM
  ld (ix+2),1:shopinvitem
  pop af
  ; QTY
  or a
  jr z,makerandomstockqty
  cp 1
  jr z,incstockqty
  dec (ix+3)            ; DECREASE STOCK QTY BY 1
  ld a,(ix+3)
  or a                  ; CHECK IF STOCK HAS REACHED 0
  ret nz            
  ld (ix+0),0
  ld (ix+1),0           ; REMOVE EMPTY STOCK ITEM
  ld (ix+2),0
ret  
incstockqty:
  inc (ix+3)              ; INCREASE STOCK QTY BY 1
ret
makerandomstockqty:
  ; GET RANDOM QTY
  ld b,15
  call rand32
  inc a                 ; DON'T ALLOW 0 QTY STOCK
  ld (ix+3),a
ret

; FIND EMPTY SLOT TO FILL UP INVENTORY
; OUTPUTS
; HL = INVENTORY SLOT TO WRITE TO

movenextslot:
  push bc
  ld bc,4
  add ix,bc
  pop bc
ret

; FIND IF SHOP HAS CERTAIN ITEM IN STOCK
; INPUTS
; B = SHOP ITEM TO CHECK
; OUTPUTS
; A = QTY OR 0 IF NOT IN STOCK
findshopqty:
   ld ix,shopinventory
   ; CHECK IF SHOP ALREADY HAS SLOT FOR THIS ITEM FIRST
   findinvloop5:
     ld a,(ix+0)
     cp 255
     jp z,returnfalse ; END OF LIST

     ; CHECK MATCHING BLOCK ID
     ld a,(currblockid)
     cp (ix+0)
     jr nz,donextinvitem2
     ; CHECK MATCHING SCREEN ID
     ld a,(currscreenid)
     cp (ix+1)
     jr nz,donextinvitem2
     ; CHECK MATCHING ITEM ID
     ld a,b;(shopinvitem-1)
     cp (ix+2)  
     jr nz,donextinvitem2
     ; RETURN QTY
     ld a,(ix+3) 
     ret

     donextinvitem2:
       call movenextslot
   jr findinvloop5
  
findnextemptyinvslot:
   ; CHECK IF SHOP ALREADY HAS SLOT FOR THIS ITEM FIRST
   ld a,(shopinvitem-1)
   ld b,a
   call findshopqty
   or a              ; WILL BE 0 IF NOT IN STOCK
   ret nz

   ; IF ITEM IS UNIQUE CHECK IF BLANK SLOT EXISTS
   checkblankslot:
   ld ix,shopinventory
   findinvloop2:
     ld a,(ix+0)
     cp 255
     jr z,checkoverwrite ; END OF LIST
     or a                ; CHECK FOR EMPTY BLOCK
     ret z
     call movenextslot
   jr findinvloop2
    
   ; NO BLANK SLOTS, OVERWRITE EXISTING SLOT
   checkoverwrite:
   ld ix,shopinventory
   findinvloop3:
     ld a,(ix+0)
     cp 255
     jr z,overwritefirstinlist
     ; CHECK MATCHING BLOCK ID
     ld a,(currblockid)
     cp (ix+0)
     ret nz
     ; CHECK MATCHING SCREEN ID
     ld a,(currscreenid)
     cp (ix+1)
     ret nz
     ; SLOT NOT YET FOUND
     call movenextslot
   jr findinvloop3

; WE CAN'T FIND A SUITABLE SLOT
; JUST OVERWRITE FIRST ONE IN LIST THAT DOESN'T MATCH OUR ID
; SHOULD NEVER THEORETICALLY HAPPEN ANYWAY UNLESS PLAYER VISITS
; FOUR DIFFERENT SHOPS
overwritefirstinlist:
  ld ix,shopinventory
  clearoldshopstockloop:
    ld a,(ix+0)
    cp 255
    jr z,gettopstockslot
    ld a,(currblockid)
    cp (ix+0)
    ret nz
    ld a,(currscreenid)
    cp (ix+1)
    ret nz
    call movenextslot
  jr clearoldshopstockloop

gettopstockslot:
  ld ix,shopinventory
ret
; RETURN FIRST STOCK SLOT AS ALL OUR SLOTS ARE FROM SAME SCREEN!?!?
; NEVERY GOING TO HAPPEN, BUT STILL

askyesnoplayer:
  call statusbarprintparagraph
  call checknokeyspressed ; PAUSE TO MAKE SURE PLAYER ISN'T HOLDING DOWN KEYS
  call waityesno
  cp "n"
ret

; SHOP KEEPER BUY AND SELL ROUTINE
speaktoshopkeeper:
  call generateshopinv ; GENERATE SHOP STOCK IF WE NEED TO
  ld hl,str_shopkeeperhello
  call askyesnoplayer
  jp z,shopkeeperbuying

  call createshopinvdisplay ; RECORD INVENTORY LOOKUPS BASED ON KEY PRESSES
  call printshopinvdisplay
  call waitoption_1_2_3_4_5b
  ; PLAYER HAS PRESSED KEY - GIVE STOCK BREAKDOWN
  jp checkshopinventory

; RECORD NUMBER OF ITEM PLAYER IS LOOKING AT
itempick:
  defb 0
; CHECK ITEM DETAILS 
; INPUTS
; A = "1","2","3",etc
checkshopinventory:
  sub "1" ; CONVERT TO ORDINARY LOOKUP NUMBER STARTING AT 0
  ld (itempick),a
  ; GET LOOKUP TO ITEM INTO DE AND SWITCH TO HL
  call shopdisplaypick
  ; SKIP BLOCK ID AND SCREEN ID
  inc hl
  inc hl
  ; GET OBJECT ID IN DE
  ld b,(hl) 
  push hl
  call getrandobjectstr
  pop hl
  inc hl
  ; GET QTY
  ld a,(hl)
  ld (shopitemqty-1),a
  ; GET PRICE
  call makecurritemprice
  ld (shopitemprice-1),a

  ld hl,str_shopkeeperinstock
  call askyesnoplayer
  jp z,shopkeepergoodbye
  jp buyitem

; INPUTS
; A  = SHOP ITEM ID
; OUTPUTS
; HL = LOOKUP TO GLOBAL SHOP INVENTORY ITEM 
shopdisplaypick:
  ld hl,shopitemdisplaylist
  ; GET LOOKUP TO ITEM INTO DE AND SWITCH TO HL
  rlca
  ld b,0
  ld c,a
  add hl,bc
  ld d,(hl)
  inc hl
  ld e,(hl)
  ex de,hl
ret

; CURRENT PRICE OF ITEM PLAYER IS INTERESTED IN
;curritemprice:
;  defb 0

; INPUTS
; B = ITEM ID
; OUTPUT
; A = ITEM PRICE
makecurritemprice:
  push hl
  ld hl,basepricesbyitemid
  ld c,b
  ld b,0
  add hl,bc
  ld a,(hl)
  pop hl
  ; INCREASE/DECREASE ITEM PRICE BASED ON QUANTITY AVAILABLE
  push af
  ld a,(shopitemqty-1)
  sub 2
  jr c,qtyrare
  sub 3
  jr c,qtylessrare
  sub 5
  jr c,qtycommon
  ; PLENTY OF THEM
  pop af
  sub 3
  jr c,onedollar           ; DON'T LET PRICE GO BELOW 1
  or a
  jr z,onedollar
ret
qtyrare:
  pop af
  add 5
ret
qtylessrare:
  pop af
  add 3
ret
qtycommon:
  pop af
ret
onedollar:
  pop af
  ld a,1
ret

buyitem:
  ld a,(itempick)
  call shopdisplaypick
  ; GET PRICE
  ld a,(shopitemprice-1)
  ld c,a
  ld b,0
  ; SEE IF PLAYER HAS ENOUGH MONEY
  push hl
  ld hl,(player_cash2)
  sbc hl,bc
  pop hl
  jr c,printnotenoughcash

  ; TRY TO ADD STOCK. DO THIS FIRST IN CASE WE HAVE NO INVENTORY SPACE LEFT
  inc hl
  inc hl
  ld b,(hl)            ; INCREMENT PLAYER STOCK
  ld a,b
  ld (shopinvitem-1),a ; RECORD ITEM ID FOR LATER USE
  push hl
  call addplayerinvrand
  pop hl
  or a               ; NOT ENOUGH SPACE
  jr z,printnotenoughspace

  ; DEDUCT CASH AND ADD ITEM TO PLAYER INVENTORY
  ld a,(shopitemprice-1)
  ld c,a
  ld b,0
  push hl
  ld hl,(player_cash2)
  sbc hl,bc
  ld (player_cash2),hl
  pop hl

  ; DRECREMENT SHOP STOCK
  ld a,2
  call makeshopinv

  call updatestatusbarmoney
  ld hl,str_shopkeeperthanks
  jp statusbarprintparagraph

printnotenoughcash:
  ld hl,str_shopkeeperlowcash
  jp statusbarprintparagraph
printnotenoughspace:
  ld hl,str_shopkeeperlowspace
  jp statusbarprintparagraph

shopkeeperbuying:
  ld hl,str_shopkeeperbuying
  call askyesnoplayer
  jp z,shopkeepergoodbye
  call checkinventoryempty      ; CHECK IF PLAYER HAS SOMETHING TO SELL
  or a
  jr nz,shopkeepernoitems

  call showinventory
  call waitoption_1_2_3_4_5b
  call shopkeepermakeoffer
  call askyesnoplayer
  jr z,shopkeepergoodbye
  ; PLAYER ACCEPTED OFFER

  ; ADD CASH AND DEDUCT ITEM FROM PLAYER INVENTORY
  ld a,(shopitemoffer-1)
  ld c,a
  ld b,0
  ld hl,(player_cash2)
  add hl,bc
  ld (player_cash2),hl

  ; DEC PLAYER STOCK
  ld a,(shopinvitem-1)          
  ld b,a
  call remplayerinvrand

  ; INCREMENT SHOP STOCK
  ld a,1                   
  call makeshopinv

  call updatestatusbarmoney
 
  shopkeepergoodbye:
  call loadrandgoodbye
  jp printstronce

shopkeepernoitems:
  ld hl,str_shopkeepernoitems
  jp printstronce
shopkeepermakeoffer:
  sub "1"                                 ; CONVERT KEYPRESS TO ORDINARY LOOKUP NUMBER STARTING AT 0
  ld hl,player_inventory_rand
  call vectorlookupreturnfirstval
  or a
  jr z,shopkeepergoodbye                  ; RETURN IF NO OBJECT IN INVENTORY SLOT
  ld b,a
  ld (shopinvitem-1),a                    ; RECORD ITEM PLAYER WANTS TO SELL
  call getrandobjectstr                   ; GET OBJECT STRING IN DE
  call findshopqty                        ; GET CURRENT SHOP QTY FOR PRICE
  ld (shopitemqty-1),a
  call makecurritemprice
  ld (shopitemoffer-1),a
  ld hl,str_shopkeeperoffer
ret

; SHOP KEEPER STRINGS
str_shopkeeperhello:    defb 13,welcome,"! ",13,would,13,you,13,liketo,"SEE WHAT I ",13,have,"IN STOCK?",255
str_shopkeeperbuying:   defb "DO ",13,you,13,have,"ANYTHING ",13,you,13,would,13,liketo,"SELL?",255
str_shopkeeperinvent:   defb 1:shopitemkey
                        defb ") ",11,255
str_shopkeeperinstock:  defb "WE ",13,have
                        defb 14,1:shopitemqty
                        defb " ",11," "
                        defb "IN STOCK AT $"
                        defb 14,1:shopitemprice
                        defb " EACH. ",13,would,13,you,13,liketo,"BUY?",255
str_shopkeeperlowcash:  defb 13,comeback,13,when,13,you,13,have,"MORE MONEY",255
str_shopkeeperlowspace: defb "I SEE ",13,your,"HANDS ARE FULL BOY",255
str_shopkeeperthanks:   defb 13,thankyou,"! ",13,comeback,"SOON",255
str_shopkeepernoitems:  defb 13,comeback,13,when,13,you,13,have," SOMETHING FOR ME",255
str_shopkeeperoffer:    defb "HOW ABOUT $"
                        defb 14,1:shopitemoffer
                        defb " FOR 1 ",11,"?",255

; SCAN THROUGH ALL SHOP INVENTORIES AND MOVE THIS SHOPS ITEMS TO TABLE
createshopinvdisplay:
  ; CLEAR SHOP DISPLAY TABLE
  call clearshopinvdisplay
  xor a
  ld (shopitemkeyrecord-1),a
  ld hl,shopinventory
  printshopinvloop:
     ld a,(hl)
     cp 255                 ; END OF LIST
     ret z 
  
     ; CHECK IF INVENTORY ITEM IS FROM THIS SHOP
     ld a,(currblockid)
     cp (hl)
     jr nz,nextshopinv
     inc hl
     ld a,(currscreenid)
     cp (hl)
     jr nz,nextshopinv2

     ; RECORD LOOKUP TO INVENTORY ITEM DATA
     dec hl
     ld a,1:shopitemkeyrecord
     call recordshopinvdisplay
     
     ; REMEMBER ITEM NUMBER
     ld a,(shopitemkeyrecord-1)
     inc a
     ld (shopitemkeyrecord-1),a
     cp 5                       ; DON'T DISPLAY TOO MANY PRODUCTS
     ret z     

     nextshopinv:
       inc hl
     nextshopinv2:
       ld bc,3
       add hl,bc
  jr printshopinvloop

; RECORD THE ITEM LOOKUP BEING DISPLAYED TO THE PLAYER
; INPUTS
; HL = INVENTORY ITEM LOOKUP
; A  = INVENTORY NUMBER
recordshopinvdisplay:
   push hl
   ex de,hl
   ld hl,shopitemdisplaylist
   rlca
   ld c,a
   ld b,0
   add hl,bc ; ADD TWICE AS WE ARE LOOKING UP 16BIT ADDRESS
   ld (hl),d
   inc hl
   ld (hl),e
   pop hl
ret 
   
clearshopinvdisplay:
  ld hl,shopitemdisplaylist
  ld bc,10
  jp clearmem

; SCAN THROUGH DISPLAY TABLE AND CONVERT LOOKUP TO INVENTORY ITEM NAME
printshopinvdisplay:
  ld hl,shopitemdisplaylist
  ld a,"0"
  ld (shopitemkey-1),a
  printshopinvdisplayloop:
    ld a,(hl)
    cp 255         ; END OF LIST
    ret z      
    or a
    jr z,skipblankitem

    push hl

    ; GET LOOKUP IN DE AND SWITCH TO HL
    ld d,(hl)      
    inc hl
    ld e,(hl)
    inc hl
    ex de,hl

    inc hl    ; SKIP BLOCK ID
    inc hl    ; SKIP SCREEN ID

    ; GET OBJECT STRING IN DE
    ld b,(hl)
    call getrandobjectstr  

    ld a,(shopitemkey-1)
    inc a
    ;; GET KEY NUM
    ld (shopitemkey-1),a

    ld hl,str_shopkeeperinvent
    xor a ; DON'T PAGE SCROLL
    call statusbarprintparagraph

    pop hl
    skipblankitem:
    inc hl
    inc hl
  jr printshopinvdisplayloop