; CLEAR GAME MAP DATA
cleargamemap:
  di
  ld (backupsp),sp
  ld sp,endofgamemap
  ld de,0
  ld b,2
  jr loopyloop2

; CLEAR MEMORY USING THE STACK POINTER
; CLEARS 128 BYTES ON EACH PASS
backupsp:
  defw 0
clearsp:
  di
  ld (backupsp),sp
  ld sp,endoftilemaps
  ld de,0
  ld b,6
  loopyloop2:
  push de
  push de
  push de
  push de
  push de
  push de
  push de
  push de
  push de
  push de
  push de
  push de
  push de
  push de
  push de
  push de

  push de
  push de
  push de
  push de
  push de
  push de
  push de
  push de
  push de
  push de
  push de
  push de
  push de
  push de
  push de
  push de

  push de
  push de
  push de
  push de
  push de
  push de
  push de
  push de
  push de
  push de
  push de
  push de
  push de
  push de
  push de
  push de

  push de
  push de
  push de
  push de
  push de
  push de
  push de
  push de
  push de
  push de
  push de
  push de
  push de
  push de
  push de
  push de
  djnz loopyloop2
  ld sp,(backupsp)
  ei
ret

; SPEED UP LDIR BUT ONLY USE ON MULTIPLES OF 16
useLDI79:
  call useLDI60
  call useLDI10
  jr useLDI9

useLDI16:
  call useLDI8
  jr useLDI8

useLDI28:
  call useLDI10
  call useLDI10
  jr useLDI8

useLDI29:
  call useLDI10
  call useLDI10
  jr useLDI9

useLDI199:
  call useLDI60
  call useLDI79

useLDI60:
  call useLDI10
  call useLDI10
  call useLDI10
  call useLDI10
  call useLDI10
  jr useLDI10

useLDI10:
  ldi
useLDI9:
  ldi
useLDI8:
  ldi
  ldi
  ldi
  ldi
  ldi
  ldi
  ldi
  ldi
ret

; LOOKS UP A SPRITE GRAPHIC FROM THE ANIMATION VECTOR TABLE
; BY NUMBER
; INPUTS
; A = IMAGE NUMBER
; RESULTS
; DE = SPRITE DATA
vectorspritelookup:
  push hl
  ld hl,spriteanimtable 
  vlookup:
  call vectorlookup
  pop hl
ret
; LOOKS UP A TILE GRAPHIC FROM THE VECTOR TABLE
; BY NUMBER
; INPUTS
; A = IMAGE NUMBER
; RESULTS
; DE = SPRITE DATA
vectorobjectlookup:
  push hl
  dec a ; MAKE START FROM 0
  dec a
  ld hl,tile_ptr_table 
  jr vlookup

; INPUTS
; A = DOUBLE BUFFER ID IMAGE
vectorbufferlookup:
  push hl
  ld hl,doublebuffertable 
  jr vlookup

; INPUTS
; HL = VECTOR TABLE
; A = IMAGE NUMBER
; RESULTS
; DE = SPRITE DATA
vectorlookup:
  call vectorlookuphl
  ex de,hl   ; COPY SPRITE DATA TO DE
ret

vectorlookupreturnfirstval:
  push bc
  rlca      ; DOUBLE BYTE TO USE LOOKUP TABLE
  ld b,0
  ld c,a
  add hl,bc
  ld a,(hl) ; LOAD HL WITH ADDRESS OF VECTOR TABLE
  pop bc
ret

vectorlookuphl:
  call vectorlookupreturnfirstval
  inc hl
  ld h,(hl)
  ld l,a
ret
; MOVE BASED ON DIRECTION JUMP TABLE
; VECTOR TABLE LAUNCH CODE
; INPUTS 
; A = ID NUMBER
; HL = LOOKUP TABLE
vectortablelaunchcode:
  call vectorlookuphl
  jp (hl)     ; JUMP TO VECTOR TABLE FUNCTION