; DEACTIVATE SPRITE BUFFER ON MOVING SCREEN
; PREVENTS SPRITE BUFFER BEING DRAWN WITH PREVIOUS SCREEN GRAPHICS
deactivatemcpsdoublebuffer:
  ld ix,mcps
  deactivatebufferloop:
    ld a,(ix+0) 
    cp 255 
    ret z
    ld (ix+15),0
    call findnextmcpupdate 
  jr deactivatebufferloop

; DEACTIVATE ANIMATIONS ON MOVING SCREEN
; THEY NEED TO BE REGENERATED ON NEW SCREEN
deactivateanimations:
  ld hl,animtiles
  ld bc,5

  ; DEACTIVATE ALL ITEM FROM LIST
  ; INPUTS
  ; HL = LIST
  ; BC = ITEM SIZE
  deactivateitemlist:
  ld a,(hl)
  ; RETURN IF WE GET TO END OF LIST
  cp 255
  ret z
  ; DEACTIVATE
  ld (hl),0
  add hl,bc
jr deactivateitemlist

; ACTIVATE TILE ANIMATION
; INPUTS 
; B = SPRITE NUMBER IN ANIM VECTOR TABLE
; C = TILE NUM
; D = IS FLIPPED?
activatetileanim:
  ld ix,animtiles
  activatetileanimloop:
  ld a,(ix)
  cp 255  ; FOUND END OF LIST
  ret z
  cp 1    ; ALREADY ACTIVE, TRY NEXT ONE
  jr z,nextanimblock

  ld (ix+0),1 ; MAKE ACTIVE
  ld (ix+1),0 ; SPRITE ANIM OFFSET
  ld (ix+2),b ; SPRITE ID IN TABLE
  ld (ix+3),d ; IS FLIPPED
  ld (ix+4),c ; TILE NUM

  ; MARK AS PHYSICAL OBSTACLE ON OBJECT TILEMAP
  ld hl,tilemap2
  ld l,c
  ld (hl),1
  ret

  nextanimblock:
    push bc
    ld bc,5
    add ix,bc
    pop bc
  jr activatetileanimloop

randommcpstable:
  ; RABBIT
  defb zone_forest         ; ZONE
  defb anim_rabbitleft     ; SPRITE UP
  defb anim_rabbitleft     ; SPRITE DOWN
  defb anim_rabbitleft     ; SPRITE LEFT
  defb 0                   ; MOVEMENT RANDOM
  defb 2                   ; CHAR TYPE ANIMAL
  ; RABBIT
  defb zone_winter         ; NARNIA - ZONE
  defb anim_rabbitleft     ; SPRITE UP
  defb anim_rabbitleft     ; SPRITE DOWN
  defb anim_rabbitleft     ; SPRITE LEFT
  defb 0                   ; MOVEMENT RANDOM
  defb 2                   ; CHAR TYPE ANIMAL
  ; RABBIT
  defb zone_autumn         ; AUTUMN - ZONE
  defb anim_rabbitleft     ; SPRITE UP
  defb anim_rabbitleft     ; SPRITE DOWN
  defb anim_rabbitleft     ; SPRITE LEFT
  defb 0                   ; MOVEMENT RANDOM
  defb 2                   ; CHAR TYPE ANIMAL
  ; TUMBLEWEED
  defb zone_western        ; ZONE
  defb anim_tumbleweed1    ; SPRITE UP
  defb anim_tumbleweed1    ; SPRITE DOWN
  defb anim_tumbleweed1    ; SPRITE LEFT
  defb 0                   ; MOVEMENT RANDOM
  defb 5                   ; CHAR TYPE OBSTRUCTION OBJECT
  ; TUMBLEWEED
  defb zone_westernindian  ; ZONE
  defb anim_tumbleweed1    ; SPRITE UP
  defb anim_tumbleweed1    ; SPRITE DOWN
  defb anim_tumbleweed1    ; SPRITE LEFT
  defb 0                   ; MOVEMENT RANDOM
  defb 5                   ; CHAR TYPE OBSTRUCTION OBJECT

  defb 255 ; END OF LIST

spawnrandommcps:
  ; DON'T SPAWN ANIMALS IF WE ARE IN BUILDING
  ld a,(inbuilding)
  or a;cp 0
  ret nz
  ld ix,mcps
  ld iy,randommcpstable

  nextdef:
    ld a,(iy+0)
    ; RETURN IF WE GET TO END OF LIST
    cp 255
    ret z
    ld a,(currzonedata) ; CHECK IF PLAYER IS IN RIGHT ZONE FOR SPRITE
    cp (iy+0)
    jr nz,nextrndmcp    ; SKIP DEFINITION IF SPRITE IS NOT SUITABLE

    ; FOUND MATCH, MAKE SPRITE IN NEXT EMPTY SPRITE DEF
    nextmcp:
      ld a,(ix+0)
      ; RETURN IF WE GET TO END OF LIST
      cp 255
      ret z
      or a;cp 0 ; CHECK IF SPRITE IS INACTIVE
      jr nz,skipmcp

      ; CLEAR SPRITE BUFFER SO IT DOESN'T TRASH NEW SCREEN
      ld (ix+15),0
      ; CLEAR OBJECT PICKUP ID
      ld (ix+18),0
      ; COPY SPRITE IMAGE DEFINITIONS - UP LEFT DOWN
      ld a,(iy+1)
      ld (ix+1),a     
      ld (ix+10),a       
      ld a,(iy+2)
      ld (ix+11),a       
      ld a,(iy+3)
      ld (ix+12),a      
      ld a,(iy+4)
      ld (ix+24),a     
      ld a,(iy+5)
      ; MAKE ANIMAL SPRITE     
      ld (ix+27),a

      ; SAVE MAP LOCATION
      ld a,(inbuilding)
      ld (ix+3),a
      ld a,(tilemap_cur)
      ld (ix+4),a
      ld a,(tilemap_cury)
      ld (ix+5),a
      ld (ix+9),5            ; SET MOVE COUNTER

      call findunusedspriteid
      cp 0                   ; SPRITE BUFFERS ALL USED
      ret z
      ld (ix+26),c           ; SET SPRITE ID
       
      ; GENERATE RANDOM POSITION
      ld b,scr_width_bytes_right
      call brand20
      ld (ix+6),a
      ld b,scr_height_pixels_bottom
      call rand20
      ld (ix+7),a

      ; ACTIVATE SPRITE
      ld (ix+0),1

      ; MOVE TO NEXT SPRITE DEFINITION
      nextrndmcp:
         ld bc,6
         add iy,bc
      jr nextdef

    skipmcp:
      call findnextmcpupdate
    jr nextmcp

; THIS ROUTINE FINDS AN UNUSED BUFFER FOR THE NEWLY SPAWNED SPRITE TO USE
; OUTPUT
; C = SPRITE ID TO USE
; 255 IF NONE FOUND
findunusedspriteid:
  ld hl,spriteidlist
  ld c,0
  ld b,7
  loopspriteids:
    ld a,(hl)
    or a;cp 0
    jr z,foundunusedspriteid
    inc c
    inc hl
    jr loopspriteids
    
    foundunusedspriteid:
    ld (hl),1 ; MARK ID AS USED
    jp returntrue       ; RETURN
  djnz loopspriteids
jp returnfalse

nextspriteid:
  inc c
  inc hl
jr loopspriteids

; INPUT
; A = SPRITE ID TO CLEAR
clearspriteid:
  cp 1 ; DO NOT CLEAR ARROW SPRITE ID
  ret z
  ld hl,spriteidlist
  ld b,0
  ld c,a
  add hl,bc
  ld (hl),0
ret

; CHECK IF A COMPUTER SPRITE HAS GONE PAST
; ONE SCREEN AWAY FROM PLAYER, IF SO DEACTIVATE IT
checkmcpoutofscope:
  ld a,(tilemap_cur)
  sub (ix+4)
  cp 2   ; CHECK IF SPRITE IS TWO SCREENS AWAY
  jr z,deactivatesprite
  cp 97 ; CHECK IF SPRITE IS TWO SCREENS AWAY
  jr z,deactivatesprite
  ld a,(tilemap_cury)
  sub (ix+5)
  cp 2   ; CHECK IF SPRITE IS TWO SCREENS AWAY
  jr z,deactivatesprite
  cp 97;cp 253 ; CHECK IF SPRITE IS TWO SCREENS AWAY
  jr z,deactivatesprite
ret

; MAKE SURE SCREEN ID DOESNT GO OVER 100
limitmapsizexplus:
  ld a,(ix+4) ; X
  cp 100
  ret nz
  ld (ix+4),0
ret
limitmapsizexminus:
  ld a,(ix+4) ; X
  cp 255
  ret nz
  ld (ix+4),99
ret
limitmapsizeyplus:
  ld a,(ix+5) ; Y
  cp 100
  ret nz
  ld (ix+5),0 ; RESET MAP POS TO 0
ret
limitmapsizeyminus:
  ld a,(ix+5) ; Y
  cp 255
  ret nz
  ld (ix+5),99 ; RESET MAP POS TO 0
ret

; INPUT
; IX = SPRITE BLOCK TO DEACTIVATE
deactivatesprite:
  ld (ix+15),0            ; CLEAR BUFFER
  ld (ix+0),0             ; MARK INACTIVE
  ld a,(ix+26)            ; CLEAR SPRITE ID
  jr clearspriteid

deactivatespriteiy:
  ld (iy+15),0            ; CLEAR BUFFER
  ld (iy+0),0             ; MARK INACTIVE
  ld a,(iy+26)            ; CLEAR SPRITE ID
  jr clearspriteid

movespritenorthwest:
  call movespritenorth
movespritew:
  call movespritewest
  jp jumpback

movespritewest:
  ; MAKE SURE SPRITE IMAGE IS FACING LEFT
  ld (ix+13),0
  ld a,(ix+10)
  ld (ix+1),a

  ld a,(ix+6)      ; GET X PIXEL
  sub 1             ; ARE WE PAST EDGE OF SCREEN   
  jr c,moveleftscreen

  moveleftpix:
    ld d,a           ; GET X PIXEL
    ; DO OBJECT COLLISION DETECTION
    ; IF WE HAVEN'T COLLIDED WITH AN OBJECT, LET PLAYER PROCEED
    ld a,(ix+7)            ; LOAD Y POSITION INTO E
    add 12                 ; MOVE COLLISION DETECTION HALF WAY UP SPRITE 
    ld e,a

    call checkifmovementok
    or a;cp 0
    ret nz                 ; DO NOT ALLOW PLAYER TO MOVE
    dec (ix+6)             ; DEC X PIXEL
    ld (ix+20),1           ; RECORD THAT WE HAVE ACTUALLY MOVED SPRITE
    ret
  
  moveleftscreen:
    dec (ix+4)
    call limitmapsizexminus
    ld (ix+6),scr_width_bytes_right   ; SET X PIXEL TO RIGHT OF SCREEN
    movescreen:
    ld a,(ix+0)       ; CHECK IF MCP OR PLAYER
    cp 2 
    jp z,set_tilemap_view
    
    ; DEACTIVATE MCP SPRITE IF IT GOES PAST TWO SCREENS
    jp checkmcpoutofscope

movespriten:
  call movespritenorth
  jp jumpback

; PLAYER FUNCTIONS JUMP BACK TO DIFFERENT LOCATION
movespritenorthwestp:
  call movespritenorth
movespritewp:
  call movespritewest
  jp updateplayersprite

movespritenp:
  call movespritenorth
  jp updateplayersprite

movespritenorth:
  ; MAKE SURE SPRITE IMAGE IS FACING UP
  ld (ix+13),1
  ld a,(ix+12) ; CHANGE GRAPHIC TO NORTH FACING MAN
  ld (ix+1),a

  ld a,(ix+7)      ; GET Y PIXEL
  sub 4             ; ARE WE PAST EDGE OF SCREEN   
  jr c,moveupscreen

  moveuppix:
    call adjustcollisiondetectiony

    call checkifmovementok
    or a;cp 0
    ret nz              ; DO NOT ALLOW PLAYER TO MOVE
    ld a,(ix+7)      ; GET Y PIXEL
    sub 4
    ld (ix+7),a      ; SET Y PIXEL
    ld (ix+20),1     ; RECORD THAT WE HAVE ACTUALLY MOVED SPRITE
    ret

  moveupscreen:
    dec (ix+5)
    call limitmapsizeyminus
    ld (ix+7),scr_height_pixels_bottom ; SET Y PIXEL TO BOTTOM OF SCREEN
    jr movescreen

movespritenortheast:
  call movespritenorth
movespritee:
  call movespriteeast
  jp jumpback 

checkifmovementok:
  call checktileoccupied        ; CHECK IF OCCUPIED
  call checkmovementok          ; CHECK OBJECT TILEGRID FOR OBSTACLES
  or a;cp 0
  ret nz  ; DO NOT ALLOW PLAYER TO MOVE
  call checkcollisionsprite     ; CHECK IF SPRITES NEARBY
ret

; PLAYER FUNCTIONS JUMP BACK TO DIFFERENT LOCATION
movespritenortheastp:
  call movespritenorth
movespriteep:
  call movespriteeast
  jp updateplayersprite 

movespriteeast:
  ; MAKE SURE SPRITE IMAGE IS FACING RIGHT
  ld (ix+13),1
  ld a,(ix+10)
  ld (ix+1),a

  ld a,(ix+6) ; GET X PIXEL
  add 255-80+5     ; ARE WE PAST EDGE OF SCREEN   
  jr c,moverightscreen

  moverightpix:
    ld a,(ix+6)      ; GET X PIXEL
    add 4            ; MOVE COLLISION DETECTION TO RIGHT SIDE OF SPRITE
    ; DO OBJECT COLLISION DETECTION
    ; IF WE HAVEN'T COLLIDED WITH AN OBJECT, LET PLAYER PROCEED
    ld d,a            ; LOAD X POSITION INTO D
    ld a,(ix+7)                 ; LOAD Y POSITION INTO E
    add 12 ; MOVE COLLISION DETECTION HALF WAY UP SPRITE 
    ld e,a

    call checkifmovementok
    or a;cp 0
    ret nz            ; DO NOT ALLOW PLAYER TO MOVE
    inc (ix+6)      ; INC X PIXEL
    ld (ix+20),1     ; RECORD THAT WE HAVE ACTUALLY MOVED SPRITE
    ret

  moverightscreen:
    inc (ix+4)
    call limitmapsizexplus
    ld (ix+6),0      ; SET X PIXEL TO LEFT OF SCREEN
    jp movescreen
    
movespritesoutheast:
  call movespritesouth
  call movespriteeast
  jp jumpback

movespritesouthwest:
  call movespritesouth
  call movespritewest
  jp jumpback

movesprites:
  call movespritesouth
  jp jumpback

; PLAYER FUNCTIONS JUMP BACK TO DIFFERENT LOCATION
movespritesoutheastp:
  call movespritesouth
  call movespriteeast
  jp updateplayersprite

movespritesouthwestp:
  call movespritesouth
  call movespritewest
  jp updateplayersprite

movespritesp:
  call movespritesouth
  jp updateplayersprite

; INPUT
; A = Y POS OF SPRITE
; OUTPUT
; D = Y POS OF COLLISION DETECTION ON SPRITE
adjustcollisiondetectiony:
  add 12                 ; MOVE COLLISION DETECTION HALF WAY UP SPRITE 
  ld e,a                 ; LOAD Y POSITION INTO E
  ; DO OBJECT COLLISION DETECTION
  ; IF WE HAVEN'T COLLIDED WITH AN OBJECT, LET PLAYER PROCEED
  ld d,(ix+6)            ; LOAD X POSITION INTO D
  inc d                  ; MOVE X COLLISION DETECTION TO MIDDLE OF SPRITE
  inc d
ret

movespritesouth:
  ; MAKE SURE SPRITE IMAGE IS FACING DOWN
  ld (ix+13),0
  ld a,(ix+11)
  ld (ix+1),a

  ld a,(ix+7) ; GET Y PIXEL
  add 80+32   ; ARE WE PAST EDGE OF SCREEN    
  jr c,movedownscreen

  movedownpix:
    ld a,(ix+7)            ; GET Y PIXEL
    add 4
    call adjustcollisiondetectiony

    call checkifmovementok
    or a;cp 0
    ret nz                 ; DO NOT ALLOW PLAYER TO MOVE
    ld a,(ix+7)             ; GET Y PIXEL
    add 4
    ld (ix+7),a             ; SET Y PIXEL
    ld (ix+20),1            ; RECORD THAT WE HAVE ACTUALLY MOVED SPRITE
    ret

  movedownscreen:
    inc (ix+5)
    call limitmapsizeyplus
    ld (ix+7),0      ; SET Y PIXEL TO TOP OF SCREEN
    jp movescreen
    
; INPUTS
; A = TILE OBJECT ID TO CHECK
; OUTPUTS
; A = 0, MOVE OK
; A = 1, MOVE NOT OK
checkmovementok:
  push af
  ld a,(ix+0)
  cp 2                       ; ARE WE A PLAYER OR AN MCP?
  jr z,checkmovementokplayer
  cp 3                       ; ARE WE AN ARROW?
  jr z,checkmovementokarrow

checkmovementokmcp:
    pop af
    or a; cp 0                ; EMPTY SPACE
    ret z
    cp 254                    ; BRIDGE, ETC
    jp z,returnfalse
    cp 246                    ; BRIDGE, ETC FLIPPED
    jp z,returnfalse
    jp returntrue             ; DO NOT ALLOW SPRITE TO MOVE

checkmovementokarrow:
    pop af
    or a;cp 0                 ; EMPTY SPACE
    ret z
    cp 254                    ; BRIDGE, ETC
    jp z,returnfalse
    cp 246                    ; BRIDGE, ETC FLIPPED
    jp z,returnfalse
    cp 2                      ; WATER
    jp z,returnfalse
    jp deactivatesprite       ; WE HIT AN OBJECT, DISABLE ARROW

checkmovementokplayer:
    pop af
    ld (ix+25),0              ; RESET SUBMERGED STATUS
    or a;cp 0                 ; EMPTY SPACE
    ret z
    cp 254                    ; BRIDGE, ETC
    jp z,returnfalse
    cp 246                    ; BRIDGE, ETC FLIPPED
    jp z,returnfalse
    cp 2                      ; WATER
    jr z,setmovementifflipper
    cp 3                      ; MOUNTAIN
    jr z,setmovementifrope
    call questchooser
    jp returntrue             ; QUEST MAY BE LOCKED, DO NOT ALLOW PLAYER TO MOVE THRU SPRITE
    
setmovementifflipper:
  ld a,1:selfmodify_hasnoflippers ; SET TO 0 IF WE HAVE FLIPPERS  
  cp 1                            ; IF WE HAVE NO FLIPPERS...
  ret z
  ld (ix+25),1                    ; RECORD THAT PLAYER IS SUBMERGED
  ret

setmovementifrope:
  ld a,1:selfmodify_hasnorope ; SET TO 0 IF WE HAVE ROPE
  ret ;cp 1                   ; IF WE HAVE NO ROPE...
  ;ret z

; INPUTS
; B = CURR X COORD
; C = CURR Y COORD
; D = DEST X COORD
; E = DEST Y COORD
; OUTPUTS
; A = DIRECTION, 1 = NORTH, 2 = NE
; REACHED DESTINATION
; A = 0

; DIRECTION TABLE
; X DIRECTIONS
; 8 1 2
; 7 0 3
; 6 5 4

; WORK OUT DIRECTION OF TRAVEL FROM TWO SETS OF COORDINATES

updir:   defb 8,1,2
middir:  defb 7,0,3
downdir: defb 6,5,4

getdirectionfromcoords:
  ld a,c
  sub e
  or a;cp 0
  jr z,setmid
  jr c,setup

  setdown:
    ld hl,downdir+1
    jr gethdir
  setup:
    ld hl,updir+1
    jr gethdir
  setmid:
    ld hl,middir+1

  gethdir:
    ld a,b
    sub d
    or a;cp 0
    ret z
    jr c,setright
    
    setleft:
    dec hl
    ld a,(hl)
    ret

    setright:
    inc hl
    ld a,(hl)
    ret

; GET NEW SPRITE DIRECTION - RANDOM SLOW TURNING
getnewspritedirection:
  dec (ix+9)
  ld a,(ix+9)
  or a;cp 0
  jr z,resetmovecounter
  jp finishturnsprite

  resetmovecounter:
  ld (ix+9),5 ; RANDOM MOVE COUNTER
   
  ; CHECK IF WE HAVE A MAP DESTINATION, OTHERWISE MOVE RANDOMLY
  ld a,(ix+24) ; X
  or a;cp 0 ; RANDOM
  jr z,moverandomly
  cp 1 ; MOVE DESTINATION
  jr z,findnewdirection
  cp 2 ; MOVE TO PLAYER
  jr z,findplayerloc
  
  ; MOVE IN STRAIGHT LINE TOWARDS DESTINATION - ARROW
  movestraightline:
  jp finishturnsprite

  ; MOVE TOWARD PLAYER - SET DEST SCREEN TO SAME AS PLAYER
  findplayerloc:
  ld b,(ix+4) ; CURRENT SPRITE X LOCATION
  ld c,(ix+5) ; CURRENT SPRITE Y LOCATION
  push ix
  ld ix,playerspritedata
  ld d,(ix+4) ; COPY PLAYER X SCREEN LOCATION AS DEST
  ld e,(ix+5) ; COPY PLAYER Y SCREEN LOCATION AS DEST
  pop ix
  call getdirectionfromcoords
  or a;cp 0 ; IF WE HAVE REACHED DESTINATION SCREEN, GO TO PLAYER
  jr z,findnewdirectiontilenum
  ld (ix+8),a
  jr finishturnsprite

  ; MOVE TOWARDS SCREEN
  findnewdirection:
  ; LIMIT DIRECTION TO THREE CLOSEST POINTS OF COMPASS TO WHERE WE NEED TO GO
  ld b,(ix+4)    ; X CURR
  ld c,(ix+5)    ; Y CURR
  ld d,(ix+21)   ; X DEST
  ld e,(ix+22)   ; Y DEST
  call getdirectionfromcoords
  or a; cp 0 ; IF WE HAVE REACHED DESTINATION SCREEN, GO FOR TILE NUMBER
  jr z,findnewdirectiontilenum
  ld (ix+8),a
  jr finishturnsprite

  ; IF WE HAVE REACHED SCREEN DESTINATION. HEAD FOR PLAYER TILE
  findnewdirectiontilenum:
  ld b,(ix+6) ; CURRENT X BYTE 
  ld c,(ix+7) ; CURRENT Y LINE
  push ix
  ld ix,playerspritedata
  ld d,(ix+6) ; PLAYER X PIXEL POS
  ld e,(ix+7) ; PLAYER Y PIXEL POS
  pop ix
  call getdirectionfromcoords
  ld (ix+8),a
  jr moverandomlysometimes

  ; A RANDOM JIGGLE STOPS THE CHARACTER GETTING STUCK BEHIND A TREE... SOMETIMES!
  moverandomlysometimes:
  call brand
  sub 160
  jr c, finishturnsprite
  ld b,8
  call rand32
  ld (ix+8),a
  jr finishturnsprite

  moverandomly:
  ; GET DIRECTION OF SPRITE, ROTATE SLOWLY TO MAKE LESS JERKY 
  call brand
  sub 128
  jr c, turnspriteright

  turnspriteleft:
  ld a,(ix+8)
  dec a
  cp 255 ; IF WE HAVE TURNED TOO FAR, DO NOTHING  
  jr z, finishturnsprite
  jr savedirection

  turnspriteright:
  ld a,(ix+8)
  inc a
  cp 9 ; IF WE HAVE TURNED TOO FAR, DO NOTHING  
  jr z, finishturnsprite

  savedirection:
  ld (ix+8),a
  finishturnsprite:
  ; RESET MOVE COUNTER
  ld (ix+14),1      ; SHOW WE NEED TO UPDATE TILE LOCATION AGAIN
  jp movesprite     ; RETURN TO OUR PREVIOUS FUNCTION

updateplayersprite:
  ; LOAD CHARACTER TABLE DATA
  ld ix,playerspritedata
  ;call mc_wait_flyback
  updatethissprite:
  ; SWAP SPRITE NUMBERS FOR WALKING ANIMATION
  ld a,(ix+19)
  inc a
  cp 2
  jr nz,skipanimcounter2
  xor a                  ; RESET ANIM COUNTER
  skipanimcounter2:
  ld (ix+19),a

  ; RESTORE IF WE HAVE BUFFER
  ld a,(ix+15)
  or a;cp 0
  jr z,skiprestorebufferpl
  call restoremybuffer

  skiprestorebufferpl:
  ; GRAB BACKGROUND INTO BUFFER
  jp grabbgdrawsprite

; INPUT
; IX = SPRITE DATA DEFINITION
restoremybuffer:
  ; CHECK IF BUFFER IS OF
  ; RESTORE OLD BACKGROUND FROM DOUBLE BUFFER
  ld (ix+15),0 ; RECORD THAT WE USED DOUBLE BUFFER
  ld a,(ix+26) ; GET SPRITE DOUBLE BUFFER ID IMAGE
  call vectorbufferlookup
  ld h,(ix+16) ; GET X COORD
  ld l,(ix+17) ; GET Y COORD
  jr restorebuff
; IY = SPRITE DATA DEFINITION
restoremybufferiy:
  ; CHECK IF BUFFER IS OF
  ; RESTORE OLD BACKGROUND FROM DOUBLE BUFFER
  ld (iy+15),0 ; RECORD THAT WE USED DOUBLE BUFFER
  ld a,(iy+26) ; GET SPRITE DOUBLE BUFFER ID IMAGE
  call vectorbufferlookup
  ld h,(iy+16) ; GET X COORD
  ld l,(iy+17) ; GET Y COORD
  restorebuff:
  call get_scr_addr
  call tile_restore
ret
; IX = SPRITE DATA DEFINITION
;restoremybufferdeactivatesprite:
;  ld (ix+0),0
;  call restoremybuffer
;  jp nextmcpupdate
; ON MOVING SCREENS, WE WANT TO SET ALL SPRITES TO REDRAW THEIR POSITIONS
markallcharacterspritesredraw:
  ld ix,mcps
  updatecharloop2:
  ld a,(ix)
  cp 255; CHECK IF END OF LIST
  ret z
  or a;cp 0; CHECK IF ACTIVE
  jr z, nextmcpupdate2
  cp 2; PLAYER SPRITE - SKIP IT !!! JUST DEACTIVATED, ERASE SPRITE FROM SCREEN
  jr z,nextmcpupdate2

  ld (ix+20),1 ; MARK SPRITE HAS HAVING MOVED SO IT NEEDS TO BE REDRAWN
  
  nextmcpupdate2:
    call findnextmcpupdate
  jp updatecharloop2

findnextmcpupdate:
  ld bc,28
  add ix,bc
ret

; INPUTS
; IX = SPRITE DATA TABLE TO UPDATE
updatecharactersprites:
  ;call mc_wait_flyback
  updatecharloop:
  ld a,(ix)
  or a;cp 0; CHECK IF ACTIVE
  jr z, nextmcpupdate
  cp 255; CHECK IF END OF LIST
  ret z
  cp 2; PLAYER SPRITE - SKIP IT !!! JUST DEACTIVATED, ERASE SPRITE FROM SCREEN
  jr z,nextmcpupdate

  ; ONLY UPDATE IF WE HAVE ACTUALLY MOVED
  ld a,(ix+20)
  or a;cp 0
  jr z,updatespritepos ; IF WE HAVEN'T MOVED THEN CALL MOVE ROUTINE

  call updatethissprite

  updatespritepos:
    ld (ix+20),0 ; RESET MOVE SWITCH
    jp getnewspritedirection
 
  jumpback:

  nextmcpupdate:
    call findnextmcpupdate
  jp updatecharloop

; INPUT
; IX = SPRITE DEFINITION
grabbgdrawsprite:
  ; DO NOT DRAW IF SPRITE IS NOT IN SCREEN
  ld a,(inbuilding)
  cp (ix+3)
  ret nz
  ld a,(tilemap_cur)
  cp (ix+4)
  ret nz
  ld a,(tilemap_cury)
  cp (ix+5)
  ret nz
  ; GRAB BACKGROUND INTO BUFFER
  ld a,(ix+26) ; GET SPRITE DOUBLE BUFFER ID IMAGE
  call vectorbufferlookup
  ld h,(ix+6) ; GET X COORD
  ld l,(ix+7) ; GET Y COORD
  ; RECORD PREVIOUS SPRITE COORDINATES
  ld (ix+16),h
  ld (ix+17),l
  call get_scr_addr
  push hl ; BACK UP COORDS
  call tile_grab
  ld (ix+15),1 ; RECORD THAT WE STORED DOUBLE BUFFER

  ; IF WE ARE PICKUPABLE OBJECT, DRAW THAT INSTEAD
  ; IF NOT, DRAW ANIMATION IMAGES
  ld a,(ix+18)
  cp 0
  jr nz,skipanimobject

  ; GET SPRITE IMAGE TO USE FOR ANIMATION
  ; THIS USES A LOOKUP TABLE
  ; A = SPRITE NUMBER
  ld a,(ix+1) ; GET SPRITE IMAGE
  add (ix+19) ; ADD SPRITE ANIMATION COUNTER OFFSET

  call vectorspritelookup

  finishdrawobject:
  ; DRAW SPRITE ON SCREEN
  pop hl ; RESTORE COORDS
  ld a,(ix+13) ; CHECK IF SPRITE IS FLIPPED
  or a;cp 0
  jr z,dontflipsprite

  ld a,(ix+25)              ; CHECK IF SUBMERGED
  cp 1
  jr z,doflipsub
  call tile_draw_flip
  jr finisheddrawingsprite:
  doflipsub: 
  call tile_draw_flip_submerged
  jr finisheddrawingsprite

  dontflipsprite: 
  ld a,(ix+25)              ; CHECK IF SUBMERGED
  cp 1
  jr z,dosub
  call tile_draw
  jr finisheddrawingsprite:
  dosub: 
  call tile_draw_submerged

  finisheddrawingsprite:
  ; CHECK IF WE NEED TO RESTORE TREE TOPS
  ; PLAYER SPACE
  ld d,(ix+6) ; GET X COORD
  ld e,(ix+7) ; GET Y COORD
  jr checkredrawsingletile

skipanimobject:
  call vectorobjectlookup
  jr finishdrawobject

; INPUTS
; D = X COORD
; E = Y COORD
checkredrawsingletile:
  ; FIND TILE WE ARE OCCUPYING (ADJUST Y COLLISION DETECTION TO HEAD)
  ld a,e
  add 12
  ld e,a
  call convpixeltotile
  ld hl,tilemap1
  ld b,0
  ld c,a
  add hl,bc
 
  ; CHECK IF IT HOLDS CONTENT
  ; DO THREE TILES, ONE ON EACH SIDE OF SPRITE
  ;dec l
  push hl
  call checkifredrawtreetops
  pop hl
  dec l 
  ld a,l  ; MAKE SURE WE DON'T UPDATE PAST TOP LEFT CORNER OF SCREEN
  or a;cp 0
  ret z
  push hl 
  call checkifredrawtreetops
  pop hl
  inc l
  inc l
  ld a,l  ; MAKE SURE WE DON'T UPDATE PAST BOTTOM RIGHT CORNER OF SCREEN
  cp 201
  ret z
  jp checkifredrawtreetops

; REDRAW SINGLE TILE BELOW PLAYER
; INPUTS 
; HL = POINTER TO OBJECT TILEMAP TILE
checkifredrawtreetops:
  ld a,(hl)
  or a;cp 0
  ret z
  
  ; INPUTS
  ; A = TILE MAP TILE CONTENT
  ; HL = TILE MAP NUMBER
  redrawsingletile:
  push af ; SAVE TILE CONTENTS DATA
  call gettilepixelpos
  call get_scr_addr
  pop af ; RESTORE TILE CONTENTS DATA
  ld de,tile_ptr_table

  ; FLIP TILE IF IT IS OVER 200
  ; SUBTRACT 200 TO GET TILE GRAPHIC TO FLIP
  sub 201
  jr c,spritenotflipped3:
  call get_tile_ptr    ;; lookup ptr to tile pixels
  jp tile_draw_flip    ;; now draw tile    

  spritenotflipped3:
  add 200
  call get_tile_ptr ;; lookup ptr to tile pixels
  jp tile_draw    ;; now draw tile  

; INPUT 
; A = TILE MAP TILE CONTENT
; HL = TILE MAP NUMBER
redrawsingletile_notrans:
  push af ; SAVE TILE CONTENTS DATA
  call gettilepixelpos
  call get_scr_addr
  pop af ; RESTORE TILE CONTENTS DATA
  or a;cp 0 ; IF TILE IS EMPTY, JUST CLEAR IT AS WE HAVE NO SPRITE DATA FOR EMPTY
  jr z,docleartile
  ld de,tile_ptr_table
  call get_tile_ptr    ;; lookup ptr to tile pixels
  jp tile_restore    ;; now draw tile  

docleartile:
  xor a ;ld a,&00 ; SET BACKGROUND COLOUR
  jp ClearTile
; INPUT
; A = TILE NUMBER
; OUTPUT
; D = X COORD
; E = Y COORD
convtilenumtocoord:
  ld e,255
  loop1:
    sub tilemap_width_tiles
    inc e
  jr nc,loop1
  add tilemap_width_tiles
  ; GET X TILE POS
  ld d,a
ret

; CONVERT X / Y COORD TO TILE NUMBER
; INPUTS 
; C = X COORD
; B = Y COORD
; RESULT
; A = TILE NUMBER
convxytotilenum:
  ; CONVERT VERT TILE ROW TO TILE ID
  ld hl,tilemapwidthtilesdata
  push bc
  ld c,b
  ld b,0
  dec c
  add hl,bc
  ld a,(hl) ; VERT POS IN A
  pop bc
  add c     ; ADD X COORD
ret

; INPUTS 
; L = TILE NUMBER
; OUTPUT
; H = X BYTE POS
; L = Y LINE POS
gettilepixelpos:
  ; CONVERT TILE NUMBER TO X / Y TILE NUMBER
  ; D = X TILES, E = Y TILES
  ld a,l
  call convtilenumtocoord

  ; D = X TILE NUM
  ; E = Y TILE NUM
  ld hl,tiletabley
  ld l,e
  ld e,(hl)

  ld hl,tiletablex
  ld l,d
  ld d,(hl)

  ex de,hl
ret

; INPUTS 
; HL = JUMP TABLE TO USE
movespritep:
  ld hl,directionjumptableplayer
  ; A = DIRECTION TO MOVE
  ; GENERATED BY JOYSTICK FUNCTION
  jp vectortablelaunchcode

movesprite:
  ld hl,directionjumptable
  ; GET DIRECTION TO MOVE FROM MCP SPRITE DATA
  ld a,(ix+8) 
  jp vectortablelaunchcode

; PLAYER VECTOR TABLE JUMPS BACK TO JOYSTICK CONTROL FUNCTION INSTEAD
; OF MCP DIRECTION CONTROL FUNCTION
directionjumptable:
  defw jumpback             ; COUNTER IS 0 - DO NOTHING
  defw movespriten           ; COUNTER IS 1...
  defw movespritenortheast
  defw movespritee
  defw movespritesoutheast
  defw movesprites
  defw movespritesouthwest
  defw movespritew
  defw movespritenorthwest

; PLAYER VECTOR TABLE JUMPS BACK TO JOYSTICK CONTROL FUNCTION INSTEAD
; OF MCP DIRECTION CONTROL FUNCTION
directionjumptableplayer:
  defw updateplayersprite     ; COUNTER IS 0 - DO NOTHING
  defw movespritenp           ; COUNTER IS 1...
  defw movespritenortheastp
  defw movespriteep
  defw movespritesoutheastp
  defw movespritesp
  defw movespritesouthwestp
  defw movespritewp
  defw movespritenorthwestp
  
; INPUTS
; D = X BYTE
; E = Y LINE
; RESULT
; A = TILE NUMBER
tilemapwidthtilesdata:
  defb 0,20,40,60,80,100,120,140,160,180,200

convpixeltotile:
  ; DIVIDE WIDTH BY 4 (BYTES)
  ; DIVIDE HEIGHT BY 16 (LINES)
 
  ; CONVERT VERT LINE POSITION TO TILE ROW
  push bc
  ld hl,tilecalcvert
  ld l,e
  ld b,0
  ld c,(hl)

  ; CONVERT VERT TILE ROW TO TILE ID
  ld hl,tilemapwidthtilesdata
  add hl,bc
  ld c,(hl) ; VERT POS IN C

  ; HORIZ
  ld hl,tilecalchoriz
  ld l,d
  ; GET HORIZ POS FIRST
  ld a,(hl)
  add c     ; ADD VERT POS
  pop bc
ret
; INPUTS
; D = X BYTE
; E = Y LINE
; RESULTS
; A = CONTENTS OF OCCUPIED TILE (OBJECT TILEMAP ID)
; B = CONTENTS OF OCCUPIED TILE (GRAPHIC TILEMAP ID)
; C = CURRENT TILE NUMBER

; 0BJECT TYPES
; 0 - EMPTY SPACE
; 255 - ENTER LOG CABIN
; 254 - TRAVERSABLE PART OF SPRITE
; 253 - ENTER MINE
; 252 - EXIT BUILDING
; 251 - ENTER WESTERN ZONE
; 250 - PICK UP OBJECT
; 249 - RANDOM QUEST
; 248 - ENTER WIG WAM
; 247 - ENTER STONE BUILDING
; 246 - VERTICALLY FLIPPED SPRITE OBJECT
checktileoccupied:
  call convpixeltotile   ; GET TILE NUMBER FROM COORDS D E
  ld c,a                 ; RETURN CURRENT TILE NUMBER

  ld hl,tilemap0
  ld l,a
  ld b,(hl)

  ld hl,tilemap2
  ld l,a
  ld a,(hl)
ret