statusbar_iconpos equ &F6E4

genscreenname:
  ; X COORD
  ld a,(tilemap_cur)
  call convbytetostr
  ld hl,bytetostring
  ld de,tilemap_name
  ldi
  ldi 
  ldi
  ; PERIOD
  ld a,":"
  ld (de),a
  inc de
  ; Y COORD
  ld a,(tilemap_cury)
  call convbytetostr
  ld hl,bytetostring
  ldi
  ldi
  ldi
ret

wordtostr:
  defb "00000"

; CONVERT A 16 BIT HEX TO STRING
; INPUTS
; HL = NUMBER TO CONVERT
convwordtostr:
  ld bc,10000
  call convwordtostrloop
  ld (wordtostr+0),a  ; SAVE RESULT IN STRING
  ld bc,1000
  call convwordtostrloop
  ld (wordtostr+1),a  ; SAVE RESULT IN STRING
  ld bc,100
  call convwordtostrloop
  ld (wordtostr+2),a  ; SAVE RESULT IN STRING
  ld bc,10
  call convwordtostrloop
  ld (wordtostr+3),a  ; SAVE RESULT IN STRING
  ld a,l
  add 48
  ld (wordtostr+4),a  ; SAVE RESULT IN STRING
ret

convwordtostrloop:
  xor a      ; RESET COUNTER
  convwordtostrloop2:
    sbc hl,bc
    inc a
  jr nc,convwordtostrloop2
  add hl,bc
  dec a
  add 48               ; CONVERT TO ASCII
ret

; VARIOUS FUNCTIONS
; CONVERT TENS AND HUNDREDS INTEGER OF BYTE TO STRING
; INPUTS
; C = AMOUNT TO CHECK, EITHER 10 OR 100
convbytetenshundreds:
  ld b,255
  hundredsloop:
    sub c
    inc b
  jr nc,hundredsloop
  add c
  ; WRITE TO MEMORY / ADD 48 TO CONVERT FROM DECIMAL TO CHAR
  ld d,a
  ld a,b
  add 48
  ld (hl),a
  inc hl
  ld a,d
ret
; CONVERT BYTE TO INTEGER STRING
; A = BYTE TO CONVERT
; RESULT LOADED INTO BYTETOSTRING

convbytetostr:
  push hl
  push de ; BACK UP D
  ld hl,bytetostring

  ; HUNDREDS
  ld c,100
  call convbytetenshundreds
  ld c,10
  call convbytetenshundreds

  ; SINGLES
  add 48
  ld (hl),a  

  pop de
  pop hl
ret

; CONVERT 001 TO 1 FOR SHOP PRICES
raligncoord:
  ld hl,bytetostring
  ld a,(hl)
  cp "0"
  ret nz
  inc hl
  ld a,(hl)
  cp "0"
  jr z,justsingles
  dec hl
  ld (hl),a
  ld a,(bytetostring+2)
  inc hl
  ld (hl),a
  inc hl
  ld (hl),255
ret

justsingles:
  inc hl
  ld a,(hl)
  dec hl
  dec hl
  ld (hl),a
  inc hl
  ld (hl),255
ret

bytetostring:
  defb "000"

; UPDATE STATUS BAR ICON INVENTORY
; INPUTS
; B = TILEMAP NUMBER OF ICON TO DISPLAY
updatestatusbaricon:
  ; CLEAR AREA FIRST
  call clearstatusbaricon
  push hl
  push bc ; BACKUP B
  ; DRAW ICON WE PICKED UP
  ld a,b
  ld de,tile_ptr_table
  dec a ; MAKE TILES START FROM 1
  ;dec a
  call get_tile_ptr    ;; lookup ptr to tile pixels
  ld hl,statusbar_iconpos
  call tile_draw    ;; now draw tile  
  pop bc
  pop hl
ret

genmoneystring:
  ; X COORD
  ld hl,(player_cash2)
  call convwordtostr
  ld hl,wordtostr
  
  ld a,"0"
  ld (tilemap_name3+1),a
  ld de,tilemap_name3+2 ; SKIP DOLLAR SIGN
  ldi
  ldi
  ldi
  ldi
  ldi
ret

; DRAW HORIZONTAL LINE ALL WAY ACROSS SCREEN
; INPUTS
; A = LINE COLOUR
; A PRESERVED
DrawHorizLine:
  push af
  push hl
  ld (hl),a ; LINE COL
  push hl ; COPY HL TO DE
  pop de 
  inc de
  call useLDI79
  pop hl
  call scr_next_line_hl
  pop af
ret

ClearStatusBar:
  ld hl,screenadr+1600
  ld a,&0C
  call DrawHorizLine
  ld a,&30 ; RED LINE
  call DrawHorizLine
  ld a,&68 ; YELLOW LINE
  call DrawHorizLine
  ld b,36
  loopylooa:
    push bc
    ld a,&C0 ; WHITE LINE
    call DrawHorizLine
    pop bc
  djnz loopylooa
  ld a,&30 ; RED
  call DrawHorizLine
ret

drawstatusbar:
  ld hl,screenadr+1600
  ld de,scrollleft2
  call tile_restore_scroll
  ld hl,screenadr+1600+80-4
  ld de,scrollright
  call tile_restore_scroll
ret

updatestatusbar:
  ld hl,screenadr+1600+80+4
  push de
  ld de,tilemap_name
  call gra_wr_string2
  pop de
updatestatusbarmoney:
  call genmoneystring
  ld hl,screenadr+1600+160+4
  push de
  ld de,tilemap_name3
  call gra_wr_string2
  ;call updatestatusbartime
  pop de
ret

updatestatusbartext:
  ld hl,screenadr+1600+320+20
  push de
  ld de,screentext4
  call gra_wr_string2
  pop de
ret

statusbarscrollnewline:
  push de
  push hl
  push bc

  call updatestatusbartext

  ld de,topstatusbarline     ; TOP STRING
  ld hl,secondstatusbarline  ; BOTTOM STRING
  ld b,24                    ; ROWS OF PIXELS TO COPY
  loopyman: 
    push bc ; PRESERVE COUNT

    push hl
    push de
    call useLDI28
    call useLDI28
    pop de
    pop hl
    call scr_next_line_hl
    ex de,hl
    call scr_next_line_hl
    ex de,hl

    pop bc
  djnz loopyman
  call clearnewline        ; ERASE STATUS BAR STRING WITH SPACES
  call updatestatusbartext ; DRAW SPACES ON SCREEN IN CASE NEXT LINE DOES NOT REACH TO END, I.E WORDWRAPPED
  pop bc
  pop hl
  pop de
ret

underlinenewline:
  ld a,"-"
  jr fillnewline
clearnewline:
  ld a," "
fillnewline:
  ; CLEAR NEW LINE
  ld hl,screentext4
  ld (hl),a
  ld de,screentext4+1
  call useLDI29
  dec de
  ex de,hl
  ld (hl),255
  ex de,hl
ret

; WRITE STRING TO BUFFER screentext4
; INPUTS
; HL = LINE OF TEXT TO PRINT
; DE = OBJECT TEXT TO INSERT IN PLACE OF CHAR 11
; A = 1, DO PAGE SCROLL
str_backup_ptr:
  defw 0

; SCROLL ANY NEW CHARACTER SPEECHES TO TOP OF PAGE. THIS CLEARS
; THE PAGE OF ANY OLD INFORMATION, MAKES IT LOOK LESS CLUTTERED
scrolltopofpage:
  ld a,(linecount)
  scrollpageloop:
     cp 4
     ret z
     inc a
     push af
     call statusbarscrollnewline
     pop af
  jr scrollpageloop
ret

; IF WE REACH 5 LINES, ASK FOR SPACE TO CONTINUE PRINTING
linecount:
  defb 0
dopagescroll:
  defb 0
spacecountde:
  defw 0
spacecounthl:
  defw 0

statusbarprintparagraph:
  ld (dopagescroll),a
  push bc
  ld (str_backup_ptr),de ; BACKUP INSERT TEXT (OBJECT STR)

  ; RESET LINE COUNT
  ld a,0
  ld (linecount),a

  statusbarprintpara:
  call statusbarscrollnewline
  ld de,screentext4
  ld (spacecounthl),hl   ; RESET LAST SPACE POS
  ld (spacecountde),de   ; RESET LAST SPACE POS

  printloop:
    ld a,(hl)
    cp 255 ; WE MUST ALWAYS END BEFORE 28 CHARS
    jp z,finishtextprint
    cp " "; RECORD SPACE POS
    jr z,recordlastspace
    cp 10 ; MAKE NEW LINE
    jr z,makenewline
    cp 11 ; PRINT OBJECT TEXT
    jr z,printobjecttext
    cp 12 ; PRINT UNDERLINE
    jr z,makeunderline
    cp 13 ; PRINT DICTIONARY WORD
    jr z,printdictionaryword
    cp 14 ; PRINT COORDS (STORED IN xcoord and ycoord)
    jr z,printcoord
    ; COPY CHAR
    printloopjustcopychar:
    ldi
  jr printloop
  
  ; MAKE NEW LINE
  makenewline:
    inc hl
    ; INCREMENT LINE COUNT
    ld a,(linecount)
    inc a
    ld (linecount),a
    ; CHECK IF WE HAVE RUN OUT OF SPACE
    call checkreachedendofpage
    jr statusbarprintpara

  checkbufferoverrun:
    push hl
    push de
    ld hl,screentext4
    sbc hl,de               ; SUB SCREENTEXT 4 FROM DE 4 TO GET CURRENT LENGTH OF STRING (NEGATIVE)
    ld a,l                  ; LOAD RESULT IN A
    pop de
    pop hl
    sub 255-27              ; IF OVER 28, GO BACK TO LAST SPACE COUNT
    ret              

  recordlastspace:
    call checkbufferoverrun
    jr c,recoverlastspace
    ld (spacecounthl),hl    ; ELSE SAVE CURRENT SPACE POSITION
    ld (spacecountde),de  
    jr printloopjustcopychar
 
  recoverlastspace:
    ld hl,(spacecounthl)    ; LOAD LAST SPACE POSITION
    ld de,(spacecountde)
    ex de,hl
    ld (hl),255             ; MARK AS EOL
    ex de,hl
    jr makenewline    

  makeunderline:
    inc hl
    push hl
    call underlinenewline
    pop hl
    jr printloop

  ; PRINT OBJECT TEXT
  ; INSERT TEXT INTO STRING
  ; HL = TEXT TO INSERT (ENDING IN 255)
  ; DE = MAIN STRING TO INSERT INTO
  printobjecttext:
    inc hl
    push hl ; BACK UP MAIN STRING PTR
    ld hl,(str_backup_ptr)
    printstr:
    call copystr
    pop hl
    call checkbufferoverrun
    jr c,recoverlastspace
    jr printloop
  
  printdictionaryword:
    ; DE = SCREENTEXT4
    inc hl
    ld a,(hl)           ; GET NUMBER OF WORD TO INSERT
    inc hl
    push hl             ; STORE POS IN STRING TO READ FROM
    ld hl,dictionary
    call vectorlookuphl ; GET WORD INTO HL
    jr printstr

  printcoord:
    ; DE = SCREENTEXT4
    inc hl
    ld a,(hl)           ; GET NUMBER OF WORD TO INSERT
    inc hl
    push hl             ; STORE POS IN STRING TO READ FROM
    call convbytetostr
    call raligncoord
    ld hl,bytetostring
    jr printstr

  finishtextprint:
    call checkbufferoverrun  ; WE NEED TO CHECK IF WE ARE THE LAST WORD IN THE TEXT AND HAVE OVERRUN
    jr c,recoverlastspace    ; IN WHICH CASE WORD WRAP WON'T HAVE BEEN TRIGGERED AS WE HAVE NO SPACES LEFT.
    call updatestatusbartext
    pop bc
    ld a,(dopagescroll)
    cp 0
    ret z
    call scrolltopofpage
    ret

; INPUTS
; A = CURRENT LINE COUNT
checkreachedendofpage:
   cp 5
   ret nz
   ; RESET LINE COUNT
   ld a,0
   ld (linecount),a
   push hl ; BACK UP POSITION IN ORIGINAL STRING
   push de ; BACK UP OBJECT WORD
   ; SHOW PRESS SPACE TEXT
   call waitspace
   pop de ; RESTORE OBJECT WORD
   pop hl ; RESTORE POSITION IN ORIGINAL STRING
   ret

space_iconpos equ &F6E4+40+40

yesno_text:
   defb "(Y/N)",255
space_text:
   defb "(SPC)",255
clear_text:
   defb "      ",255

clearstatusbaricon:
   push hl
   push af
   ; CLEAR STATUS BAR OBJECT AREA
   ld hl,statusbar_iconpos
   ld a,&C0
   call ClearTile
   pop af
   pop hl
ret
clearstatusbarinput:
   push hl
   push de
   ; CLEAR STATUS BAR OBJECT AREA
   ld hl,space_iconpos
   ld de,clear_text
   call gra_wr_string2
   pop de
   pop hl
ret

waitspace:
   call clearstatusbaricon
   ld hl,space_iconpos
   ld de,space_text
   call gra_wr_string2
   ; WAIT FOR PLAYER TO PRESS SPACE
   call waitoption_spacebar 
   call clearstatusbarinput
   ret

waityesno:
   ; CLEAR STATUS BAR OBJECT AREA
   call clearstatusbaricon
   ld hl,space_iconpos
   ld de,yesno_text
   call gra_wr_string2
   ; WAIT FOR PLAYER TO PRESS Y OR NO
   call waitoption_yes_no
   call clearstatusbarinput
   ret